//*****************************************************************************
//*
//*
//*		HeightDlg.cpp
//*
//*
//*****************************************************************************
#include	"StdAfx.h"
#include	"OsmViewer.h"
#include	"HeightDlg.h"
#include	"SrtmFunctions.h"
#include	<math.h>

#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif

#define 	 ID_COPY_PIC	0x7159
#define 	 FRAME_LEFT		130
#define 	 FRAME_RIGHT	30
#define 	 FRAME_TOP		20
#define 	 FRAME_BOTTOM	50
#define 	 FRAME_BASE		10


static unsigned char	aFont16[] =
	{
	#include "Image/Fonts/Arial16.h"
	};


BEGIN_MESSAGE_MAP(CHeightDlg,CDialog)
	//{{AFX_MSG_MAP(CHeightDlg)
	ON_WM_DESTROY()
	ON_WM_CONTEXTMENU()
	ON_COMMAND(ID_COPY_PIC,OnCopyPic)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

DLG_OLDPOS(CHeightDlg)



//*****************************************************************************
//*
//*		CDialog
//*
//*****************************************************************************
//  Dialogfeld CHeightDlg
CHeightDlg::CHeightDlg(CWnd *pParent): CDialog(CHeightDlg::IDD,pParent)
{
	//{{AFX_DATA_INIT(CHeightDlg)
	//}}AFX_DATA_INIT
}

//*****************************************************************************
//*
//*		OnDestroy
//*
//*****************************************************************************
void CHeightDlg::OnDestroy()
{

	GET_DLG_OLDPOS();

	DeleteObject(m_hBitmap);

	CDialog::OnDestroy();

}

//*****************************************************************************
//*
//*		DoDataExchange
//*
//*****************************************************************************
void CHeightDlg::DoDataExchange(CDataExchange *pDX)
{

	CDialog::DoDataExchange(pDX);

	//{{AFX_DATA_MAP(CHeightDlg)
	//}}AFX_DATA_MAP

}


//*****************************************************************************
//*
//*		OnInitDialog
//*
//*****************************************************************************
BOOL CHeightDlg::OnInitDialog()
{
char		cText[256];
LPCTSTR		pCache;
RouteData  *pRoute;
CStatic	   *pWnd;
double		dMin;
double		dMax;
double		dVal;
double		dNow;
double		dRest;
double		dStep;
double		dLast;
double		dDiff;
double		dFull;
CRect		sRect;
BitmapImage	sTemp;
BitmapImage	sImage;
unsigned	uColor;
int			iCount;
int			iSizeX;
int			iSizeY;
int			iPixel;
int			iPosX;
int			iPosY;
int			iPos;
int			iNum;
int			iVal;


	SET_DLG_OLDPOS();

	SetCursor(IDC_WAIT);


		pCache = SrtmPath();
	if(!pCache || !*pCache)								// Muss die Srtm-LIB initialisiert werden
		{
		SrtmInit();
		}

	pWnd = GetDlgStatic(IDC_FRAME);
	pWnd->GetClientRect(&sRect);

	sImage.SetSize(24,sRect.Width()*2,sRect.Height()*2,BGR(255,255,255));

	iSizeX	= sRect.Width ()*2-FRAME_LEFT-FRAME_RIGHT;
	iSizeY	= sRect.Height()*2-FRAME_TOP -FRAME_BOTTOM;
	iPosY	= sRect.Height()*2-FRAME_BOTTOM;
	iPosX	= FRAME_LEFT;


	m_dLength		= CalcDistance(m_pRoute,m_iCount,0x0E);
	dStep			= 10.0;
	
	for(iNum=0;iNum<5;iNum++)
		{
		if(m_dLength/dStep<15000.0)dStep*=2.0;
		}

	iCount			= ScaleRoute(m_pRoute,m_iCount,&pRoute,dStep);
	m_dMetersUp		= 0;
	m_dMetersDown	= 0;

	   dVal = SrtmGetHeight(pRoute[0].dCoordX,pRoute[0].dCoordY);
	if(dVal>-10000.0)
		{
		pRoute[0].dCoordZ = dVal;
		}

	for(iPos=1;iPos<iCount;iPos++)						// Hhenmeter berechnen
		{
		   dVal = SrtmGetHeight(pRoute[iPos].dCoordX,pRoute[iPos].dCoordY);
		if(dVal>-10000.0)
			{
			pRoute[iPos].dCoordZ = dVal;
			}

		   dDiff = pRoute[iPos].dCoordZ-pRoute[iPos-1].dCoordZ;
		if(dDiff>0.0)
				m_dMetersUp	  += dDiff;
		else	m_dMetersDown -= dDiff;
		}

	delete pRoute;

	iCount	= ScaleRoute(m_pRoute,m_iCount,&pRoute,m_dLength/(double)(iSizeX-3));
	CalcDistance(pRoute,iCount,0x0E);

	dMin = pRoute[0].dCoordZ;
	dMax = pRoute[0].dCoordZ;

	for(iPos=1;iPos<iCount;iPos++)						// Hole die Hhen vom Pfad			
		{
		   dVal = SrtmGetHeight(pRoute[iPos].dCoordX,pRoute[iPos].dCoordY);
		if(dVal>-10000.0)
			{
			pRoute[iPos].dCoordZ = dVal;
			}
		else{
			dVal = pRoute[iPos].dCoordZ;
			}

		if(dMin>dVal)dMin=dVal;
		if(dMax<dVal)dMax=dVal;

		}

	if(dMax<=dMin+0.1)dMax=dMin+0.1;


	sImage.SetPixelFunction(TEXT_SMOTH,0,0);			// km Skalierung ausgeben
	sImage.SetPixelFunction(TEXT_NONE ,0,1);
	sImage.SetFont(aFont16);
	sImage.SetAlign(1);

	iVal   = iSizeX/200;
	dStep  = m_dLength/(double)iVal;

	if(dStep<0.1)dStep=0.1;

	dRest  = modf(log10(dStep),&dFull);
	dStep /= pow (10.0 , dFull);

		 if(dStep<=2.5)dStep= 2.5;
	else if(dStep<=5.0)dStep= 5.0;
	else			   dStep=10.0;

	dStep *= pow (10.0,dFull);


	for(dVal=0,iNum=0;dVal<=m_dLength;dVal+=dStep,iNum++)
		{
		iPixel	= (int)((double)iSizeX*dVal/m_dLength);
		iVal	= (int)(dVal);

		if(dVal==0.0 && m_dLength>5000.0)
			{
			strcpy(cText,"0.0 km");
			}
		else{
			vtostr(iVal,cText,VTS_SIGNED|VTS_ADDSUFFIX|VTS_ADDSPACE|0x8310,"m");
			}

		sImage.Box  (iPosX+iPixel,iPosY,2,(iVal&1)? 8:16,BGR(100,100,100));
		sImage.Print(iPosX+iPixel,iPosY+20,cText);
		}


	sImage.SetAlign(2);									// Vertikale Skala ausgeben

	iVal   = iSizeY/60;
	dStep  = (dMax-dMin)/(double)iVal;

	if(dStep<0.1)dStep=0.1;

	dRest  = modf(log10(dStep),&dFull);
	dStep /= pow (10.0 , dFull);

		 if(dStep<=2.5)dStep= 2.5;
	else if(dStep<=5.0)dStep= 5.0;
	else			   dStep=10.0;

	dStep *= pow(10.0,dFull);
	dVal   = (int)((dMin+dStep-0.1)/dStep);
	dVal  *= dStep;

	for(iNum=0;dVal<=dMax;dVal+=dStep,iNum++)
		{
		iPixel	= (int)((double)iSizeY*(dVal-dMin)/(dMax-dMin));
		iPixel += FRAME_BASE;
		iVal	= (int)(dVal);

		vtostr(iVal,cText,VTS_SIGNED|VTS_ADDSUFFIX|VTS_ADDSPACE|0x8400,"m");

		sImage.Box  (iPosX   ,iPosY-iPixel,iSizeX,1,BGR(222,222,222));
		sImage.Box  (iPosX   ,iPosY-iPixel,(iVal&1)? -8:-16,2,BGR(100,100,100));
		sImage.Print(iPosX-18,iPosY-iPixel-8,cText);
		}


	dVal	= (double)(iSizeY-FRAME_BASE)/(dMax-dMin);
	dLast	= pRoute[0].dCoordZ-dMin;
	dStep	= pRoute[0].dDistance-1.0;
	dFull	= 0.0;

	for(iPos=0;iPos<iCount;iPos++)						// Hhenlinie zeichnen
		{
		dNow   = pRoute[iPos].dCoordZ-dMin;
		dDiff  = dNow-dLast;
		dDiff /= pRoute[iPos].dDistance-dStep;
		if(dDiff<-0.3)dDiff=-0.3;
		if(dDiff> 0.3)dDiff= 0.3;

		dFull  = dFull*0.66+dDiff*0.33;

		if(dFull<-0.15)
			{
			if(dFull<-0.2)dFull=-0.2;
			uColor = BGR(0,0,222);
			}
		else if(dFull<0.0)
			{
			iNum   = (int)(dFull/-0.15*222.0);
			uColor = BGR(0,222-iNum,iNum);
			}
		else if(dFull<0.15)
			{
			iNum   = (int)(dFull/0.15*222.0);
			uColor = BGR(iNum,222-iNum,0);
			}
		else{
			if(dFull>0.2)dFull=0.2;
			uColor = BGR(222,0,0);
			}

		iPixel = FRAME_BASE+(int)(dNow*dVal);
		dStep  = pRoute[iPos].dDistance;
		dLast  = dNow;

		sImage.Box(iPosX+2+iPos,iPosY-2,1,-iPixel,uColor);
		}


	delete pRoute;

	sImage.Box(iPosX,iPosY,2,-iSizeY,BGR(0,0,0));		// Skala ausgeben
	sImage.Box(iPosX,iPosY, iSizeX,2,BGR(0,0,0));


	sTemp.Stretch(sImage,&sRect,1);
	m_hBitmap = sTemp.CreateBitmap(m_hWnd);

	pWnd->SetBitmap(m_hBitmap);

	sprintf(cText,"   Anstieg = %3.1f m   Abstieg = %3.1f m   Lnge = %3.1f km",m_dMetersUp,m_dMetersDown,m_dLength*0.001);
	SetDlgItemText(IDC_INFO,cText);


	SetCursor(IDC_ARROW);

	CDialog::OnInitDialog();




return TRUE;
}

//*****************************************************************************
//*
//*		OnContextMenu
//*
//*****************************************************************************
void CHeightDlg::OnContextMenu(CWnd *pWnd,CPoint sPoint)
{
CMenu	sMenu;


	sMenu.CreatePopupMenu();

	sMenu.AppendMenu(MF_STRING,ID_COPY_PIC,_T("Bild kopieren"));
	sMenu.TrackPopupMenu(0,sPoint.x,sPoint.y,this);
	sMenu.DestroyMenu();

}

//*****************************************************************************
//*
//*		OnCopyPic
//*
//*****************************************************************************
void CHeightDlg::OnCopyPic()
{

	if(OpenClipboard())
		{
		EmptyClipboard();
		SetClipboardData(CF_BITMAP,m_hBitmap);
		CloseClipboard();
		}

}
