//*****************************************************************************
//*
//*
//*		MainFrm.cpp
//*
//*
//*****************************************************************************
#include	"StdAfx.h"
#include	"OsmViewer.h"
#include	"OsmViewerDoc.h"
#include	"OsmViewerView.h"
#include	"MainFrm.h"

#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif



IMPLEMENT_DYNCREATE(CMainFrame,CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame,CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_COMMAND(ID_STATUS_BAR_FLAT				,OnFlatBar)
	ON_COMMAND(ID_PATHBARVIEW_ON				,OnPathBar)
	ON_COMMAND(ID_FIXWINDOW						,OnFixWindow)
	ON_UPDATE_COMMAND_UI(ID_PATHBARVIEW_ON		,OnPathBarUI)
	ON_UPDATE_COMMAND_UI(ID_STATUS_BAR_FLAT 	,OnFlatBarUI)
	ON_UPDATE_COMMAND_UI(ID_FIXWINDOW			,OnFixWindowUI)
	//}}AFX_MSG_MAP
	ON_MESSAGE(ID_SETSTATUSBAR,					,OnSetStatusbar)
	ON_APP_MESSAGE()
	ON_MENUICON()
	ON_ENUMWND()
END_MESSAGE_MAP()

static UINT indicators[] =
	{
	ID_SEPARATOR,												// Statusleistenanzeige
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
	};

MENUICON_PROC(CMainFrame)
ENUMWND_PROC (CMainFrame)
APP_PROC     (CMainFrame)


//*****************************************************************************
//*
//*		CMainFrame
//*
//*****************************************************************************
//  CMainFrame Konstruktion/Zerstrung
CMainFrame::CMainFrame()
{
CRegKeys	sKey;


	m_bFlatMode		= TRUE;
	m_bPathBarOn	= FALSE;
	m_bWindowFixed	= FALSE;
	m_bIsZoomed		= FALSE;
	m_iMonitor		= 0;
	m_iLastPosX		= 0;	
	m_iLastPosY		= 0;	
	m_iLastSizeX	= 0;	
	m_iLastSizeY	= 0;
	
	sKey.Open();
	sKey.Up("Settings");
	sKey.Get(m_bIsZoomed ,"IsZoomed");
	sKey.Get(m_bFlatMode ,"FlatMode");
	sKey.Get(m_iLastPosX ,"LastPosX");
	sKey.Get(m_iLastPosY ,"LastPosY");
	sKey.Get(m_iLastSizeX,"LastSizeX");
	sKey.Get(m_iLastSizeY,"LastSizeY");
	sKey.Get(m_iMonitor  ,"LastMonitor");
	sKey.Get(m_bPathBarOn,"ShowPathBar");


	ENUMWND_REGISTER("OsmViewer");

	MonitorInit();

	
}

//*****************************************************************************
//*
//*		CMainFrame
//*
//*****************************************************************************
CMainFrame::~CMainFrame()
{
CRegKeys	sKey;


	sKey.Open();
	sKey.Up("Settings");
	sKey.Set(m_bIsZoomed,"IsZoomed");
	sKey.Set(m_bFlatMode,"FlatMode");
	sKey.Set(m_bPathBarOn,"ShowPathBar");

	if(!m_bIsZoomed)
		{
		sKey.Set(m_iLastPosX ,"LastPosX");
		sKey.Set(m_iLastPosY ,"LastPosY");
		sKey.Set(m_iLastSizeX,"LastSizeX");
		sKey.Set(m_iLastSizeY,"LastSizeY");
		}
	
	if(MonitorCount()>1)
		{
		sKey.Set(m_iMonitor,"LastMonitor");
		}


}

//*****************************************************************************
//*
//*		OnCreate
//*
//*****************************************************************************
int CMainFrame::OnCreate(LPCREATESTRUCT pCreateStruct)
{
COsmViewerView *pView;
COLORREF		aColors[8];
DWORD			dwStyle;
unsigned		uVal;
unsigned		uPos;



	if(CFrameWnd::OnCreate(pCreateStruct) == -1)
		{
		return -1;
		}

		pView = (COsmViewerView*)GetActiveView();
	if(!pView)
		{
		pView = (COsmViewerView*)GetDescendantWindow(AFX_IDW_PANE_FIRST,TRUE);
		
		if(pView && !pView->IsKindOf(RUNTIME_CLASS(CView)))
			{
			pView = NULL;
			}
		}
	
	
	dwStyle = (m_bFlatMode)? TBSTYLE_FLAT:0;

	if(pView)
		{
		for(uPos=0;uPos<8;uPos++)						
			{
			pView->GetPathPen(uPos,aColors[uPos],uVal) ;
			}
		}


			   
	if(!m_wndStatusBar.Create(this) || !m_wndStatusBar.SetIndicators(indicators,sizeof(indicators)/sizeof(UINT)))
		{
		TRACE0("Failed to create status bar\n");
		return -1;
		}

	if(!m_wndToolBar.CreateEx(this,dwStyle|CBES_MENU_FLAT|CBES_MENU_HIDE,WS_CHILD|WS_VISIBLE|CBRS_TOP|CBRS_GRIPPER|CBRS_TOOLTIPS|CBRS_FLYBY|CBRS_SIZE_DYNAMIC,CRect(2,2,2,2)))
		{
		TRACE0("Symbolleiste konnte nicht erstellt werden\n");
		return -1; 
		}
	
	if(!m_wndPathBar.CreateEx(this,dwStyle|CBES_MENU_FLAT|CBES_MENU_HIDE,WS_CHILD|WS_VISIBLE|CBRS_TOP|CBRS_GRIPPER|CBRS_TOOLTIPS|CBRS_FLYBY|CBRS_SIZE_DYNAMIC,CRect(2,2,2,2),IDR_SHOWPATH))
		{
		TRACE0("Symbolleiste konnte nicht erstellt werden\n");
		return -1; 
		}
	
	if(!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
		{
		TRACE0("Symbolleiste konnte nicht erstellt werden\n");
		return -1; 
		}

	if(!m_wndPathBar.LoadToolBar(IDR_SHOWPATH))
		{
		TRACE0("Symbolleiste konnte nicht erstellt werden\n");
		return -1; 
		}

	CRect sRect(400,0,400,1);	  
	ClientToScreen(&sRect);
				  
	m_wndPathBar.ChangeFlags(BTFL_COLOR_CHANGE,BTFL_COLOR_CHANGE,0,0xFFFF);
	m_wndPathBar.SetColors(8,ID_SHOWPATH1,aColors,RGB(255,0,255));
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	m_wndPathBar.EnableDocking(CBRS_ALIGN_ANY);
	m_wndToolBar.SetMenuId(3,ID_STATUS_BAR_FLAT);
	m_wndToolBar.SetMenuId(4,ID_VIEW_TOOLBAR   );
	m_wndPathBar.SetMenuId(3,ID_STATUS_BAR_FLAT);
	m_wndPathBar.SetMenuId(4,ID_PATHBARVIEW_ON );
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);
	DockControlBar(&m_wndPathBar,(UINT)0,&sRect);

	RecalcLayout();
	MenuIconsInit(IDR_MAINFRAME);
	ShowControlBar(&m_wndPathBar,m_bPathBarOn,0);


return 0;
}

//*****************************************************************************
//*
//*		OnDestroy
//*
//*****************************************************************************
void CMainFrame::OnDestroy()
{
CRect	sRect;

	
	GetWindowRect(&sRect);

	m_iLastPosX		= sRect.left;	
	m_iLastPosY		= sRect.top;	
	m_iLastSizeX	= sRect.Width();	
	m_iLastSizeY	= sRect.Height();
	m_bIsZoomed		= IsZoomed();
	m_iMonitor		= MonitorOfWindow(this);

	CFrameWnd::OnDestroy();	
}


//*****************************************************************************
//*
//*		PreCreateWindow
//*
//*****************************************************************************
BOOL CMainFrame::PreCreateWindow(CREATESTRUCT &sCreate)
{
	
	if(m_bIsZoomed)
		{
		AfxGetApp()->m_nCmdShow = SW_MAXIMIZE;
		}

	if(m_iLastSizeX>50 && m_iLastSizeY>50)
	if(m_iLastSizeX+m_iLastPosX>50)
	if(m_iLastSizeY+m_iLastPosY>50)
	if(m_iLastPosX+50<GetSystemMetrics(SM_CXSCREEN))
	if(m_iLastPosY+50<GetSystemMetrics(SM_CYSCREEN))
		{
		sCreate.x	= m_iLastPosX;
		sCreate.y	= m_iLastPosY;
		sCreate.cx	= m_iLastSizeX;	
		sCreate.cy	= m_iLastSizeY;
		}

	if(MonitorOfRect(&sCreate)!=m_iMonitor)
		{
		MonitorMove(&sCreate,m_iMonitor,1);
		}

	if(!CFrameWnd::PreCreateWindow(sCreate))
		{
		return FALSE;
		}


return TRUE;
}


#ifdef		_DEBUG						

//*****************************************************************************
//*
//*		AssertValid
//*
//*****************************************************************************
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

//*****************************************************************************
//*
//*		Dump
//*
//*****************************************************************************
void CMainFrame::Dump(CDumpContext &dc) const
{
	CFrameWnd::Dump(dc);
}

#endif


//*****************************************************************************
//*
//*		OnFlatBarUI
//*
//*****************************************************************************
void CMainFrame::OnFlatBarUI(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(m_bFlatMode);
}


//*****************************************************************************
//*
//*		OnFlatBar
//*
//*****************************************************************************
void CMainFrame::OnFlatBar()
{
DWORD	uStyle;


	uStyle=(m_bFlatMode)? TBSTYLE_FLAT:0;
	m_wndToolBar.ModifyStyle(uStyle,uStyle^TBSTYLE_FLAT);
	m_bFlatMode=(uStyle)? 0:1;

	if(m_wndToolBar.GetStyle()&WS_VISIBLE)
		{
		ShowControlBar(&m_wndToolBar,FALSE,FALSE);
		ShowControlBar(&m_wndToolBar,TRUE ,FALSE);
		}

}

//*****************************************************************************
//*
//*		OnPathBarUI
//*
//*****************************************************************************
void CMainFrame::OnPathBarUI(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(m_wndPathBar.IsVisible());
}


//*****************************************************************************
//*
//*		OnPathBar
//*
//*****************************************************************************
void CMainFrame::OnPathBar()
{

	m_bPathBarOn=!m_wndPathBar.IsVisible();
	ShowControlBar(&m_wndPathBar,m_bPathBarOn,0);
}

//*****************************************************************************
//*
//*		OnFixWindowUI
//*
//*****************************************************************************
void CMainFrame::OnFixWindowUI(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(m_bWindowFixed);
}

//*****************************************************************************
//*
//*		OnFixWindow
//*
//*****************************************************************************
void CMainFrame::OnFixWindow()
{
	m_bWindowFixed = !m_bWindowFixed;
	SetWindowPos((m_bWindowFixed)? &wndTopMost:&wndNoTopMost,0,0,0,0,SWP_NOACTIVATE|SWP_NOMOVE|SWP_NOSIZE);
}

//*****************************************************************************
//*
//*		OnSetStatusbar
//*
//*****************************************************************************
LRESULT CMainFrame::OnSetStatusbar(WPARAM wParam,LPARAM lParam)
{
LPCTSTR		pText=(LPCTSTR)lParam;


	m_wndStatusBar.SetPaneText(wParam,pText);


return 0;
}

//*****************************************************************************
//*
//*		UpdatePathBar
//*
//*****************************************************************************
void CMainFrame::UpdatePathBar()
{
COsmViewerView *pView;
COLORREF		aColors[8];
unsigned		uVal;
unsigned		uPos;



		pView = (COsmViewerView*)GetActiveView();
	if(!pView)return;
	
	for(uPos=0;uPos<8;uPos++)						
		{
		pView->GetPathPen(uPos,aColors[uPos],uVal) ;
		}				  
			  
	m_wndPathBar.SetColors(8,ID_SHOWPATH1,aColors,RGB(255,0,255));

}
