//*****************************************************************************
//*
//*
//*		OsmCoordDlg.cpp
//*
//*
//*****************************************************************************
#include	"StdAfx.h"
#include	"OsmViewer.h"
#include	"OsmCoordDlg.h"
#include	"CoordFunctions.h"


#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif

BEGIN_MESSAGE_MAP(COsmCoordDlg, CDialog)
	//{{AFX_MSG_MAP(COsmCoordDlg)
	ON_WM_DESTROY()
	ON_EN_KILLFOCUS(IDC_EDIT2,	OnFocusX)
	ON_EN_KILLFOCUS(IDC_EDIT1,	OnFocusY)
	ON_EN_CHANGE   (IDC_EDIT2,	OnChangeX)
	ON_EN_CHANGE   (IDC_EDIT1,	OnChangeY)
	ON_CBN_SELCHANGE(IDC_COMBO1,OnChangeZ)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


//*****************************************************************************
//*
//*		COsmCoordDlg Dialog
//*
//*****************************************************************************
COsmCoordDlg::COsmCoordDlg(CWnd *pParent): CDialog(COsmCoordDlg::IDD,pParent)
{

	//{{AFX_DATA_INIT(COsmCoordDlg)
	m_sCoordY = _T("");
	m_sCoordX = _T("");
	m_iZoom	  = 0;
	//}}AFX_DATA_INIT

	m_bNotModal		= FALSE;
	m_bChange1		= FALSE;
	m_bChange2		= FALSE;
	m_bLocked		= FALSE;
	m_uCoordMode	= 0;										
	m_dCoordX		= 0;
	m_dCoordY		= 0;

}


//*****************************************************************************
//*
//*		Create
//*
//*****************************************************************************
BOOL COsmCoordDlg::Create(CWnd *pParent)
{

	m_bNotModal	= TRUE;	

return	CDialog::Create(IDD,pParent);
}

//*****************************************************************************
//*
//*		DoDataExchange
//*
//*****************************************************************************
void COsmCoordDlg::DoDataExchange(CDataExchange *pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COsmCoordDlg)
	DDX_Text   (pDX,IDC_EDIT1 ,m_sCoordY);
	DDX_Text   (pDX,IDC_EDIT2 ,m_sCoordX);
	DDX_CBIndex(pDX,IDC_COMBO1,m_iZoom);
	//}}AFX_DATA_MAP
}


//*****************************************************************************
//*
//*		OnInitDialog
//*
//*****************************************************************************
//  COsmCoordDlg message handlers
BOOL COsmCoordDlg::OnInitDialog()
{

	CDialog::OnInitDialog();


return TRUE;
}

//*****************************************************************************
//*
//*		OnDestroy
//*
//*****************************************************************************
void COsmCoordDlg::OnDestroy()
{

	CDialog::OnDestroy();

}


//*****************************************************************************
//*
//*		OnCancel
//*
//*****************************************************************************
void COsmCoordDlg::OnCancel()
{

	if(m_bNotModal)
		{
		ShowWindow(SW_HIDE);
		return;
		}


	CDialog::OnCancel();


}


//*****************************************************************************
//*
//*		OnOK
//*
//*****************************************************************************
void COsmCoordDlg::OnOK()
{




}

//*****************************************************************************
//*
//*		OnFocusX
//*
//*****************************************************************************
void COsmCoordDlg::OnFocusX() 
{

	if(!m_bLocked && m_bChange2)
		{
		SendNotify();
		}

}

//*****************************************************************************
//*
//*		OnFocusY
//*
//*****************************************************************************
void COsmCoordDlg::OnFocusY() 
{
	
	if(!m_bLocked && m_bChange1)
		{
		SendNotify();
		}

}

//*****************************************************************************
//*
//*		OnChangeX
//*
//*****************************************************************************
void COsmCoordDlg::OnChangeX() 
{

	if(!m_bLocked)
		{
		m_bChange2 = TRUE;
		}

}

//*****************************************************************************
//*
//*		OnChangeY
//*
//*****************************************************************************
void COsmCoordDlg::OnChangeY() 
{
CWnd   *pParent;	
TCHAR	cText[128];
double  dValue;
int		iLen;


	if(!m_bLocked)
		{
		m_bChange1 = TRUE;

		GetDlgItemText(IDC_EDIT1,cText,128);
		dValue = TextToCoord(cText,&iLen);

		if(iLen>0 && dValue!=0.0 && cText[iLen]==',' && TextToCoord(cText+iLen+1)!=0.0)
			{
			m_bLocked = TRUE;
			pParent = GetParent();
			pParent->SendMessage(WM_COMMAND,ID_UPDATE_COORD);
			cText[iLen]=0;
			iLen += strwlen(cText+iLen+1,0xE0);
			SetDlgItemText(IDC_EDIT2,cText+iLen+1);
			SetDlgItemText(IDC_EDIT1,cText);
			SendNotify();
			m_bLocked = FALSE;
			}
		}

}

//*****************************************************************************
//*
//*		OnChangeZ
//*
//*****************************************************************************
void COsmCoordDlg::OnChangeZ() 
{

	if(!m_bLocked)
		{
		SendNotify();	
		}

}

//*****************************************************************************
//*
//*		Set
//*
//*****************************************************************************
void COsmCoordDlg::Set(double dCoordX,double dCoordY,int iZoom,int iCoordMode)
{
TCHAR		cText[64];
CComboBox  *pCombo;	
CEdit      *pEdit1;	
CEdit      *pEdit2;	
CWnd	   *pWnd;	



	m_bLocked = TRUE;

	if(iCoordMode>=0)m_uCoordMode=iCoordMode;

	pWnd	= GetFocus();
	pEdit1	= (CEdit    *)GetDlgItem(IDC_EDIT1);
	pEdit2	= (CEdit    *)GetDlgItem(IDC_EDIT2);
	pCombo	= (CComboBox*)GetDlgItem(IDC_COMBO1);


	if(!pWnd || pWnd->m_hWnd!=pEdit1->m_hWnd)
		{
		CoordToText(dCoordY,m_uCoordMode,cText);
		SetDlgItemText(IDC_EDIT1,cText);
		} 	


	if(!pWnd || pWnd->m_hWnd!=pEdit2->m_hWnd)
		{
		CoordToText(dCoordX,m_uCoordMode,cText);
		SetDlgItemText(IDC_EDIT2,cText);
		} 	
	

	if(!pWnd || pWnd->m_hWnd!=pCombo->m_hWnd)
		{
		pCombo->SetCurSel(iZoom);
		}

	m_bLocked = FALSE;

}


//*****************************************************************************
//*
//*		SendNotify
//*
//*****************************************************************************
void COsmCoordDlg::SendNotify()
{
CWnd   *pParent;

	
	
	UpdateData();

	m_dCoordX	= TextToCoord(m_sCoordX);
	m_dCoordY	= TextToCoord(m_sCoordY);
	m_bChange1	= FALSE;
	m_bChange2	= FALSE;

	pParent		= GetParent();
	pParent->SendMessage(WM_COMMAND,ID_UPDATE_COORD);


}
