//*****************************************************************************
//*
//*
//*		OsmFindDlg.cpp
//*
//*
//*****************************************************************************
#include	"StdAfx.h"
#include	"OsmViewer.h"
#include	"OsmFindDlg.h"
#include	"CoordFunctions.h"


#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif

#define 	 ID_LIST	0x51FD


BEGIN_MESSAGE_MAP(COsmFindDlg, CDialog)
	//{{AFX_MSG_MAP(COsmFindDlg)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BUTTON1	, OnPath)
	ON_BN_CLICKED(IDC_BUTTON2	, OnFind)
	ON_EN_CHANGE(IDC_EDIT1		, OnCoordChanged)
	ON_CBN_EDITCHANGE(IDC_COMBO1, OnPathChanged)
	//}}AFX_MSG_MAP
	ON_NOTIFY(TVN_CBSTATECHANGED,ID_LIST,OnCheckChanged)
	ON_NOTIFY(TVN_COLUMNCLICK   ,ID_LIST,OnListSort)
END_MESSAGE_MAP()

DLG_OLDPOS(COsmFindDlg)

//*****************************************************************************
//*
//*		CDialog
//*
//*****************************************************************************
//  Dialogfeld COsmFindDlg
COsmFindDlg::COsmFindDlg(CWnd *pParent): CDialog(COsmFindDlg::IDD,pParent)
{
	//{{AFX_DATA_INIT(COsmFindDlg)
	m_sPath 	= _T("");
	m_sCoordY	= _T("");
	m_sCoordX	= _T("");
	m_sFilter	= _T("");
	m_sDisdance = _T("100");
	//}}AFX_DATA_INIT
}


//*****************************************************************************
//*
//*		DoDataExchange
//*
//*****************************************************************************
void COsmFindDlg::DoDataExchange(CDataExchange *pDX)
{
	CDialog::DoDataExchange(pDX);

	//{{AFX_DATA_MAP(COsmFindDlg)
	DDX_CBString(pDX,IDC_COMBO1,m_sPath    );
	DDX_Text    (pDX,IDC_EDIT1 ,m_sCoordY  );
	DDX_Text    (pDX,IDC_EDIT2 ,m_sCoordX  );
	DDX_Text    (pDX,IDC_EDIT3 ,m_sDisdance);
	DDX_Text    (pDX,IDC_EDIT4 ,m_sFilter  );
	//}}AFX_DATA_MAP
}


//*****************************************************************************
//*
//*		OnInitDialog
//*
//*****************************************************************************
//  Behandlungsroutinen fr Nachrichten COsmFindDlg
BOOL COsmFindDlg::OnInitDialog()
{
CRegKeys	sKey;

	
	SET_DLG_OLDPOS()
	
	m_iSortDir	=  0;
	m_iSortMode	= -1;
	
	SetButtonBitmap(this,IDC_BUTTON1,IDB_OPEN);
	
	sKey.Open();
	sKey.Up(_T("FindDlg"));
	sKey.Get(m_sCoordX	,_T("CoordX"  ));
	sKey.Get(m_sCoordY	,_T("CoordY"  ));
	sKey.Get(m_sDisdance,_T("Disdance"));
	sKey.Get(m_sFilter  ,_T("Filter"  ));
	
	ComboBoxLoad(this,IDC_COMBO1,_T("#SeachPaths"),_T("#FindDlg"),m_sPath);

	m_cList.CreateEx(WS_EX_CLIENTEDGE,WS_CHILD|WS_VISIBLE|WS_TABSTOP|TVS_FULLROWSELECT|TVS_CHECKBOXES,IDC_FRAME,this,ID_LIST);
	m_cList.InsertColumn(0,_T("Dateiname"    ),TVCFMT_LEFT , -99);
	m_cList.InsertColumn(1,_T("Name"         ),TVCFMT_LEFT , -38);
	m_cList.InsertColumn(2,_T("Abstand"      ),TVCFMT_RIGHT,  65);

	CDialog::OnInitDialog();

	OnPathChanged();


return TRUE;
}

//*****************************************************************************
//*
//*		OnDestroy
//*
//*****************************************************************************
void COsmFindDlg::OnDestroy()
{
	
	GET_DLG_OLDPOS()
	
	DelButtonBitmap(this,IDC_BUTTON1);

	CDialog::OnDestroy();


}

//*****************************************************************************
//*
//*		OnPathChanged
//*
//*****************************************************************************
void COsmFindDlg::OnPathChanged() 
{
CString		sText;


	GetDlgItemText(IDC_COMBO1,sText);
	GetDlgItem(IDC_BUTTON2)->EnableWindow(!sText.IsEmpty());
	
}

//*****************************************************************************
//*
//*		OnCoordChanged
//*
//*****************************************************************************
void COsmFindDlg::OnCoordChanged() 
{
static int	iLocked=0;
TCHAR		cText[128];
double		dValue;
int			iLen;
int			iNum;


	if(iLocked)return;

	GetDlgItemText(IDC_EDIT1,cText,128);
	dValue = TextToCoord(cText,&iLen);

	if(iLen>0 && dValue!=0.0 && cText[iLen]==',' && TextToCoord(cText+iLen+1)!=0.0)
		{
		iLocked=1;
		cText[iLen]=0;
		iLen  += strwlen(cText+iLen+1,0xE0);
		dValue = TextToCoord(cText,&iNum);
		cText[iLen+1+iNum] = 0;
		SetDlgItemText(IDC_EDIT2,cText+iLen+1);
		SetDlgItemText(IDC_EDIT1,cText);
		iLocked=0;
		}

}

//*****************************************************************************
//*
//*		OnCheckChanged
//*
//*****************************************************************************
void COsmFindDlg::OnCheckChanged(NMHDR *pNmHdr,LRESULT *pResult)
{
NM_TREEVIEW   *pItem = (NM_TREEVIEW*)pNmHdr;

	
	if(m_iSelCount<0)return;
	
	if((pItem->itemNew.state&TVIS_STATEIMAGEMASK)>0x1000)
		{
		m_iSelCount++;
		}
	else if(m_iSelCount>0)
		{
		m_iSelCount--;
		}
	 

	GetDlgItem(IDOK)->EnableWindow(m_iSelCount>0);

}


//*****************************************************************************
//*
//*		OnListSort
//*
//*****************************************************************************
void COsmFindDlg::OnListSort(NMHDR *pNmHdr,LRESULT *pResult)
{
NMHEADER   *pHeader = (NMHEADER*)pNmHdr;
TVSORTEX	sSort;


	
	if(pHeader->iItem==0)
		{
		m_iSortDir			= (m_iSortMode==0)? !m_iSortDir:0;
		m_iSortMode			= 0;
		sSort.hParent		= TVI_ROOT;
		sSort.lParam		= m_iSortDir;
		sSort.lpfnCompare 	= ComparePath;
		m_cList.SortChildrenEX(&sSort,0);
		}

	if(pHeader->iItem==1)
		{
		m_iSortDir			= (m_iSortMode==1)? !m_iSortDir:0;
		m_iSortMode			= 1;
		sSort.hParent		= TVI_ROOT;
		sSort.lParam		= m_iSortDir;
		sSort.lpfnCompare 	= CompareName;
		m_cList.SortChildrenEX(&sSort,0);
		}

	if(pHeader->iItem==2)
		{
		m_iSortDir			= (m_iSortMode==2)? !m_iSortDir:0;
		m_iSortMode			= 2;
		sSort.hParent		= TVI_ROOT;
		sSort.lParam		= m_iSortDir;
		sSort.lpfnCompare 	= CompareDiff;
		m_cList.SortChildrenEX(&sSort,0);
		}


}


//*****************************************************************************
//*
//*		ComparePath
//*
//*****************************************************************************
int CALLBACK COsmFindDlg::ComparePath(HWND hWnd,HTREEITEM hItem1,HTREEITEM hItem2,LPARAM lParam1,LPARAM lParam2,LPARAM lParam)
{
TV_ITEM		sItem1;
TV_ITEM		sItem2;
int			iCmp;

    
	sItem1.mask		 = TVIF_TEXT|TVIF_SUBITEM|TVIF_TEXTPTR;
	sItem1.hItem	 = hItem1;
	sItem1.cChildren = 0;

	sItem2.mask		 = TVIF_TEXT|TVIF_SUBITEM|TVIF_TEXTPTR;
	sItem2.hItem	 = hItem2;
	sItem2.cChildren = 0;

	TreeList_GetItem(hWnd,&sItem1);
	TreeList_GetItem(hWnd,&sItem2);

	iCmp = strvicmp(sItem1.pszText,sItem2.pszText);

	
return (lParam)? -iCmp:iCmp;
}


//*****************************************************************************
//*
//*		CompareName
//*
//*****************************************************************************
int CALLBACK COsmFindDlg::CompareName(HWND hWnd,HTREEITEM hItem1,HTREEITEM hItem2,LPARAM lParam1,LPARAM lParam2,LPARAM lParam)
{
TV_ITEM		sItem1;
TV_ITEM		sItem2;
int			iCmp;

    
	sItem1.mask		 = TVIF_TEXT|TVIF_SUBITEM|TVIF_TEXTPTR;
	sItem1.hItem	 = hItem1;
	sItem1.cChildren = 1;

	sItem2.mask		 = TVIF_TEXT|TVIF_SUBITEM|TVIF_TEXTPTR;
	sItem2.hItem	 = hItem2;
	sItem2.cChildren = 1;

	TreeList_GetItem(hWnd,&sItem1);
	TreeList_GetItem(hWnd,&sItem2);

	iCmp = strvicmp(sItem1.pszText,sItem2.pszText);

	
return (lParam)? -iCmp:iCmp;
}


//*****************************************************************************
//*
//*		CompareDiff
//*
//*****************************************************************************
int CALLBACK COsmFindDlg::CompareDiff(HWND hWnd,HTREEITEM hItem1,HTREEITEM hItem2,LPARAM lParam1,LPARAM lParam2,LPARAM lParam)
{
TV_ITEM		sItem1;
TV_ITEM		sItem2;
int			iCmp;

    
	sItem1.mask		 = TVIF_TEXT|TVIF_SUBITEM|TVIF_TEXTPTR;
	sItem1.hItem	 = hItem1;
	sItem1.cChildren = 2;

	sItem2.mask		 = TVIF_TEXT|TVIF_SUBITEM|TVIF_TEXTPTR;
	sItem2.hItem	 = hItem2;
	sItem2.cChildren = 2;

	TreeList_GetItem(hWnd,&sItem1);
	TreeList_GetItem(hWnd,&sItem2);
			   	 			 	   
	iCmp  = (int)strtof(sItem1.pszText,0,0x25);
	iCmp -= (int)strtof(sItem2.pszText,0,0x25);
	     
	
return (lParam)? -iCmp:iCmp;
}

//*****************************************************************************
//*
//*		OnPath
//*
//*****************************************************************************
void COsmFindDlg::OnPath()
{
CPathDlg	sDlg;


	UpdateData();
	sDlg.SetPath(m_sPath);
	if(sDlg.DoModal()!=IDOK)return;

	m_sPath=sDlg.GetPath();
	UpdateData(FALSE);
	OnPathChanged();

}

//*****************************************************************************
//*
//*		OnFind
//*
//*****************************************************************************
void COsmFindDlg::OnFind()
{
CProgressDlg	sDlg;
CRegKeys		sKey;
	
	
	UpdateData();
	
	sKey.Open();
	sKey.Up(_T("FindDlg"));
	sKey.Set(m_sCoordX	,_T("CoordX"  ));
	sKey.Set(m_sCoordY	,_T("CoordY"  ));
	sKey.Set(m_sDisdance,_T("Disdance"));
	sKey.Set(m_sFilter  ,_T("Filter"  ));

	ComboBoxSave(this,IDC_COMBO1,_T("#SeachPaths"),_T("#FindDlg"));


	if(m_sPath.IsEmpty())
		{
		MessageBox(_T("Bitte einen Dateipfad angeben !"),_T("Fehler"),MB_OK|MB_ICONERROR);
		return;
		}

	DelBackSlash(m_sPath);

	if(ExistFile(m_sPath)<2)
		{
		MessageBox(_T("Der angegebene Dateipfad existiert nicht !"),_T("Fehler"),MB_OK|MB_ICONERROR);
		return;
		}

	
	m_iSelCount	= 0;
	m_cList.DeleteAllItems();

	sDlg.StepIt();
	sDlg.SetRange(100);
	sDlg.SetProgressMode(200);
	sDlg.SetTitle(_T("Suche nach Tracks"));
	sDlg.SetProc(SearchProc,this,(LPCTSTR)m_sPath);
	sDlg.DoModal();

	GetDlgItem(IDOK)->EnableWindow(m_iSelCount>0);

}

//*****************************************************************************
//*
//*		OnCancel
//*
//*****************************************************************************
void COsmFindDlg::OnCancel()
{

	CDialog::OnCancel();
}

//*****************************************************************************
//*
//*		OnOK
//*
//*****************************************************************************
void COsmFindDlg::OnOK()
{
HTREEITEM		hItem;



	hItem = m_cList.GetFirstItem();

	while(hItem)
		{
		if(m_cList.GetCheck(hItem))
			{
			m_sFileList.Add(m_cList.GetItemText(hItem));
			}

		hItem = m_cList.GetNextSiblingItem(hItem);
		}


	CDialog::OnOK();

	
}

//*****************************************************************************
//*
//*		SearchProc
//*
//*****************************************************************************
int _cdecl COsmFindDlg::SearchProc(CProgressDlg *pDlg){COsmFindDlg	*pThis=(COsmFindDlg*)pDlg->GetVoid1();return pThis->SearchProc(pDlg,pDlg->GetChar2());}
int        COsmFindDlg::SearchProc(CProgressDlg *pDlg,LPCTSTR pPath)
{
TCHAR			cText[32];
TCHAR			cName[92];
HTREEITEM		hItem;
CFileFinder		sFind;
LPCTSTR			pFilter;
LPCTSTR			pFile;
RouteData	   *pData;	
double			dDiff;
double			dValue;
double			dCoordX;
double			dCoordY;
double			dDisdance;
int				iSelected;
int				iCount;
int				iPos;
int				iLen;


	m_iSelCount =-1;
	iSelected	= 0;	
	dDisdance	= strtof(m_sDisdance,0,0x25);if(dDisdance<0.01)dDisdance=100.0;
	dCoordX		= TextToCoord(m_sCoordX)*0.017453292519943295769236907684886;
	dCoordY		= TextToCoord(m_sCoordY)*0.017453292519943295769236907684886;
	pFilter		= (m_sFilter.IsEmpty())? _T("*.gpx;*.kml;*.kmz;*.trk;*.tk"):m_sFilter;
	sFind.Set(pPath,CFF_FIND_SUBDIR,m_sFilter);
		    

	for(;;)	   
		{
		if(pDlg->IsStoped())break;

			pFile = sFind.Next(1);
		if(!pFile)break;

		pDlg->SetText(_T("Datei: @"),pFile);
		iCount = ReadTrackFile(pFile,&pData,cName);
		
		if(iCount<=0)continue;

		pData[0].dCoordX *= 0.017453292519943295769236907684886;
		pData[0].dCoordY *= 0.017453292519943295769236907684886;
		dDiff = DistanceOfPointsEx(pData[0].dCoordX,pData[0].dCoordY,dCoordX,dCoordY);

		for(iPos=1;iPos<iCount;iPos++)
			{
			pData[iPos].dCoordX *= 0.017453292519943295769236907684886;
			pData[iPos].dCoordY *= 0.017453292519943295769236907684886;
			
			dValue = DistanceOfPointsEx(pData[iPos].dCoordX,pData[iPos].dCoordY,dCoordX,dCoordY);

			if(dValue<dDiff)dDiff=dValue;
			}

	
		delete pData;

		iLen  = _stprintf(cText,_T("%i m"),(int)dDiff);

		if(iLen>5){memmove(cText+iLen-4,cText+iLen-5, 6*sizeof(TCHAR));cText[iLen-5]=' ';iLen++;}
		if(iLen>9){memmove(cText+iLen-8,cText+iLen-9,10*sizeof(TCHAR));cText[iLen-9]=' ';iLen++;}

		hItem = m_cList.InsertItem(pFile);
		m_cList.SetItemText(hItem,cName,1);
		m_cList.SetItemText(hItem,cText,2);

		if(dDiff<=dDisdance)
			{
			m_cList.SetCheck(hItem);
			iSelected++;
			}
		}


	m_iSelCount = iSelected;


return iSelected;
}

