//*****************************************************************************
//*
//*
//*		OsmFrameDlg.cpp
//*
//*
//*****************************************************************************
#include	"StdAfx.h"
#include	"OsmViewer.h"
#include	"OsmFrameDlg.h"
#include	"CoordFunctions.h"


#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif

#define 	 ID_UPDATE		0x3455
#define 	 ID_OSMWND		0x3456
#define		 OSM_ZOOM_MASK	((1<< OSM_ZOOM_BASE)-1)		// Maske fr OSM-Koordinaten


BEGIN_MESSAGE_MAP(COsmFrameDlg, CDialog)
	//{{AFX_MSG_MAP(COsmFrameDlg)
	ON_WM_TIMER()
	ON_BN_CLICKED  (IDC_CHECK1, OnFixed)
	ON_WM_SIZE()
	ON_WM_SIZING()
	ON_EN_KILLFOCUS(IDC_EDIT1,	OnFocus1)
	ON_EN_KILLFOCUS(IDC_EDIT2,	OnFocus2)
	ON_EN_KILLFOCUS(IDC_EDIT3,	OnFocus3)
	ON_EN_KILLFOCUS(IDC_EDIT4,	OnFocus4)
	ON_EN_KILLFOCUS(IDC_EDIT5,	OnFocus5)
	ON_EN_KILLFOCUS(IDC_EDIT6,	OnFocus6)
	ON_EN_CHANGE   (IDC_EDIT1,	OnChange1)
	ON_EN_CHANGE   (IDC_EDIT2,	OnChange2)
	ON_EN_CHANGE   (IDC_EDIT3,	OnChange3)
	ON_EN_CHANGE   (IDC_EDIT4,	OnChange4)
	ON_EN_CHANGE   (IDC_EDIT5,  OnChange5)
	ON_EN_CHANGE   (IDC_EDIT6,  OnChange6)
	//}}AFX_MSG_MAP
	ON_NOTIFY(OSM_NM_RECTDONE ,ID_OSMWND,OnMapRectDone)
	ON_NOTIFY(OSM_NM_PLACEDONE,ID_OSMWND,OnFixedDone)
	ON_NOTIFY(OSM_NM_CHANGEXOR,ID_OSMWND,OnXorChanged)
END_MESSAGE_MAP()


DLG_SIZING_ITEMS(COsmFrameDlg,1,1)
	{							
	ID_OSMWND,	0, 0,  -1,-1,	
	IDC_TEXT1,	0, 1,   0, 0,	
	IDC_TEXT2,	0, 1,   0, 0,	
	IDC_TEXT3,	0, 1,  -1, 0,	
	IDOK,	    1, 0,   0, 0,	
	};

DLG_OLDSIZE(COsmFrameDlg)
DLG_SIZING (COsmFrameDlg)
DLG_SIZING_SIZE(COsmFrameDlg)



//*****************************************************************************
//*
//*		CDialog
//*
//*****************************************************************************
COsmFrameDlg::COsmFrameDlg(CWnd *pParent): CDialog(COsmFrameDlg::IDD,pParent)
{
	//{{AFX_DATA_INIT(COsmFrameDlg)
	//}}AFX_DATA_INIT

	m_uCoordMode= 0;										
	m_bLocked	= 0;
	m_pOsmMain	= 0;
	m_bFixed	= 0;
	m_dFrameX1	= 0;
	m_dFrameX2	= 0;
	m_dFrameY1	= 0;
	m_dFrameY2	= 0;
	m_iFrameX1	= 0;
	m_iFrameX2	= 0;
	m_iFrameY1	= 0;
	m_iFrameY2	= 0;
	m_iZoom		=-1; 

}


//*****************************************************************************
//*
//*		DoDataExchange
//*
//*****************************************************************************
void COsmFrameDlg::DoDataExchange(CDataExchange *pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COsmFrameDlg)
	DDX_Check(pDX,IDC_CHECK1,	m_bFixed);
	//}}AFX_DATA_MAP
}



//*****************************************************************************
//*
//*		OnInitDialog
//*
//*****************************************************************************
BOOL COsmFrameDlg::OnInitDialog() 
{
WNDPROC	pProc;
CRect	sRect;
CWnd   *pWnd;

	
	pWnd=GetDlgItem(IDC_EDIT1);pProc=GetWndProc(pWnd);SetWndData(pWnd,pProc);SetWndProc(pWnd,WheelProc);
	pWnd=GetDlgItem(IDC_EDIT2);pProc=GetWndProc(pWnd);SetWndData(pWnd,pProc);SetWndProc(pWnd,WheelProc);
	pWnd=GetDlgItem(IDC_EDIT3);pProc=GetWndProc(pWnd);SetWndData(pWnd,pProc);SetWndProc(pWnd,WheelProc);
	pWnd=GetDlgItem(IDC_EDIT4);pProc=GetWndProc(pWnd);SetWndData(pWnd,pProc);SetWndProc(pWnd,WheelProc);
	pWnd=GetDlgItem(IDOK     );pProc=GetWndProc(pWnd);SetWndData(pWnd,pProc);SetWndProc(pWnd,WheelProc);

	m_bChanged1	= 0;
	m_bChanged2	= 0;
	m_bChanged3	= 0;
	m_bChanged4	= 0;
	m_bLocked	= 0;

	CDialog::OnInitDialog();
	

	if(!m_iFrameX1 && !m_iFrameX2 && !m_iFrameY1 && !m_iFrameY2)
		{
		m_cOsmCtrl.CoordToPos(m_dFrameX1,m_dFrameY1,m_iFrameX1,m_iFrameY1);
		m_cOsmCtrl.CoordToPos(m_dFrameX2,m_dFrameY2,m_iFrameX2,m_iFrameY2);
		}
	else{
		m_cOsmCtrl.PosToCoord(m_iFrameX1,m_iFrameY1,m_dFrameX1,m_dFrameY1);
		m_cOsmCtrl.PosToCoord(m_iFrameX2,m_iFrameY2,m_dFrameX2,m_dFrameY2);
		}

	m_iFrameX1 &= OSM_ZOOM_MASK;
	m_iFrameX2 &= OSM_ZOOM_MASK; 
	m_iFrameY1 &= OSM_ZOOM_MASK; 
	m_iFrameY2 &= OSM_ZOOM_MASK;
				

	GetDlgItem(IDC_FRAME1)->GetClientRect(&sRect);


	m_cOsmCtrl.SetServer(m_pOsmMain);
	m_cOsmCtrl.SetScrollRect(m_dFrameX1,m_dFrameY1,m_dFrameX2,m_dFrameY2,TRUE,sRect.Width(),sRect.Height());
	m_cOsmCtrl.CreateEx(WS_EX_CLIENTEDGE,WS_CHILD|WS_VISIBLE|OSM_MOVE_R|OSM_MOUSE_ZOOM|OSM_CHANGE_NM,IDC_FRAME1,this,ID_OSMWND);
	m_cOsmCtrl.SetAction(0,(m_bFixed)? OSM_ACTION_PLACE:OSM_ACTION_RECT);
	m_cOsmCtrl.Reinit();

	DLG_SIZING_INIT();
	SET_DLG_OLDSIZE();

	OnFixed();
	SetRect();
	SetCoord(m_dFrameX1,m_dFrameY1,m_dFrameX2,m_dFrameY2);

	SetTimer(ID_UPDATE,250,NULL);


return TRUE;  
}

//*****************************************************************************
//*
//*		OnMapRectDone
//*
//*****************************************************************************
void COsmFrameDlg::OnMapRectDone(NMHDR *pNmHdr,LRESULT *pResult)
{
OSM_NOTIFY *pNotify=(OSM_NOTIFY*)pNmHdr;


	m_bLocked = 0;

	if(pNotify->dPos1X==pNotify->dPos2X)pNotify->iMode=1;
	if(pNotify->dPos1Y==pNotify->dPos2Y)pNotify->iMode=1;

	if(pNotify->iMode==0)
		{
		m_dFrameX1	= pNotify->dPos1X;
		m_dFrameY1	= pNotify->dPos1Y;
		m_dFrameX2	= pNotify->dPos2X;
		m_dFrameY2	= pNotify->dPos2Y;
		m_iFrameX1	= pNotify->iPos1X;
		m_iFrameY1	= pNotify->iPos1Y;
		m_iFrameX2	= pNotify->iPos2X;
		m_iFrameY2	= pNotify->iPos2Y;

		SetRect();
		}
	else{
		SetRect(TRUE);
		}

	SetCoord(m_dFrameX1,m_dFrameY1,m_dFrameX2,m_dFrameY2);
			
}

//*****************************************************************************
//*
//*		OnFixedDone
//*
//*****************************************************************************
void COsmFrameDlg::OnFixedDone(NMHDR *pNmHdr,LRESULT *pResult)
{
OSM_NOTIFY *pNotify=(OSM_NOTIFY*)pNmHdr;


	m_bLocked = 0;

	if(pNotify->iMode==0)
		{
		m_dFrameX1	= pNotify->dPos1X;
		m_dFrameY1	= pNotify->dPos1Y;
		m_iFrameX1	= pNotify->iPos1X;
		m_iFrameY1	= pNotify->iPos1Y;
		SetRect();
		}
	else{
		SetRect();
		}

	SetCoord(m_dFrameX1,m_dFrameY1,m_dFrameX2,m_dFrameY2);
			
}

//*****************************************************************************
//*
//*		OnXorChanged
//*
//*****************************************************************************
void COsmFrameDlg::OnXorChanged(NMHDR *pNmHdr,LRESULT *pResult)
{
OSM_NOTIFY *pNotify=(OSM_NOTIFY*)pNmHdr;
CString		sStatus;
double		dDiffX;
double		dDiffY;
int			iLastX;
int			iLastY;
int			iSizeX;
int			iSizeY;


	m_bLocked = 1;

	SetCoord(pNotify->dPos1X,pNotify->dPos1Y,pNotify->dPos2X,pNotify->dPos2Y);


	if(pNotify->iMode==OSM_ACTION_PLACE)
		{
		iLastX = (m_iSizeX<<(OSM_ZOOM_BASE-OSM_AREA_BITS-m_iZoom))+pNotify->iPos1X;
		iLastY = (m_iSizeY<<(OSM_ZOOM_BASE-OSM_AREA_BITS-m_iZoom))+pNotify->iPos1Y;
		
		m_cOsmCtrl.SetRect(pNotify->iPos1X,pNotify->iPos1Y,iLastX,iLastY);
		}
	else{
		dDiffX = DistanceOfPointsEx(pNotify->dPos1X*0.017453292519943295769236907684886,pNotify->dPos1Y*0.017453292519943295769236907684886,pNotify->dPos2X*0.017453292519943295769236907684886,pNotify->dPos1Y*0.017453292519943295769236907684886);
		dDiffY = DistanceOfPointsEx(pNotify->dPos1X*0.017453292519943295769236907684886,pNotify->dPos1Y*0.017453292519943295769236907684886,pNotify->dPos1X*0.017453292519943295769236907684886,pNotify->dPos2Y*0.017453292519943295769236907684886);

		sStatus.Format(_T("Breite = %.3f km   Lnge = %.3f km"),dDiffX*0.001,dDiffY*0.001);
		SetDlgItemText(IDC_TEXT2,sStatus);

		if(m_iZoom>=0)
			{
			iSizeX = (pNotify->iPos2X-pNotify->iPos1X)>>(OSM_ZOOM_BASE-OSM_AREA_BITS-m_iZoom);
			iSizeY = (pNotify->iPos2Y-pNotify->iPos1Y)>>(OSM_ZOOM_BASE-OSM_AREA_BITS-m_iZoom);

			sStatus.Format(_T("Pixel : X=%i   Y=%i"),iSizeX,iSizeY);
			SetDlgItemText(IDC_TEXT3,sStatus);
			}
		}

	m_bLocked = 0;
			
}

//*****************************************************************************
//*
//*		SetCoord
//*
//*****************************************************************************
//	Koordinaten in den vier oberen Edit-Fenstern einstellen
void COsmFrameDlg::SetCoord(double m_dCoordX1,double m_dCoordY1,double m_dCoordX2,double m_dCoordY2)
{
TCHAR	cText[64];
BOOL	bOld;


	bOld		= m_bLocked;
	m_bLocked	= 1;

	CoordToText(m_dCoordX1,m_uCoordMode  ,cText);	SetDlgItemText(IDC_EDIT2,cText);
	CoordToText(m_dCoordX2,m_uCoordMode  ,cText);	SetDlgItemText(IDC_EDIT4,cText);
	CoordToText(m_dCoordY1,m_uCoordMode|1,cText);	SetDlgItemText(IDC_EDIT1,cText);
	CoordToText(m_dCoordY2,m_uCoordMode|1,cText);	SetDlgItemText(IDC_EDIT3,cText);
	sprintf(cText,"%i",m_iSizeX);					SetDlgItemText(IDC_EDIT5,cText);
	sprintf(cText,"%i",m_iSizeY);					SetDlgItemText(IDC_EDIT6,cText);

	m_bLocked	= bOld;


}


//*****************************************************************************
//*
//*		OnFocus1
//*
//*****************************************************************************
void COsmFrameDlg::OnFocus1() 
{
TCHAR		cText[64];
double		dValue;
int			iLen;	

	
	if(!m_bLocked && m_bChanged1)
		{
		GetDlgItemText(IDC_EDIT1,cText,64);
		dValue = TextToCoord(cText,&iLen);

		if(iLen)
			{
			m_dFrameY1 = dValue;
			m_cOsmCtrl.CoordToPos(m_dFrameX1,m_dFrameY1,m_iFrameX1,m_iFrameY1);
			SetRect();
			}

		m_bLocked = TRUE;
		CoordToText(m_dFrameY1,m_uCoordMode|1,cText);
		SetDlgItemText(IDC_EDIT1,cText);
		m_bLocked = FALSE;
		}

	m_bChanged1 = FALSE;

}

//*****************************************************************************
//*
//*		OnFocus2
//*
//*****************************************************************************
void COsmFrameDlg::OnFocus2() 
{
TCHAR		cText[64];
double		dValue;
int			iLen;	

	
	if(!m_bLocked && m_bChanged2)
		{
		GetDlgItemText(IDC_EDIT2,cText,64);
		dValue = TextToCoord(cText,&iLen);

		if(iLen)
			{
			m_dFrameX1 = dValue;
			m_cOsmCtrl.CoordToPos(m_dFrameX1,m_dFrameY1,m_iFrameX1,m_iFrameY1);
			SetRect();
			}

		m_bLocked = TRUE;
		CoordToText(m_dFrameX1,m_uCoordMode,cText);
		SetDlgItemText(IDC_EDIT2,cText);
		m_bLocked = FALSE;
		}

	m_bChanged2 = FALSE;

}

//*****************************************************************************
//*
//*		OnFocus3
//*
//*****************************************************************************
void COsmFrameDlg::OnFocus3() 
{
TCHAR		cText[64];
double		dValue;
int			iLen;	

	
	if(!m_bLocked && m_bChanged3)
		{
		GetDlgItemText(IDC_EDIT3,cText,64);
		dValue = TextToCoord(cText,&iLen);

		if(iLen)
			{
			m_dFrameY2 = dValue;
			m_cOsmCtrl.CoordToPos(m_dFrameX2,m_dFrameY2,m_iFrameX2,m_iFrameY2);
			SetRect();
			}

		m_bLocked = TRUE;
		CoordToText(m_dFrameY2,m_uCoordMode|1,cText);
		SetDlgItemText(IDC_EDIT3,cText);
		m_bLocked = FALSE;
		}

	m_bChanged3 = FALSE;

}


//*****************************************************************************
//*
//*		OnFocus4
//*
//*****************************************************************************
void COsmFrameDlg::OnFocus4() 
{
TCHAR		cText[64];
double		dValue;
int			iLen;	

	
	if(!m_bLocked && m_bChanged4)
		{
		GetDlgItemText(IDC_EDIT4,cText,64);
		dValue = TextToCoord(cText,&iLen);

		if(iLen)
			{
			m_dFrameX2 = dValue;
			m_cOsmCtrl.CoordToPos(m_dFrameX2,m_dFrameY2,m_iFrameX2,m_iFrameY2);
			SetRect();
			}

		m_bLocked = TRUE;
		CoordToText(m_dFrameX2,m_uCoordMode,cText);
		SetDlgItemText(IDC_EDIT4,cText);
		sprintf(cText,"%i",m_iSizeX);
		SetDlgItemText(IDC_EDIT5,cText);
		m_bLocked = FALSE;
		}

	m_bChanged4 = FALSE;

}

//*****************************************************************************
//*
//*		OnFocus5
//*
//*****************************************************************************
void COsmFrameDlg::OnFocus5() 
{
TCHAR		cText[64];
int			iValue;

	
	if(!m_bLocked && m_bChanged5)
		{
		GetDlgItemText(IDC_EDIT5,cText,64);
		iValue = strcalc(cText);
		if(iValue<   64)iValue=64;
		if(iValue>20000)iValue=20000;

		if(m_iSizeX!=iValue)
			{
			m_iSizeX   = iValue;
			SetRect();
			}

		m_bLocked = TRUE;
		CoordToText(m_dFrameX2,m_uCoordMode,cText);
		SetDlgItemText(IDC_EDIT3,cText);
		sprintf(cText,"%i",m_iSizeX);
		SetDlgItemText(IDC_EDIT5,cText);
		m_cOsmCtrl.CoordToPos(m_dFrameX2,m_dFrameY2,m_iFrameX2,m_iFrameY2);
		m_bLocked = FALSE;
		}

	m_bChanged5 = FALSE;

}

//*****************************************************************************
//*
//*		OnFocus6
//*
//*****************************************************************************
void COsmFrameDlg::OnFocus6() 
{
TCHAR		cText[64];
int			iValue;

	
	if(!m_bLocked && m_bChanged6)
		{
		GetDlgItemText(IDC_EDIT6,cText,64);
		iValue = strcalc(cText);
		if(iValue<   64)iValue=64;
		if(iValue>20000)iValue=20000;

		if(m_iSizeY!=iValue)
			{
			m_iSizeY = iValue;
			SetRect();
			}

		m_bLocked = TRUE;
		CoordToText(m_dFrameY2,m_uCoordMode,cText);
		SetDlgItemText(IDC_EDIT4,cText);
		sprintf(cText,"%i",m_iSizeY);
		SetDlgItemText(IDC_EDIT6,cText);
		m_cOsmCtrl.CoordToPos(m_dFrameX2,m_dFrameY2,m_iFrameX2,m_iFrameY2);
		m_bLocked = FALSE;
		}

	m_bChanged6 = FALSE;

}

//*****************************************************************************
//*
//*		OnChange1
//*
//*****************************************************************************
void COsmFrameDlg::OnChange1() 
{
TCHAR		cText[64];
double		dValue;
int			iLen;	


	if(!m_bLocked)
		{
		m_bChanged1 = TRUE;

		GetDlgItemText(IDC_EDIT1,cText,128);
		dValue = TextToCoord(cText,&iLen);

		if(iLen>0 && dValue!=0.0 && cText[iLen]==',' && TextToCoord(cText+iLen+1)!=0.0)
			{
			iLen += strwlen(cText+iLen+1,0xE0);
			m_dFrameY1 = dValue;
			m_dFrameX1 = TextToCoord(cText+iLen+1);
			m_cOsmCtrl.CoordToPos(m_dFrameX1,m_dFrameY1,m_iFrameX1,m_iFrameY1);
			SetRect();
		
			m_bLocked   = TRUE;
			SetDlgItemText(IDC_EDIT2,cText+iLen+1);
			GetDlgItem(IDC_EDIT2)->SetFocus();
			CoordToText(m_dFrameY1,m_uCoordMode|1,cText);
			SetDlgItemText(IDC_EDIT1,cText);
			m_bLocked   = FALSE;
			m_bChanged1 = FALSE;
			m_bChanged2 = TRUE;
			}
		}

}

//*****************************************************************************
//*
//*		OnChange2
//*
//*****************************************************************************
void COsmFrameDlg::OnChange2() 
{

	if(!m_bLocked)
		{
		m_bChanged2 = TRUE;
		}

}

//*****************************************************************************
//*
//*		OnChange3
//*
//*****************************************************************************
void COsmFrameDlg::OnChange3() 
{
TCHAR		cText[64];
double		dValue;
int			iLen;	



	if(!m_bLocked)
		{
		m_bChanged3 = TRUE;

		GetDlgItemText(IDC_EDIT3,cText,128);
		dValue = TextToCoord(cText,&iLen);

		if(iLen>0 && dValue!=0.0 && cText[iLen]==',' && TextToCoord(cText+iLen+1)!=0.0)
			{
			iLen += strwlen(cText+iLen+1,0xE0);
			m_dFrameY2 = dValue;
			m_dFrameX2 = TextToCoord(cText+iLen+1);
			m_cOsmCtrl.CoordToPos(m_dFrameX2,m_dFrameY2,m_iFrameX2,m_iFrameY2);
			SetRect();
		
			m_bLocked   = TRUE;
			SetDlgItemText(IDC_EDIT2,cText+iLen+1);
			GetDlgItem(IDC_EDIT4)->SetFocus();
			CoordToText(m_dFrameY2,m_uCoordMode|1,cText);
			SetDlgItemText(IDC_EDIT3,cText);
			m_bLocked   = FALSE;
			m_bChanged3 = FALSE;
			m_bChanged4 = TRUE;
			}
		}

}

//*****************************************************************************
//*
//*		OnChange4
//*
//*****************************************************************************
void COsmFrameDlg::OnChange4() 
{

	if(!m_bLocked)
		{
		m_bChanged4 = TRUE;
		}

}


//*****************************************************************************
//*
//*		OnChange5
//*
//*****************************************************************************
void COsmFrameDlg::OnChange5() 
{

	if(!m_bLocked)
		{
		m_bChanged5 = TRUE;
		}
	
}

//*****************************************************************************
//*
//*		OnChange6
//*
//*****************************************************************************
void COsmFrameDlg::OnChange6() 
{

	if(!m_bLocked)
		{
		m_bChanged6 = TRUE;
		}

}

//*****************************************************************************
//*
//*		OnTimer
//*
//*****************************************************************************
void COsmFrameDlg::OnTimer(UINT_PTR nIdEvent)
{
CString		sText;
CString		sStatus;
double		dCoordX;
double		dCoordY;
CPoint		sPoint;
CPoint		sPixel;
CWnd	   *pWnd;	



	if(nIdEvent==ID_UPDATE)
		{
		GetCursorPos(&sPoint);

		sPixel = sPoint;
		m_cOsmCtrl.ScreenToClient(&sPixel);
		pWnd = CWnd::WindowFromPoint(sPoint); 

		if(m_cOsmCtrl.PtInClientRect(&sPixel) && pWnd && pWnd->m_hWnd==m_cOsmCtrl.m_hWnd)
			{
			m_cOsmCtrl.PixelToCoord(sPixel.x,sPixel.y,dCoordX,dCoordY);
			sStatus.Format(_T("Breite = %s   Lnge = %s"),CoordToText(dCoordY,m_uCoordMode|1),CoordToText(dCoordX,m_uCoordMode));
			}

		GetDlgItemText(IDC_TEXT1,sText);
		if(sText!=sStatus)SetDlgItemText(IDC_TEXT1,sStatus);


		return;
		}


	CDialog::OnTimer(nIdEvent);

}

//*****************************************************************************
//*
//*		WheelProc
//*
//*****************************************************************************
LRESULT CALLBACK COsmFrameDlg::WheelProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
WNDPROC		pProc;
HWND		hTemp;
	
	
	if(uMsg==WM_MOUSEWHEEL)
		{
		hTemp = ::GetParent  (hWnd);
		hTemp = ::GetDlgItem (hTemp,ID_OSMWND);
		return  ::SendMessage(hTemp,uMsg,wParam,lParam);
		}

	pProc = (WNDPROC)GetWindowLong(hWnd,GWL_USERDATA);


return CallWindowProc(pProc,hWnd,uMsg,wParam,lParam);
}

//*****************************************************************************
//*
//*		SetRect
//*
//*****************************************************************************
void COsmFrameDlg::SetRect(BOOL bOlnlyStatus)
{
CString		sStatus;
double		dDiffX;
double		dDiffY;


	if(m_iZoom>=0)
		{
		if(m_bFixed)
			{
			m_iFrameX2 = (m_iSizeX<<(OSM_ZOOM_BASE-OSM_AREA_BITS-m_iZoom))+m_iFrameX1;
			m_iFrameY2 = (m_iSizeY<<(OSM_ZOOM_BASE-OSM_AREA_BITS-m_iZoom))+m_iFrameY1;
			}
		else{
			m_iSizeX   = (m_iFrameX2-m_iFrameX1)>>(OSM_ZOOM_BASE-OSM_AREA_BITS-m_iZoom);
			m_iSizeY   = (m_iFrameY2-m_iFrameY1)>>(OSM_ZOOM_BASE-OSM_AREA_BITS-m_iZoom);
			}

		sStatus.Format(_T("Pixel : X=%i   Y=%i"),m_iSizeX,m_iSizeY);
		SetDlgItemText(IDC_TEXT3,sStatus);
		}
	else{
		m_iSizeX = 0;
		m_iSizeY = 0;
		}


	dDiffX = DistanceOfPointsEx(m_dFrameX1*0.017453292519943295769236907684886,m_dFrameY1*0.017453292519943295769236907684886,m_dFrameX2*0.017453292519943295769236907684886,m_dFrameY1*0.017453292519943295769236907684886);
	dDiffY = DistanceOfPointsEx(m_dFrameX1*0.017453292519943295769236907684886,m_dFrameY1*0.017453292519943295769236907684886,m_dFrameX1*0.017453292519943295769236907684886,m_dFrameY2*0.017453292519943295769236907684886);

	sStatus.Format(_T("Breite = %.3f km   Lnge = %.3f km"),dDiffX*0.001,dDiffY*0.001);
	SetDlgItemText(IDC_TEXT2,sStatus);


	if(!bOlnlyStatus)
		{
		m_cOsmCtrl.SetRect(m_iFrameX1,m_iFrameY1,m_iFrameX2,m_iFrameY2);
		}


}

//*****************************************************************************
//*
//*		OnCancel
//*
//*****************************************************************************
void COsmFrameDlg::OnCancel()
{

	
	if(m_bLocked)
		{
		m_cOsmCtrl.CancelAction();
		return;
		}

	
	GET_DLG_OLDSIZE()

	CDialog::OnCancel();


}


//*****************************************************************************
//*
//*		OnOK
//*
//*****************************************************************************
void COsmFrameDlg::OnOK()
{
double	dValue;
int		iValue;
int		iPosX1;
int		iPosX2;
int		iPosY1;
int		iPosY2;


	if(m_iSizeY<0)
		{
		iValue=m_iFrameY1;m_iFrameY1=m_iFrameY2;m_iFrameY2=iValue;
		dValue=m_dFrameY1;m_dFrameY1=m_dFrameY2;m_dFrameY2=dValue;
		m_iSizeY=-m_iSizeY;
		}

	if(m_iSizeX<0)
		{
		m_cOsmCtrl.PosToPixel(m_iFrameX1,m_iFrameY1,iPosX1,iPosY1);
		m_cOsmCtrl.PosToPixel(m_iFrameX2,m_iFrameY2,iPosX2,iPosY2);

		if(iPosX1>=iPosX2)
			{
			iValue=m_iFrameX1;m_iFrameX1=m_iFrameX2;m_iFrameX2=iValue;
			dValue=m_dFrameX1;m_dFrameX1=m_dFrameX2;m_dFrameX2=dValue;
			m_iSizeX=-m_iSizeX;
			}
		}

	GET_DLG_OLDSIZE()

	CDialog::OnOK();

}

//*****************************************************************************
//*
//*		OnFixed
//*
//*****************************************************************************
void COsmFrameDlg::OnFixed() 
{

	UpdateData();
	
	GetDlgItem(IDC_EDIT3)->ShowWindow((m_bFixed)? SW_HIDE:SW_SHOW);
	GetDlgItem(IDC_EDIT4)->ShowWindow((m_bFixed)? SW_HIDE:SW_SHOW);
	GetDlgItem(IDC_EDIT5)->ShowWindow((m_bFixed)? SW_SHOW:SW_HIDE);
	GetDlgItem(IDC_EDIT6)->ShowWindow((m_bFixed)? SW_SHOW:SW_HIDE);

	SetDlgItemText(IDC_TEXT5,(m_bFixed)? " Pixel X :":"Breite B :");
	SetDlgItemText(IDC_TEXT6,(m_bFixed)? " Pixel Y :":"Lng  B :" );

	m_cOsmCtrl.SetAction(0,(m_bFixed)? OSM_ACTION_PLACE:OSM_ACTION_RECT);

}

