//*****************************************************************************
//*
//*
//*		OsmServerDlg.cpp
//*
//*
//*****************************************************************************
#include	"StdAfx.h"
#include	"OsmViewer.h"
#include	"OsmServerDlg.h"
#include	"OsmSettingsDlg.h"
#include	"CoordFunctions.h"


#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif

#define 	 ID_SERVER		0x1206
#define 	 ID_LAYERS		0x1207
#define 	 ID_COPY_TEXT	0x1208

BEGIN_MESSAGE_MAP(COsmServerDlg, CDialog)
	//{{AFX_MSG_MAP(COsmServerDlg)
	ON_WM_DESTROY()
	ON_WM_CONTEXTMENU()
	ON_BN_CLICKED(IDC_UP2,		OnUpLayer)
	ON_BN_CLICKED(IDC_UP1,		OnUpServer)
	ON_BN_CLICKED(IDC_DOWN2, 	OnDownLayer)
	ON_BN_CLICKED(IDC_DOWN1, 	OnDownServer)
	ON_BN_CLICKED(IDC_DELETE1, 	OnDeleteServer)
	ON_BN_CLICKED(IDC_DELETE2, 	OnDeleteLayer)
	ON_BN_CLICKED(IDC_SETTINGS,	OnSettings)
	ON_BN_CLICKED(IDC_TESTURL,	OnTestUrl)
	ON_BN_CLICKED(IDC_DEFAULT,  OnDefault)
	ON_BN_CLICKED(IDC_IMPORT, 	OnImport)
	ON_BN_CLICKED(IDC_EXPORT, 	OnExport)
	ON_COMMAND(ID_COPY_TEXT,	OnCopyText)
	//}}AFX_MSG_MAP
	ON_NOTIFY(TVN_ENDLABELEDIT,ID_SERVER,OnEndLabelEdit)
	ON_NOTIFY(TVN_ENDLABELEDIT,ID_LAYERS,OnEndLabelEdit)
	ON_NOTIFY(TVN_SELCHANGED  ,ID_SERVER,OnSelChanged)
	ON_NOTIFY(TVN_SELCHANGED  ,ID_LAYERS,OnSelChanged)
	ON_NOTIFY(NM_SETFOCUS	  ,ID_SERVER,OnListFocus)
	ON_NOTIFY(NM_SETFOCUS	  ,ID_LAYERS,OnListFocus)
END_MESSAGE_MAP()


LPCTSTR	COsmServerDlg::m_aInterfaceNames[] =
	{
	"OSM",
	"ESRI",
	"YANDEX",
	"MAPY",
	0
	};

#define 	C(t,i)		CoordConvert(t,i)


//*****************************************************************************
//*
//*		CDialog
//*
//*****************************************************************************
//  Dialogfeld COsmServerDlg
COsmServerDlg::COsmServerDlg(CWnd *pParent): CDialog(COsmServerDlg::IDD,pParent)
{
	//{{AFX_DATA_INIT(COsmServerDlg)
	//}}AFX_DATA_INIT

	m_uCoordMode	= 0;
}


//*****************************************************************************
//*
//*		DoDataExchange
//*
//*****************************************************************************
void COsmServerDlg::DoDataExchange(CDataExchange *pDX)
{
	CDialog::DoDataExchange(pDX);

	//{{AFX_DATA_MAP(COsmServerDlg)
	//}}AFX_DATA_MAP
}


//*****************************************************************************
//*
//*		OnInitDialog
//*
//*****************************************************************************
//  Behandlungsroutinen fr Nachrichten COsmServerDlg
BOOL COsmServerDlg::OnInitDialog()
{
HTREEITEM	hItem;
CString		sText;
CString		sName;
CRegKeys	sKey;
int			iPos;
int			iSel;
int			iRow;


	m_pMenuWnd		=  0;
	m_hMenuItem		=  0;
	m_iCurrentList	= -1;

   	m_cServer.CreateEx(WS_EX_CLIENTEDGE,WS_CHILD|WS_VISIBLE|WS_TABSTOP|TVS_FULLROWSELECT|TVS_EDITLABELS|TVS_CHECKBOXES,IDC_FRAME1,this,ID_SERVER);
 	m_cLayers.CreateEx(WS_EX_CLIENTEDGE,WS_CHILD|WS_VISIBLE|WS_TABSTOP|TVS_FULLROWSELECT|TVS_EDITLABELS|TVS_CHECKBOXES,IDC_FRAME2,this,ID_LAYERS);

 	m_cServer.SetExtendedStyle(TVS_EX_HOMEENDSELECT|TVS_EX_EDITCLICK|TVS_EX_ITEMLINES|TVS_EX_ALTERNATECOLOR|TVS_EX_SUBSELECT|TVS_EX_ALWAYSSCROLLY|TVS_EX_AUTOHSCROLL|TVS_EX_SINGLECHECKBOX,TVS_EX_HOMEENDSELECT|TVS_EX_ITEMLINES|TVS_EX_ALTERNATECOLOR|TVS_EX_EDITCLICK|TVS_EX_SUBSELECT|TVS_EX_ALWAYSSCROLLY|TVS_EX_AUTOHSCROLL|TVS_EX_SINGLECHECKBOX);
 	m_cLayers.SetExtendedStyle(TVS_EX_HOMEENDSELECT|TVS_EX_EDITCLICK|TVS_EX_ITEMLINES|TVS_EX_ALTERNATECOLOR|TVS_EX_SUBSELECT|TVS_EX_ALWAYSSCROLLY|TVS_EX_AUTOHSCROLL                      ,TVS_EX_HOMEENDSELECT|TVS_EX_ITEMLINES|TVS_EX_ALTERNATECOLOR|TVS_EX_EDITCLICK|TVS_EX_SUBSELECT|TVS_EX_ALWAYSSCROLLY|TVS_EX_AUTOHSCROLL);

	m_cServer.InsertColumn( 0,_T("Name"	        ),TVCFMT_LEFT, -55);
	m_cServer.InsertColumn( 1,_T("Server"       ),TVCFMT_LEFT, -99);
	m_cServer.InsertColumn( 2,_T("Pfad"         ),TVCFMT_LEFT, -60);
	m_cServer.InsertColumn( 3,_T("Min. Zoom"    ),TVCFMT_RIGHT, 45);
	m_cServer.InsertColumn( 4,_T("Max. Zoom"    ),TVCFMT_RIGHT, 45);
	m_cServer.InsertColumn( 5,_T("Bereich X1"   ),TVCFMT_RIGHT, 80);
	m_cServer.InsertColumn( 6,_T("Bereich Y1"   ),TVCFMT_RIGHT, 80);
	m_cServer.InsertColumn( 7,_T("Bereich Y2"   ),TVCFMT_RIGHT, 80);
	m_cServer.InsertColumn( 8,_T("Bereich Y2"   ),TVCFMT_RIGHT, 80);
	m_cServer.InsertColumn( 9,_T("Fix"          ),TVCFMT_LEFT,  30);
	m_cServer.InsertColumn(10,_T("Interface"    ),TVCFMT_LEFT,  60);

	m_cLayers.InsertColumn( 0,_T("Name"	        ),TVCFMT_LEFT, -55);
	m_cLayers.InsertColumn( 1,_T("Server"       ),TVCFMT_LEFT, -99);
	m_cLayers.InsertColumn( 2,_T("Pfad"         ),TVCFMT_LEFT, -60);
	m_cLayers.InsertColumn( 3,_T("Alpha Offset" ),TVCFMT_RIGHT, 90);
	m_cLayers.InsertColumn( 4,_T("Alpha Scale"  ),TVCFMT_RIGHT, 90);
	m_cLayers.InsertColumn( 5,_T("Information"  ),TVCFMT_LEFT, 230);
	m_cLayers.InsertColumn( 6,_T("Fix"          ),TVCFMT_LEFT,  30);
	m_cLayers.InsertColumn( 7,_T("Interface"    ),TVCFMT_LEFT,  60);

	m_cServer.SetColumnAutoEdit( 0,TVAE_EDIT|TVAE_DBLCLICK|TVAE_FULLWIDTH);
	m_cServer.SetColumnAutoEdit( 1,TVAE_EDIT|TVAE_DBLCLICK|TVAE_FULLWIDTH);
	m_cServer.SetColumnAutoEdit( 2,TVAE_EDIT|TVAE_DBLCLICK|TVAE_FULLWIDTH);
	m_cServer.SetColumnAutoEdit( 3,TVAE_EDIT|TVAE_DBLCLICK|TVAE_FULLWIDTH);
	m_cServer.SetColumnAutoEdit( 4,TVAE_EDIT|TVAE_DBLCLICK|TVAE_FULLWIDTH);
	m_cServer.SetColumnAutoEdit( 5,TVAE_EDIT|TVAE_DBLCLICK|TVAE_FULLWIDTH);
	m_cServer.SetColumnAutoEdit( 6,TVAE_EDIT|TVAE_DBLCLICK|TVAE_FULLWIDTH);
	m_cServer.SetColumnAutoEdit( 7,TVAE_EDIT|TVAE_DBLCLICK|TVAE_FULLWIDTH);
	m_cServer.SetColumnAutoEdit( 8,TVAE_EDIT|TVAE_DBLCLICK|TVAE_FULLWIDTH);
	m_cServer.SetColumnAutoEdit( 9,TVAE_CHECK|TVAE_DBLCLICK|TVAE_ICONCLICK);
	m_cServer.SetColumnAutoEdit(10,TVAE_CBLIST|TVAE_DBLCLICK|TVAE_FULLWIDTH,m_aInterfaceNames);

	m_cLayers.SetColumnAutoEdit( 0,TVAE_EDIT|TVAE_DBLCLICK|TVAE_FULLWIDTH);
	m_cLayers.SetColumnAutoEdit( 1,TVAE_EDIT|TVAE_DBLCLICK|TVAE_FULLWIDTH);
	m_cLayers.SetColumnAutoEdit( 2,TVAE_EDIT|TVAE_DBLCLICK|TVAE_FULLWIDTH);
	m_cLayers.SetColumnAutoEdit( 3,TVAE_EDIT|TVAE_DBLCLICK|TVAE_FULLWIDTH);
	m_cLayers.SetColumnAutoEdit( 4,TVAE_EDIT|TVAE_DBLCLICK|TVAE_FULLWIDTH);
	m_cLayers.SetColumnAutoEdit( 5,TVAE_EDIT|TVAE_DBLCLICK|TVAE_FULLWIDTH);
	m_cLayers.SetColumnAutoEdit( 6,TVAE_CHECK|TVAE_DBLCLICK|TVAE_ICONCLICK);
	m_cLayers.SetColumnAutoEdit( 7,TVAE_CBLIST|TVAE_DBLCLICK|TVAE_FULLWIDTH,m_aInterfaceNames);


	sKey.Open();
	sKey.Up(_T("Server"));

	iRow = 0;
	sKey.Get(iRow,_T("Select"));

	for(iPos=0;iPos<100;iPos++)
		{
		sName.Format(_T("Name%02i"),iPos);
		sText.Empty();

		if(!sKey.Get(sText,sName))break;

		hItem = m_cServer.InsertItem(sText);

		sName.Format(_T("Server%02i"   ),iPos);	sText.Empty();	sKey.Get(sText,sName);				m_cServer.SetItemText(hItem,sText,1);
		sName.Format(_T("Path%02i"	   ),iPos);	sText.Empty();	sKey.Get(sText,sName);				m_cServer.SetItemText(hItem,sText,2);
		sName.Format(_T("ZoomMin%02i"  ),iPos);	sText.Empty();	sKey.Get(sText,sName);				m_cServer.SetItemText(hItem,sText,3);
		sName.Format(_T("ZoomMax%02i"  ),iPos);	sText.Empty();	sKey.Get(sText,sName);				m_cServer.SetItemText(hItem,sText,4);
		sName.Format(_T("AreaXA%02i"   ),iPos);	sText.Empty();	sKey.Get(sText,sName);	C(sText,0);	m_cServer.SetItemText(hItem,sText,5);
		sName.Format(_T("AreaYA%02i"   ),iPos);	sText.Empty();	sKey.Get(sText,sName);	C(sText,1);	m_cServer.SetItemText(hItem,sText,6);
		sName.Format(_T("AreaXB%02i"   ),iPos);	sText.Empty();	sKey.Get(sText,sName);	C(sText,0);	m_cServer.SetItemText(hItem,sText,7);
		sName.Format(_T("AreaYB%02i"   ),iPos);	sText.Empty();	sKey.Get(sText,sName);	C(sText,1);	m_cServer.SetItemText(hItem,sText,8);
		sName.Format(_T("Fixed%02i"    ),iPos);	iSel=0;			sKey.Get(iSel ,sName);	            m_cServer.SetCheck   (hItem,iSel ,9);
		sName.Format(_T("Interface%02i"),iPos);	iSel=0;			sKey.Get(iSel ,sName);	            m_cServer.SetItemText(hItem,m_aInterfaceNames[iSel],10);
		}

	if(iRow>=iPos || iRow<0)iRow=0;
	if(iPos>0)
		{
		hItem = m_cServer.GetItemOfRow(iRow);
		m_cServer.SetCheck(hItem,TRUE);
		m_cServer.EnsureVisible(hItem);
		}

	
	iRow			= -1;
	m_iServerCnt	= iPos;
	m_cServer.InsertItem(_T(""));

	sKey.Down();
	sKey.Up(_T("Layer"));

	for(iPos=0;iPos<100;iPos++)
		{
		sName.Format(_T("Name%02i"),iPos);
		sText.Empty();

		if(!sKey.Get(sText,sName))break;

		hItem = m_cLayers.InsertItem(sText);

		sName.Format(_T("Server%02i"   ),iPos);	sText.Empty();	sKey.Get(sText,sName);	m_cLayers.SetItemText(hItem,sText,1);
		sName.Format(_T("Path%02i"	   ),iPos);	sText.Empty();	sKey.Get(sText,sName);	m_cLayers.SetItemText(hItem,sText,2);
		sName.Format(_T("AlphaOff%02i" ),iPos);	sText.Empty();	sKey.Get(sText,sName);	m_cLayers.SetItemText(hItem,sText,3);
		sName.Format(_T("AlphaMul%02i" ),iPos);	sText.Empty();	sKey.Get(sText,sName);	m_cLayers.SetItemText(hItem,sText,4);
		sName.Format(_T("Info%02i"     ),iPos);	sText.Empty();	sKey.Get(sText,sName);	m_cLayers.SetItemText(hItem,sText,5);
		sName.Format(_T("Fixed%02i"    ),iPos);	iSel=0;			sKey.Get(iSel ,sName);	m_cLayers.SetCheck   (hItem,iSel ,6);
		sName.Format(_T("Interface%02i"),iPos);	iSel=0;			sKey.Get(iSel ,sName);	m_cLayers.SetItemText(hItem,m_aInterfaceNames[iSel],7);

		iSel = 0;
		sName.Format(_T("Select%02i"  ),iPos);
		sKey.Get(iSel,sName);
		
		if(iSel)
			{
			if(iRow<0)iRow=iPos;
			m_cLayers.SetCheck(hItem,TRUE);
			}
		}

	if(iRow>=0)
		{
		hItem = m_cLayers.GetItemOfRow(iRow);
		m_cLayers.EnsureVisible(hItem);
		}


	m_iLayersCnt	= iPos;
	m_cLayers.InsertItem(_T(""));

	CDialog::OnInitDialog();

	UpdatetKeys();



return TRUE;
}

//*****************************************************************************
//*
//*		OnDestroy
//*
//*****************************************************************************
void COsmServerDlg::OnDestroy()
{

	CDialog::OnDestroy();

}

//*****************************************************************************
//*
//*		OnUpServer
//*
//*****************************************************************************
void COsmServerDlg::OnUpServer()
{
HTREEITEM	hItem;
HTREEITEM	hNext;
HTREEITEM	hPrev;



		hItem = m_cServer.GetFocusItem();
	if(!hItem)return;

		hNext = m_cServer.GetNextSiblingItem(hItem);
	if(!hNext)return;

		hPrev = m_cServer.GetPrevSiblingItem(hItem);
	if(!hPrev)return;


	m_cServer.MoveItem(hItem,hPrev);
	UpdatetKeys();

}

//*****************************************************************************
//*
//*		OnUpLayer
//*
//*****************************************************************************
void COsmServerDlg::OnUpLayer()
{
HTREEITEM	hItem;
HTREEITEM	hNext;
HTREEITEM	hPrev;



		hItem = m_cLayers.GetFocusItem();
	if(!hItem)return;

		hNext = m_cLayers.GetNextSiblingItem(hItem);
	if(!hNext)return;

		hPrev = m_cLayers.GetPrevSiblingItem(hItem);
	if(!hPrev)return;


	m_cLayers.MoveItem(hItem,hPrev);
	UpdatetKeys();


}

//*****************************************************************************
//*
//*		OnDownServer
//*
//*****************************************************************************
void COsmServerDlg::OnDownServer()
{
HTREEITEM	hItem;
HTREEITEM	hNext;
HTREEITEM	hLast;



		hItem = m_cServer.GetFocusItem();
	if(!hItem)return;

		hNext = m_cServer.GetNextSiblingItem(hItem);
	if(!hNext)return;

		hLast = m_cServer.GetNextSiblingItem(hNext);
	if(!hLast)return;


	m_cServer.MoveItem(hItem,hLast);
	UpdatetKeys();

}

//*****************************************************************************
//*
//*		OnDownLayer
//*
//*****************************************************************************
void COsmServerDlg::OnDownLayer()
{
HTREEITEM	hItem;
HTREEITEM	hNext;
HTREEITEM	hLast;



		hItem = m_cLayers.GetFocusItem();
	if(!hItem)return;

		hNext = m_cLayers.GetNextSiblingItem(hItem);
	if(!hNext)return;

		hLast = m_cLayers.GetNextSiblingItem(hNext);
	if(!hLast)return;


	m_cLayers.MoveItem(hItem,hLast);
	UpdatetKeys();


}

//*****************************************************************************
//*
//*		OnDeleteServer
//*
//*****************************************************************************
void COsmServerDlg::OnDeleteServer()
{
HTREEITEM	hItem;
HTREEITEM	hNext;



		hItem = m_cServer.GetFocusItem();
	if(!hItem)return;

		hNext = m_cServer.GetNextSiblingItem(hItem);
	if(!hNext)return;


	m_cServer.DeleteItem(hItem);
	UpdatetKeys();


}

//*****************************************************************************
//*
//*		OnDeleteLayer
//*
//*****************************************************************************
void COsmServerDlg::OnDeleteLayer()
{
HTREEITEM	hItem;
HTREEITEM	hNext;



		hItem = m_cLayers.GetFocusItem();
	if(!hItem)return;

		hNext = m_cLayers.GetNextSiblingItem(hItem);
	if(!hNext)return;


	m_cLayers.DeleteItem(hItem);
	UpdatetKeys();


}

//*****************************************************************************
//*
//*		OnImport
//*
//*****************************************************************************
void COsmServerDlg::OnImport()
{
char		cText[2048];
TCHAR		cName[256];
FILE	   *pFile;
HTREEITEM	hItem;
HTREEITEM	hLast;
HTREEITEM	hNext;
CString		sName;
CString		sText;
int			iChar;
int			iLine;
int			iRet;
int			iPos;
int			iLen;
int			iCol;


	CFileDialog	sFile(TRUE,_T("*.csv"),sName,OFN_EXPLORER|OFN_ENABLESIZING|OFN_PATHMUSTEXIST|OFN_HIDEREADONLY,_T("CSV-Dateien (*.csv)|*.csv|Textdateien (*.txt)|*.txt|Alle Dateien|*.*|"));


	   sFile.m_ofn.lpstrTitle=_T("Server-Liste importieren");
	if(sFile.DoModal()!=IDOK)return;

	sName =	sFile.GetPathName();

		pFile = fopen(sName,"rb");
	if(!pFile)
		{
		sText.Format(_T("Die Datei '%s' konnte nicht geffnet werden ?"),(LPCTSTR)sName);
		MessageBox(sText,"Fehler",MB_YESNO|MB_ICONERROR|MB_DEFBUTTON2);
		return;
		}

	iChar	= (GetFileType(sName,_T("txt")))? '\t':';';
	iRet	= MessageBox(_T("Alte Server-Liste lschen ?"),_T("Frage"),MB_YESNOCANCEL);

	if(iRet==IDCANCEL)
		{
		fclose(pFile);
		return;
		}

	if(iRet==IDYES)
		{
		m_cServer.DeleteAllItems();
		m_cServer.InsertItem(_T(""));
		m_cLayers.DeleteAllItems();
		m_cLayers.InsertItem(_T(""));
		}

	cText[sizeof(cText)-1] = 0 ;

	hNext	= m_cServer.GetLastChild(TVI_ROOT);
	hLast	= m_cLayers.GetLastChild(TVI_ROOT);
	iLine	= 0;

	while(fgets(cText,sizeof(cText)-1,pFile))
		{
		iLen = strcwlen(cText,0x40);
		cText[iLen] = 0;
		iLine++;

		if(iLine>200)break;

		if(cText[0]=='*')
			{
			iPos = 1;
			iLen = strchar(cText+iPos,iChar);

			strawcpy(cName,cText+iPos,256,iLen);
			hItem = m_cLayers.InsertItem(cName,hLast,TVI_BEFORE);

			for(iCol=1;iCol<=7;iCol++)
				{
				iPos += iLen;
				if(cText[iPos]!=iChar)break;
				iPos += 1;
				iLen  = strchar(cText+iPos,iChar);
				strawcpy(cName,cText+iPos,256,iLen);
				if(iCol>=5 && iCol<=8)CoordConvert(cName,(iCol^1)&1);
				
				if(iPos==7)
					{
					m_cLayers.SetCheck(hItem,atoi(cName),iCol);
					}
				else{
					m_cLayers.SetItemText(hItem,cName,iCol);
					}
				}
			}
		else{
			iPos = 0;
			iLen = strchar(cText+iPos,iChar);

			strawcpy(cName,cText+iPos,256,iLen);
			hItem = m_cServer.InsertItem(cName,hNext,TVI_BEFORE);

			for(iCol=1;iCol<=7;iCol++)
				{
				iPos += iLen;
				if(cText[iPos]!=iChar)break;
				iPos += 1;
				iLen  = strchar(cText+iPos,iChar);
				strawcpy(cName,cText+iPos,256,iLen);

				if(iPos==10)
					{
					m_cServer.SetCheck(hItem,atoi(cName),iCol);
					}
				else{
					m_cServer.SetItemText(hItem,cName,iCol);
					}
				}
			}
		}

	fclose(pFile);


}

//*****************************************************************************
//*
//*		OnExport
//*
//*****************************************************************************
void COsmServerDlg::OnExport()
{
char		cText[256];
FILE	   *pFile;
HTREEITEM	hItem;
HTREEITEM	hNext;
LPCTSTR		pText;
CString		sName;
CString		sText;
int			iChar;
int			iRet;
int			iPos;


	CFileDialog	sFile(FALSE,_T("*.csv"),sName,OFN_EXPLORER|OFN_ENABLESIZING|OFN_PATHMUSTEXIST|OFN_HIDEREADONLY,_T("CSV-Dateien (*.csv)|*.csv|Textdateien (*.txt)|*.txt|Alle Dateien|*.*|"));


	   sFile.m_ofn.lpstrTitle=_T("Server-Liste exportieren");
	if(sFile.DoModal()!=IDOK)return;

	sName =	sFile.GetPathName();

	if(ExistFile(sName)==1)
		{
		sText.Format(_T("Die Datei '%s' existiert bereits, soll sie berschrieben werden ?"),(LPCTSTR)sName);
		iRet = MessageBox(sText,_T("Frage"),MB_YESNO|MB_ICONQUESTION|MB_DEFBUTTON2);
		if(iRet!=IDYES)return;
		}

		pFile = _tfopen(sName,_T("wb"));
	if(!pFile)
		{
		sText.Format(_T("Die Datei '%s' konnte nicht erstellt werden ?"),(LPCTSTR)sName);
		MessageBox(sText,_T("Fehler"),MB_YESNO|MB_ICONERROR|MB_DEFBUTTON2);
		return;
		}

	iChar	= (GetFileType(sName,_T("txt")))? '\t':';';

	hItem	= m_cServer.GetFirstItem();

	while(hItem)
		{
			hNext = m_cServer.GetNextSiblingItem(hItem);
		if(!hNext)break;

		for(iPos=0;iPos<=10;iPos++)
			{
			if(iPos==9)
				{
				pText = m_cServer.GetCheck(hItem,9)? "1":"0";
				}
			else{
				pText = m_cServer.GetItemText(hItem,iPos);
				}
			strawcpy  (cText,pText,sizeof(cText),_tcslen(pText));
			strreplace(cText,'"','\'');
			strreplace(cText,';',',' );
			if(iPos>=5 && iPos<=8)CoordConvert(cText,(iPos^1)&1,0);
			fprintf(pFile,"%s%c",cText,iChar);
			}

		fprintf(pFile,"\n");
		hItem = hNext;
		}


	hItem	= m_cLayers.GetFirstItem();

	while(hItem)
		{
			hNext = m_cLayers.GetNextSiblingItem(hItem);
		if(!hNext)break;

		for(iPos=0;iPos<=7;iPos++)
			{
			if(iPos==6)
				{
				pText = m_cLayers.GetCheck(hItem,9)? "1":"0";
				}
			else{
				pText = m_cLayers.GetItemText(hItem,iPos);
				}

			strawcpy  (cText,pText,sizeof(cText),_tcslen(pText));
			strreplace(cText,'"','\'');
			strreplace(cText,';',',' );
			fprintf(pFile,"%s%s%c",(iPos)? "":"*",cText,iChar);
			}

		fprintf(pFile,"\n");
		hItem = hNext;
		}

	fclose(pFile);



}

//*****************************************************************************
//*
//*		OnCancel
//*
//*****************************************************************************
void COsmServerDlg::OnCancel()
{

	CDialog::OnCancel();
}

//*****************************************************************************
//*
//*		OnOK
//*
//*****************************************************************************
void COsmServerDlg::OnOK()
{
BOOL		bChanged;
HTREEITEM	hItem;
LPCTSTR		pText;
CString		sText;
CString		sName;
CRegKeys	sKey;
int			iPos;
int			iRow;
int			iSel;
int			iMax;
int			iNow;


	bChanged = FALSE;

	sKey.Open();
	sKey.Up(_T("Server"));

	iRow =-1;
	iSel = 0;
	iMax = m_cServer.GetCount()-1;

	if(!iMax)												// Keine Server vorhanden
		{
		CDialog::OnCancel();
		return;
		}



	for(iPos=0;iPos<iMax;iPos++)							// Hat sich bei den Servern etwas verndert
		{
		hItem = m_cServer.GetItemOfRow(iPos);

		sName.Format(_T("Name%02i"     ),iPos);	sText.Empty();	sKey.Get(sText,sName);				pText=m_cServer.GetItemText(hItem, 0); if(sText!=pText){sKey.Set(pText,sName);bChanged=TRUE;}
		sName.Format(_T("Server%02i"   ),iPos);	sText.Empty();	sKey.Get(sText,sName);				pText=m_cServer.GetItemText(hItem, 1); if(sText!=pText){sKey.Set(pText,sName);bChanged=TRUE;}
		sName.Format(_T("Path%02i"     ),iPos);	sText.Empty();	sKey.Get(sText,sName);				pText=m_cServer.GetItemText(hItem, 2); if(sText!=pText){sKey.Set(pText,sName);bChanged=TRUE;}
		sName.Format(_T("ZoomMin%02i"  ),iPos);	sText.Empty();	sKey.Get(sText,sName);				pText=m_cServer.GetItemText(hItem, 3); if(sText!=pText){sKey.Set(pText,sName);bChanged=TRUE;}
		sName.Format(_T("ZoomMax%02i"  ),iPos);	sText.Empty();	sKey.Get(sText,sName);				pText=m_cServer.GetItemText(hItem, 4); if(sText!=pText){sKey.Set(pText,sName);bChanged=TRUE;}
		sName.Format(_T("AreaXA%02i"   ),iPos);	sText.Empty();	sKey.Get(sText,sName);	C(sText,0);	pText=m_cServer.GetItemText(hItem, 5); if(sText!=pText){sKey.Set(pText,sName);bChanged=TRUE;}
		sName.Format(_T("AreaYA%02i"   ),iPos);	sText.Empty();	sKey.Get(sText,sName);	C(sText,0);	pText=m_cServer.GetItemText(hItem, 6); if(sText!=pText){sKey.Set(pText,sName);bChanged=TRUE;}
		sName.Format(_T("AreaXB%02i"   ),iPos);	sText.Empty();	sKey.Get(sText,sName);	C(sText,0);	pText=m_cServer.GetItemText(hItem, 7); if(sText!=pText){sKey.Set(pText,sName);bChanged=TRUE;}
		sName.Format(_T("AreaYB%02i"   ),iPos);	sText.Empty();	sKey.Get(sText,sName);	C(sText,0);	pText=m_cServer.GetItemText(hItem, 8); if(sText!=pText){sKey.Set(pText,sName);bChanged=TRUE;}
		sName.Format(_T("Fixed%02i"    ),iPos);	iSel=0;			sKey.Get(iSel ,sName);				iNow =m_cServer.GetCheck   (hItem, 9); if(iSel !=iNow ){sKey.Set(iNow ,sName);bChanged=TRUE;}
		sName.Format(_T("Interface%02i"),iPos);	iSel=0;			sKey.Get(iSel ,sName);	iNow = strsubtext(m_cServer.GetItemText(hItem,10),m_aInterfaceNames); if(iSel!=iNow){if(iNow<0)iNow=0;sKey.Set(iNow,sName);bChanged=TRUE;}

		if(m_cServer.GetCheck(hItem)) iRow=iPos;
		}


	sKey.Get(iSel,_T("Select"));

	if(iRow!=iSel)
		{
		bChanged = TRUE;
		if(iRow<0)iRow=0;
		sKey.Set(iRow,_T("Select"));
		}

	for(;iPos<m_iServerCnt;iPos++)							// Alte Eintrge lschen
		{
		bChanged = TRUE;

		sName.Format(_T("Name%02i"     ),iPos);	sKey.Del(sName);
		sName.Format(_T("Server%02i"   ),iPos);	sKey.Del(sName);
		sName.Format(_T("Path%02i"     ),iPos);	sKey.Del(sName);
		sName.Format(_T("ZoomMin%02i"  ),iPos);	sKey.Del(sName);
		sName.Format(_T("ZoomMax%02i"  ),iPos);	sKey.Del(sName);
		sName.Format(_T("AreaXA%02i"   ),iPos);	sKey.Del(sName);
		sName.Format(_T("AreaYA%02i"   ),iPos);	sKey.Del(sName);
		sName.Format(_T("AreaXB%02i"   ),iPos);	sKey.Del(sName);
		sName.Format(_T("AreaYB%02i"   ),iPos);	sKey.Del(sName);
		sName.Format(_T("Interface%02i"),iPos);	sKey.Del(sName);
		}

	sKey.Down();
	sKey.Up(_T("Layer"));

	iMax = m_cLayers.GetCount()-1;

	for(iPos=0;iPos<iMax;iPos++)							// Hat sich bei den Layern ewtas verndert
		{
		hItem = m_cLayers.GetItemOfRow(iPos);

		sName.Format(_T("Name%02i"     ),iPos);	sText.Empty();	sKey.Get(sText,sName);	pText=m_cLayers.GetItemText(hItem,0); if(sText!=pText){sKey.Set(pText,sName);bChanged=TRUE;}
		sName.Format(_T("Server%02i"   ),iPos);	sText.Empty();	sKey.Get(sText,sName);	pText=m_cLayers.GetItemText(hItem,1); if(sText!=pText){sKey.Set(pText,sName);bChanged=TRUE;}
		sName.Format(_T("Path%02i"     ),iPos);	sText.Empty();	sKey.Get(sText,sName);	pText=m_cLayers.GetItemText(hItem,2); if(sText!=pText){sKey.Set(pText,sName);bChanged=TRUE;}
		sName.Format(_T("AlphaOff%02i" ),iPos);	sText.Empty();	sKey.Get(sText,sName);	pText=m_cLayers.GetItemText(hItem,3); if(sText!=pText){sKey.Set(pText,sName);bChanged=TRUE;}
		sName.Format(_T("AlphaMul%02i" ),iPos);	sText.Empty();	sKey.Get(sText,sName);	pText=m_cLayers.GetItemText(hItem,4); if(sText!=pText){sKey.Set(pText,sName);bChanged=TRUE;}
		sName.Format(_T("Info%02i"     ),iPos);	sText.Empty();	sKey.Get(sText,sName);	pText=m_cLayers.GetItemText(hItem,5); if(sText!=pText){sKey.Set(pText,sName);bChanged=TRUE;}
		sName.Format(_T("Fixed%02i"    ),iPos);	iSel=0;			sKey.Get(iSel ,sName);	iNow =m_cLayers.GetCheck   (hItem,6); if(iSel !=iNow ){sKey.Set(iNow ,sName);bChanged=TRUE;}
		sName.Format(_T("Interface%02i"),iPos);	iSel=0;			sKey.Get(iSel ,sName);	iNow = strsubtext(m_cLayers.GetItemText(hItem,7),m_aInterfaceNames); if(iSel!=iNow){if(iNow<0)iNow=0;sKey.Set(iNow,sName);bChanged=TRUE;}
		sName.Format(_T("Select%02i"   ),iPos);	iSel=0;			sKey.Get(iSel ,sName);	iNow =m_cLayers.GetCheck   (hItem  ); if(iSel !=iNow ){sKey.Set(iNow ,sName);bChanged=TRUE;}
		}

	for(;iPos<m_iLayersCnt;iPos++)							// Alte Eintrge lschen
		{
		bChanged = TRUE;

		sName.Format(_T("Name%02i"     ),iPos);	sKey.Del(sName);
		sName.Format(_T("Server%02i"   ),iPos);	sKey.Del(sName);
		sName.Format(_T("Path%02i"     ),iPos);	sKey.Del(sName);
		sName.Format(_T("AlphaOff%02i" ),iPos);	sKey.Del(sName);
		sName.Format(_T("ZoomMax%02i"  ),iPos);	sKey.Del(sName);
		sName.Format(_T("AlphaMul%02i" ),iPos);	sKey.Del(sName);
		sName.Format(_T("Info%02i"     ),iPos);	sKey.Del(sName);
		sName.Format(_T("Select%02i"   ),iPos);	sKey.Del(sName);
		sName.Format(_T("Interface%02i"),iPos);	sKey.Del(sName);
		}

	if(bChanged)
		{
		CDialog::OnOK();
		}
	else{
		CDialog::OnCancel();
		}


}


//*****************************************************************************
//*
//*		OnDefault
//*
//*****************************************************************************
void COsmServerDlg::OnDefault()
{
HTREEITEM	hItem;
LPCTSTR		pText;
CRegKeys	sKey;



	if(MessageBox(_T("Sollen wirklich die Standarteinstellungen wiederhergestellt werden ?"),_T("Frage"),MB_OKCANCEL|MB_ICONQUESTION)!=IDOK)
		{
		return;
		}
	
	   hItem = m_cServer.GetFirstChecked();
	if(hItem)
		{
		   pText = m_cServer.GetItemText(hItem);
		if(pText)m_sSelected=pText;
		}
	
	sKey.Open();
	sKey.DelKey(_T("Server"));
	sKey.DelKey(_T("Layer" ));


	CDialog::OnOK();

}

//*****************************************************************************
//*
//*		OnSettings
//*
//*****************************************************************************
void COsmServerDlg::OnSettings()
{
CTreeListCtrl  *pTree;
HTREEITEM		hItem;
COsmSettingsDlg	sDlg;



	pTree = (m_iCurrentList)? &m_cLayers:&m_cServer;
	hItem = pTree->GetFocusItem();

	if(!hItem)
		{
		MessageBox(_T("Es ist kein Eintrag ausgewhlt !"),_T("Fehler"),MB_OK|MB_ICONERROR);
		return;
		}


	sDlg.m_sFull = pTree->GetItemText(hItem,2);

	if(sDlg.DoModal()!=IDOK)return;

	pTree->SetItemText(hItem,sDlg.m_sFull,2);
		

}

//*****************************************************************************
//*
//*		OnTestUrl
//*
//*****************************************************************************
void COsmServerDlg::OnTestUrl()
{
TCHAR			cSuffix[1024];
CTreeListCtrl  *pTree;
HTREEITEM		hItem;
LPCTSTR			pBase;
LPCTSTR			pPath;
LPCTSTR			pName;
CString			sUrl;
INT				iLen;
CTextDlg		sDlg;




	pTree = (m_iCurrentList)? &m_cLayers:&m_cServer;
	hItem = pTree->GetFocusItem();

	if(!hItem)
		{
		MessageBox(_T("Es ist kein Eintrag ausgewhlt !"),_T("Fehler"),MB_OK|MB_ICONERROR);
		return;
		}


	pBase = pTree->GetItemText(hItem,1);
	pPath = pTree->GetItemText(hItem,2);

	if(*pPath=='/')pPath++;

	pName = GetFileName(pPath);


	if(pName[0]=='*' && pName-pPath>0)				// Ist ein Suffix angehngt "cycle/*.png?apikey=6170aad10dfd42a38d4d8c709a536f38"
		{
		strawcpy(cSuffix,pName+1,1024);
		iLen = pName-pPath-1;
		}
	else if(pName[0]=='?' && pName-pPath>0)			// Sind Parameter angehngt "cycle/?apikey=6170aad10dfd42a38d4d8c709a536f38"	
		{
		strlcpy (cSuffix,".png" ,16);
		strawcpy(cSuffix+4,pName,1020);
		iLen = pName-pPath-1;
		}
	else{											// Keine Parameter angehngt "tiles/1.0.0/osm"	 	
		iLen = _tcslen(pPath);
		strcpy(cSuffix,".png");
		}


	pName = pTree->GetItemText(hItem,(m_iCurrentList>0)? 7:10);

	if(!_tcsicmp(pName,_T("MAPY")))	
		{
		sUrl.Format(_T("http://%s/%.*s%s%u-%u-%u"),pBase,iLen,pPath,(iLen>0)? "/":"",12,0x08B2,0x059D,cSuffix);
		}
	else if(!_tcsicmp(pName,_T("YANDEX")))
		{
		sUrl.Format(_T("http://%s/%.*s&x=%i&y=%i&z=%i"),pBase,iLen,pPath,0x08B2,0x059D,12);
		}
	else if(!_tcsicmp(pName,_T("ESRI")))
		{
		sUrl.Format(_T("http://%s/%.*s%s%u/%u/%u%s"),pBase,iLen,pPath,(iLen>0)? "/":"",12,0x059D,0x08B2,cSuffix);
		}
	else{
		sUrl.Format(_T("http://%s/%.*s%s%u/%u/%u%s"),pBase,iLen,pPath,(iLen>0)? "/":"",12,0x08B2,0x059D,cSuffix);
		}
		

	sDlg.SetTitle(_T("Test URL"));
	sDlg.SetTextTitle(_T("Das ist eine Beispiel URL :"));
	sDlg.SetText(sUrl);
	sDlg.AddSizeX(250);
	sDlg.DoModal();			

}


//*****************************************************************************
//*
//*		OnListFocus
//*
//*****************************************************************************
void COsmServerDlg::OnListFocus(NMHDR *pNmHdr,LRESULT *pResult)
{

	if(m_iCurrentList<0)
		{
		GetDlgItem(IDC_SETTINGS)->EnableWindow(TRUE);
		GetDlgItem(IDC_TESTURL )->EnableWindow(TRUE);
		}

	m_iCurrentList = (pNmHdr->idFrom==ID_SERVER)? 0:1;

}

//*****************************************************************************
//*
//*		OnSelChanged
//*
//*****************************************************************************
void COsmServerDlg::OnSelChanged(NMHDR *pNmHdr,LRESULT *pResult)
{

	UpdatetKeys();

}


//*****************************************************************************
//*
//*		OnEndLabelEdit
//*
//*****************************************************************************
void COsmServerDlg::OnEndLabelEdit(NMHDR *pNmHdr,LRESULT *pResult)
{
NMTVDISPINFO   *pItem = (NMTVDISPINFO*)pNmHdr;
CTreeListCtrl  *pList;
LPCTSTR			pText;
HTREEITEM		hNext;
HTREEITEM		hItem;
int				iSub;
int				iPos;
int				iLen;



	*pResult = 0;


    if(!(pItem->item.mask&TVIF_TEXTCHANGED))
        {
        return;
        }


	pList	= (pItem->hdr.idFrom==ID_SERVER)? &m_cServer:&m_cLayers;
	hItem	=  pItem->item.hItem;
	iSub	=  pItem->item.cChildren;

	if(iSub>=5 && iSub<=8 && pItem->hdr.idFrom==ID_SERVER)	// Koordinaten anpassen
		{
		if(!(iSub&1))
			{
			LPTSTR	pTemp;

			pTemp = pItem->item.pszText;

			TextToCoord(pTemp,&iLen);
															// Y und X eingegeben
			if(iLen>0 && pTemp[iLen]==',' && TextToCoord(pTemp+iLen+1)!=0.0)
				{
				iLen += 1;
				iLen += strwlen(pTemp+iLen,0xE0);

				CoordConvert(pItem->item.pszText+iLen,iSub&1);
				pList->SetItemText(hItem,pItem->item.pszText+iLen,iSub-1);
				pItem->item.pszText[iLen] = 0;
				}
			else if(iLen>0 && TextToCoord(pTemp+iLen)!=0.0)
				{
				iLen += strwlen(pTemp+iLen,0xE0);

				CoordConvert(pItem->item.pszText+iLen,iSub&1);
				pList->SetItemText(hItem,pItem->item.pszText+iLen,iSub-1);
				pItem->item.pszText[iLen] = 0;
				}
			}

		CoordConvert(pItem->item.pszText,(iSub^1)&1);
		}


	if(pItem->item.pszText[0]==0)							// Den Eintrag lschen
		{
			hNext=pList->GetNextItem(hItem);
		if(!hNext)return;

		for(iPos=0;iPos<3;iPos++)
			{
			if( iPos==iSub)continue;
			    pText = pList->GetItemText(hItem,iPos);
			if(*pText)break;
			}

		if(iPos>=3)
			{
			pList->DeleteItem(hItem);
			pList->SelectItem(hNext);
			}

		UpdatetKeys();
		}
	else{													// Neue leer Zeile am Ende
		if(!pList->GetNextItem(hItem))
			{
			if(pItem->hdr.idFrom==ID_SERVER)
				{
					pText = pList->GetItemText(hItem,10);
				if(!pText || !*pText)pList->SetItemText(hItem,m_aInterfaceNames[0],10);
				if(!pList->GetCheck(hItem,9))pList->SetCheck(hItem,0,9);
				}
			else{
					pText = pList->GetItemText(hItem,7);
				if(!pText || !*pText)pList->SetItemText(hItem,m_aInterfaceNames[0],7);
				if(!pList->GetCheck(hItem,6))pList->SetCheck(hItem,0,6);
				}

			pList->InsertItem("");
			UpdatetKeys();
			}
		}


}


//*****************************************************************************
//*
//*		UpdatetKeys
//*
//*****************************************************************************
void COsmServerDlg::UpdatetKeys()
{
HTREEITEM	hItem;
HTREEITEM	hNext;
HTREEITEM	hLast;
HTREEITEM	hPrev;



	hItem = m_cServer.GetFocusItem();
	hPrev = m_cServer.GetPrevSiblingItem(hItem);
	hNext = m_cServer.GetNextSiblingItem(hItem);
	hLast = m_cServer.GetNextSiblingItem(hNext);

	GetDlgItem(IDC_UP1    )->EnableWindow(hItem && hPrev && hNext);
	GetDlgItem(IDC_DOWN1  )->EnableWindow(hItem && hNext && hLast);
	GetDlgItem(IDC_DELETE1)->EnableWindow(hItem && hNext);

	hItem = m_cLayers.GetFocusItem();
	hPrev = m_cLayers.GetPrevSiblingItem(hItem);
	hNext = m_cLayers.GetNextSiblingItem(hItem);
	hLast = m_cLayers.GetNextSiblingItem(hNext);

	GetDlgItem(IDC_UP2    )->EnableWindow(hItem && hPrev && hNext);
	GetDlgItem(IDC_DOWN2  )->EnableWindow(hItem && hNext && hLast);
	GetDlgItem(IDC_DELETE2)->EnableWindow(hItem && hNext);


}

//*****************************************************************************
//*
//*		CoordConvert
//*
//*****************************************************************************
void COsmServerDlg::CoordConvert(LPTSTR pText,int iSel,int iMode)
{
double	dCoord;


	if(iMode<0)
			iMode =m_uCoordMode+iSel;
	else	iMode+=iSel;

	dCoord = TextToCoord(pText);

	if(dCoord==0.0)
		{
		pText[0]=0;
		}
	else{
		CoordToText(dCoord,iMode,pText);
		}


}


//*****************************************************************************
//*
//*		CoordConvert
//*
//*****************************************************************************
void COsmServerDlg::CoordConvert(CString &sText,int iSel,int iMode)
{
LPTSTR	pText;


	pText = sText.GetBuffer(256);
	CoordConvert(pText,iSel,iMode);
	sText.ReleaseBuffer();

}

//*****************************************************************************
//*
//*		OnContextMenu
//*
//*****************************************************************************
void COsmServerDlg::OnContextMenu(CWnd *pWnd,CPoint sPoint)
{
unsigned	uFlag;
CMenu		sMenu;

	if(!pWnd)return;


	if(pWnd->m_hWnd==m_cServer.m_hWnd)					// Im Server-Fenster
		{
		m_pMenuWnd = &m_cServer;
		}
	else if(pWnd->m_hWnd==m_cLayers.m_hWnd)				// Im Layer-Fenster
		{
		m_pMenuWnd = &m_cLayers;
		}
	else{												// Kein Fenster
		m_hMenuItem	= NULL;
		m_pMenuWnd  = NULL;
		return;	
		}

	m_hMenuItem =  m_pMenuWnd->GetFocusItem();
	m_iMenuCol  =  m_pMenuWnd->GetFocusColumn();
	uFlag		= (m_hMenuItem)? 0:MF_GRAYED;

	sMenu.CreatePopupMenu();

	sMenu.AppendMenu(MF_STRING,ID_COPY_TEXT	,_T("Feld kopieren"));
	sMenu.TrackPopupMenu(uFlag,sPoint.x,sPoint.y,this);
	sMenu.DestroyMenu();


}

//*****************************************************************************
//*
//*		OnCopyText
//*
//*****************************************************************************
void COsmServerDlg::OnCopyText()
{
LPCTSTR		pText;


	if(!m_pMenuWnd || !m_hMenuItem)
		{
		return;
		}
	
		pText = m_pMenuWnd->GetItemText(m_hMenuItem,m_iMenuCol);
	if(!pText)
		{
		m_pMenuWnd = 0;
		return;
		}

	SetClipboardText(pText);

	m_pMenuWnd = 0;


}