//*****************************************************************************
//*
//*
//*		OsmSettingsDlg.cpp
//*
//*
//*****************************************************************************
#include	"StdAfx.h"
#include	"OsmViewer.h"
#include	"OsmSettingsDlg.h"

#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif

BEGIN_MESSAGE_MAP(COsmSettingsDlg, CDialog)
	//{{AFX_MSG_MAP(COsmSettingsDlg)
	ON_EN_CHANGE (IDC_EDIT2 ,OnChange)
	ON_EN_CHANGE (IDC_EDIT3 ,OnChange)
	ON_EN_CHANGE (IDC_EDIT4 ,OnChange)
	ON_BN_CLICKED(IDC_RADIO1,OnChange)
	ON_BN_CLICKED(IDC_RADIO2,OnChange)
	ON_BN_CLICKED(IDC_RADIO3,OnChange)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


DLG_OLDPOS(COsmSettingsDlg)


//*****************************************************************************
//*
//*		CDialog
//*
//*****************************************************************************
//  Dialogfeld COsmSettingsDlg
COsmSettingsDlg::COsmSettingsDlg(CWnd *pParent): CDialog(COsmSettingsDlg::IDD,pParent)
{
	//{{AFX_DATA_INIT(COsmSettingsDlg)
	m_sFull 	=  _T("");
	m_sPath 	=  _T("");
	m_sExtra	=  _T("");
	m_sApiKey	=  _T("");
	m_iSuffix	=  0;
	//}}AFX_DATA_INIT
}


//*****************************************************************************
//*
//*		DoDataExchange
//*
//*****************************************************************************
void COsmSettingsDlg::DoDataExchange(CDataExchange *pDX)
{

	CDialog::DoDataExchange(pDX);

	//{{AFX_DATA_MAP(COsmSettingsDlg)
	DDX_Text (pDX,IDC_EDIT1 ,m_sFull  );
	DDX_Text (pDX,IDC_EDIT2 ,m_sPath  );
	DDX_Text (pDX,IDC_EDIT3 ,m_sExtra );
	DDX_Text (pDX,IDC_EDIT4 ,m_sApiKey);
	DDX_Radio(pDX,IDC_RADIO1,m_iSuffix);
	//}}AFX_DATA_MAP
}


//*****************************************************************************
//*
//*		OnInitDialog
//*
//*****************************************************************************
//	Beispile fr m_sFull:
//			"cycle/*.png?apikey=6170aad10dfd42a38d4d8c709a536f38"
//			"tiles/1.0.0/osm"									
//			""
BOOL COsmSettingsDlg::OnInitDialog()
{
CString		sText;
LPCTSTR		pName;	
LPCTSTR		pText;	
INT			iSize;
INT			iPos;

	
	SET_DLG_OLDPOS();



	m_bDone	= FALSE;
	pText	= m_sFull;
	pName	= GetFileName(pText);

	if(*pName!='*' && *pName!='?')
		{
		pName += strlen(pName);
		}

	iSize = pName-pText;
	
	m_sPath = m_sFull.Left(iSize);						// Pfad kopieren
	DelBackSlash(m_sPath);

	m_iSuffix = 0;

	if(*pName)											// Suffix bestimmen
		{
		iSize = strchar(pName,'?');

		if(iSize==5 && !_tcsnicmp(pName,_T("*.png"),5))
			{
			pName    += 5;
			m_iSuffix = 1;
			}
		else if(iSize==6 && !_tcsnicmp(pName,_T("*.peng"),6))
			{
			pName    += 6;
			m_iSuffix = 1;
			}
		else if(iSize==5 && !_tcsnicmp(pName,_T("*.jpg"),5))
			{
			pName    += 5;
			m_iSuffix = 2;
			}
		else if(iSize==6 && !_tcsnicmp(pName,_T("*.jpeg"),6))
			{
			pName    += 6;
			m_iSuffix = 2;
			}
		}


	m_sApiKey.Empty();	
	iPos = strchar(pName,'?');

	if(!pName[iPos])
		{
		m_sExtra = pName;
		}
	else{
		sText    = pName;
		m_sExtra = sText.Left(iPos);
		pName   += iPos+1; 
		iPos     = strifind(pName,_T("apikey="));

		if(iPos>=0)
			{
			sText     = pName;
			m_sExtra += sText.Left(iPos);
			pName    += iPos+7;
			iSize	  = strwlen(pName,0x07);
			sText     = pName;
			m_sApiKey = sText.Left(iSize);
			pName    += iSize;			
			}

		m_sExtra += pName;
		}

	CDialog::OnInitDialog();

	m_bDone	= TRUE;


return TRUE;
}

//*****************************************************************************
//*
//*		OnCancel
//*
//*****************************************************************************
void COsmSettingsDlg::OnCancel()
{
	GET_DLG_OLDPOS();
	CDialog::OnCancel();
}

//*****************************************************************************
//*
//*		OnOK
//*
//*****************************************************************************
void COsmSettingsDlg::OnOK()
{

	UpdateFull();
	
	GET_DLG_OLDPOS();

	CDialog::OnOK();
}

//*****************************************************************************
//*
//*		OnChange
//*
//*****************************************************************************
void COsmSettingsDlg::OnChange()
{

	if(!m_bDone)return;

	UpdateFull();

	SetDlgItemText(IDC_EDIT1,m_sFull);

}

//*****************************************************************************
//*
//*		UpdateFull
//*
//*****************************************************************************
void COsmSettingsDlg::UpdateFull()
{

	UpdateData();

	m_sFull = m_sPath;

	if(!m_iSuffix && m_sExtra.IsEmpty() && m_sApiKey.IsEmpty())
		{
		DelBackSlash(m_sFull);
		return;
		}

	if(!m_sFull.IsEmpty())
		{
		AddBackSlash(m_sFull,'/');
		}

	if(m_iSuffix)
		{
		m_sFull += (m_iSuffix!=1)? "*.jpg":"*.png";
		}

	
	m_sFull += m_sExtra;	

	if(!m_sApiKey.IsEmpty())
		{
		if(m_sFull.Find('?')<0)
			{
			m_sFull += _T("?");
			}

		m_sFull += _T("apikey=");		
		m_sFull += m_sApiKey;
		}


}
