//*****************************************************************************
//*
//*
//*		OsmStatDlg.cpp
//*
//*
//*****************************************************************************
#include	"StdAfx.h"
#include	"OsmViewer.h"
#include	"OsmStatDlg.h"
#include	"SrtmFunctions.h"
#include	"CoordFunctions.h"

#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif

#define 	 ID_LIST		0x51FD
#define 	 ID_SHOWSTATS	0x51FE
#define 	 ID_SELNONE		0x51FF
#define 	 ID_SELALL		0x5200
#define 	 ID_LOADGPX		0x5201


BEGIN_MESSAGE_MAP(COsmStatDlg, CDialog)
	//{{AFX_MSG_MAP(COsmStatDlg)
	ON_WM_DESTROY()
	ON_WM_CONTEXTMENU()
	ON_COMMAND(ID_SELALL		, OnSelAll)
	ON_COMMAND(ID_SELNONE		, OnSelNone)
	ON_COMMAND(ID_LOADGPX		, OnLoadGpx)
	ON_COMMAND(ID_SHOWSTATS		, OnShow)
	ON_BN_CLICKED(IDC_BUTTON1	, OnPath)
	ON_BN_CLICKED(IDC_BUTTON2	, OnFind)
	ON_BN_CLICKED(IDC_RADIO1    , OnClicked)
	ON_BN_CLICKED(IDC_RADIO2    , OnClicked)
	ON_BN_CLICKED(IDC_RADIO3    , OnClicked)
	ON_BN_CLICKED(IDC_RADIO4    , OnClicked)
	ON_BN_CLICKED(IDC_RADIO5    , OnClicked)
	ON_BN_CLICKED(IDC_RADIO6    , OnClicked)
	ON_EN_CHANGE (IDC_EDIT1		, OnCoordChanged)
	ON_EN_CHANGE (IDC_EDIT5		, OnCoordChanged)
	ON_EN_CHANGE (IDC_EDIT8		, OnCoordChanged)
	ON_CBN_EDITCHANGE(IDC_COMBO1, OnPathChanged)
	//}}AFX_MSG_MAP
	ON_NOTIFY(TVN_CBSTATECHANGED,ID_LIST,OnCheckChanged)
	ON_NOTIFY(TVN_COLUMNCLICK   ,ID_LIST,OnListSort)
END_MESSAGE_MAP()

DLG_OLDPOS(COsmStatDlg)

BOOL TimeConvert(const double &dTime,time_t &iUtcTime)
{
double	dVal;


	dVal  = dTime;

	if(dVal>=1.0 || dVal<0.0)
		{
		dVal -= 25569.0;
		}

	if(dVal<0.0)							// Zeit vor Mi 1.Jan.1970
		{
		iUtcTime=0;
		return FALSE;
		}

	dVal *= 86400.0;						// Tage zu Sekunden umwandeln

	if(sizeof(time_t)==4)
		{
		if(dVal>2147483647.0)				// ber Jahr 2038
			{
			iUtcTime=0x7FFFFFFF;
			return FALSE;
			}

		iUtcTime = (unsigned)dVal;			// Unix Zeit speichern
		}
	else{
		iUtcTime = (time_t)((__int64)dVal);	// Unix Zeit speichern
		}


return TRUE;
}

//*****************************************************************************
//*
//*		CDialog
//*
//*****************************************************************************
//  Dialogfeld COsmStatDlg
COsmStatDlg::COsmStatDlg(CWnd *pParent): CDialog(COsmStatDlg::IDD,pParent)
{
	//{{AFX_DATA_INIT(COsmStatDlg)
	m_sPath 	 = _T("");
	m_sCoordY	 = _T("");
	m_sCoordX	 = _T("");
	m_sCoordYA	 = _T("");
	m_sCoordXA	 = _T("");
	m_sCoordYE	 = _T("");
	m_sCoordXE	 = _T("");
	m_sDisdance  = _T("");
	m_sDisdanceA = _T("100");
	m_sDisdanceE = _T("100");
	m_sFilter	 = _T("100");
	m_iSelcetA	 = 0;
	m_iSelcetE	 = 0;
	//}}AFX_DATA_INIT

	m_cStatPath[0] = 0;

}


//*****************************************************************************
//*
//*		DoDataExchange
//*
//*****************************************************************************
void COsmStatDlg::DoDataExchange(CDataExchange *pDX)
{
	CDialog::DoDataExchange(pDX);

	//{{AFX_DATA_MAP(COsmStatDlg)
	DDX_CBString(pDX,IDC_COMBO1,m_sPath     );
	DDX_Text    (pDX,IDC_EDIT1 ,m_sCoordY   );
	DDX_Text    (pDX,IDC_EDIT2 ,m_sCoordX   );
	DDX_Text    (pDX,IDC_EDIT3 ,m_sDisdance );
	DDX_Text    (pDX,IDC_EDIT4 ,m_sFilter   );
	DDX_Text    (pDX,IDC_EDIT5 ,m_sCoordYA  );
	DDX_Text    (pDX,IDC_EDIT6 ,m_sCoordXA  );
	DDX_Text    (pDX,IDC_EDIT7 ,m_sDisdanceA);
	DDX_Text    (pDX,IDC_EDIT8 ,m_sCoordYE  );
	DDX_Text    (pDX,IDC_EDIT9 ,m_sCoordXE  );
	DDX_Text    (pDX,IDC_EDIT10,m_sDisdanceE);
	DDX_Radio	(pDX,IDC_RADIO1,m_iSelcetA  );
	DDX_Radio	(pDX,IDC_RADIO4,m_iSelcetE  );
	//}}AFX_DATA_MAP
}


//*****************************************************************************
//*
//*		OnInitDialog
//*
//*****************************************************************************
//  Behandlungsroutinen fr Nachrichten COsmStatDlg
BOOL COsmStatDlg::OnInitDialog()
{
CRegKeys	sKey;

	
	SET_DLG_OLDPOS()
	
	m_iSortDir	=  0;
	m_iSortMode	= -1;
	
	SetButtonBitmap(this,IDC_BUTTON1,IDB_OPEN);
	
	sKey.Open();
	sKey.Up(_T("StatDlg"));
	sKey.Get(m_sCoordX	 ,_T("CoordX"   ));
	sKey.Get(m_sCoordY	 ,_T("CoordY"   ));
	sKey.Get(m_sDisdance ,_T("Disdance" ));
	sKey.Get(m_sCoordXA	 ,_T("CoordXA"  ));
	sKey.Get(m_sCoordYA	 ,_T("CoordYA"  ));
	sKey.Get(m_sDisdanceA,_T("DisdanceA"));
	sKey.Get(m_sCoordXE	 ,_T("CoordXE"  ));
	sKey.Get(m_sCoordYE	 ,_T("CoordYE"  ));
	sKey.Get(m_sDisdanceE,_T("DisdanceE"));
	sKey.Get(m_sFilter   ,_T("Filter"   ));
	sKey.Get(m_iSelcetA  ,_T("SelectA"  ));
	sKey.Get(m_iSelcetE  ,_T("SelectE"  ));
	
	ComboBoxLoad(this,IDC_COMBO1,_T("#SeachPaths"),_T("#StatDlg"),m_sPath);

	m_cList.CreateEx(WS_EX_CLIENTEDGE,WS_CHILD|WS_VISIBLE|WS_TABSTOP|TVS_FULLROWSELECT|TVS_CHECKBOXES|TVS_FULLROWSELECT,IDC_FRAME,this,ID_LIST);
	m_cList.SetExtendedStyle(TVS_EX_FULLROWMARK);
	m_cList.InsertColumn(0,_T("Dateiname"    ),TVCFMT_LEFT , -89);
	m_cList.InsertColumn(1,_T("Name"         ),TVCFMT_LEFT , -38);
	m_cList.InsertColumn(2,_T("Abstand"      ),TVCFMT_RIGHT,  65);
	m_cList.InsertColumn(3,_T("Lnge"        ),TVCFMT_RIGHT,  79);
	m_cList.InsertColumn(4,_T("Anstieg"      ),TVCFMT_RIGHT,  65);
	m_cList.InsertColumn(5,_T("Abstieg"      ),TVCFMT_RIGHT,  65);
	m_cList.InsertColumn(6,_T("Druchsnitt"   ),TVCFMT_RIGHT,  85);
	m_cList.InsertColumn(7,_T("Gesamt"       ),TVCFMT_RIGHT,  85);
	m_cList.InsertColumn(8,_T("Dauer"        ),TVCFMT_RIGHT,  65);
	m_cList.InsertColumn(9,_T("Pause"        ),TVCFMT_RIGHT,  65);
	m_cList.InsertColumn(10,_T("Datum"       ),TVCFMT_LEFT,   90);

	CDialog::OnInitDialog();

	OnPathChanged();
	OnClicked();


return TRUE;
}

//*****************************************************************************
//*
//*		OnDestroy
//*
//*****************************************************************************
void COsmStatDlg::OnDestroy()
{
	
	GET_DLG_OLDPOS()
	
	DelButtonBitmap(this,IDC_BUTTON1);

	CDialog::OnDestroy();


}

//*****************************************************************************
//*
//*		OnClicked
//*
//*****************************************************************************
void COsmStatDlg::OnClicked()
{

	UpdateData();

	EnableDlgItem(IDC_EDIT5 ,m_iSelcetA==0);
	EnableDlgItem(IDC_EDIT6 ,m_iSelcetA==0);
	EnableDlgItem(IDC_EDIT7 ,m_iSelcetA==0);
	EnableDlgItem(IDC_EDIT8 ,m_iSelcetE==0);
	EnableDlgItem(IDC_EDIT9 ,m_iSelcetE==0);
	EnableDlgItem(IDC_EDIT10,m_iSelcetE==0);

}

//*****************************************************************************
//*
//*		OnPathChanged
//*
//*****************************************************************************
void COsmStatDlg::OnPathChanged() 
{
CString		sText;


	GetDlgItemText(IDC_COMBO1,sText);
	GetDlgItem(IDC_BUTTON2)->EnableWindow(!sText.IsEmpty());
	
}

//*****************************************************************************
//*
//*		OnCoordChanged
//*
//*****************************************************************************
void COsmStatDlg::OnCoordChanged() 
{
static int	iLocked=0;
TCHAR		cText[128];
double		dValue;
int			iLen;
int			iNum;


	if(iLocked)return;

	GetDlgItemText(IDC_EDIT1,cText,128);
	dValue = TextToCoord(cText,&iLen);

	if(iLen>0 && dValue!=0.0 && cText[iLen]==',' && TextToCoord(cText+iLen+1)!=0.0)
		{
		iLocked=1;
		cText[iLen]=0;
		iLen  += strwlen(cText+iLen+1,0xE0);
		dValue = TextToCoord(cText,&iNum);
		cText[iLen+1+iNum] = 0;
		SetDlgItemText(IDC_EDIT2,cText+iLen+1);
		SetDlgItemText(IDC_EDIT1,cText);
		iLocked=0;
		}

	GetDlgItemText(IDC_EDIT5,cText,128);
	dValue = TextToCoord(cText,&iLen);

	if(iLen>0 && dValue!=0.0 && cText[iLen]==',' && TextToCoord(cText+iLen+1)!=0.0)
		{
		iLocked=1;
		cText[iLen]=0;
		iLen  += strwlen(cText+iLen+1,0xE0);
		dValue = TextToCoord(cText,&iNum);
		cText[iLen+1+iNum] = 0;
		SetDlgItemText(IDC_EDIT6,cText+iLen+1);
		SetDlgItemText(IDC_EDIT5,cText);
		iLocked=0;
		}

	GetDlgItemText(IDC_EDIT8,cText,128);
	dValue = TextToCoord(cText,&iLen);

	if(iLen>0 && dValue!=0.0 && cText[iLen]==',' && TextToCoord(cText+iLen+1)!=0.0)
		{
		iLocked=1;
		cText[iLen]=0;
		iLen  += strwlen(cText+iLen+1,0xE0);
		dValue = TextToCoord(cText,&iNum);
		cText[iLen+1+iNum] = 0;
		SetDlgItemText(IDC_EDIT9,cText+iLen+1);
		SetDlgItemText(IDC_EDIT8,cText);
		iLocked=0;
		}
}

//*****************************************************************************
//*
//*		OnCheckChanged
//*
//*****************************************************************************
void COsmStatDlg::OnCheckChanged(NMHDR *pNmHdr,LRESULT *pResult)
{
NM_TREEVIEW   *pItem = (NM_TREEVIEW*)pNmHdr;

	
	if(m_iSelCount<0)return;
	
	if((pItem->itemNew.state&TVIS_STATEIMAGEMASK)>0x1000)
		{
		m_iSelCount++;
		}
	else if(m_iSelCount>0)
		{
		m_iSelCount--;
		}
	 

	GetDlgItem(IDOK)->EnableWindow(m_iSelCount>0);

}


//*****************************************************************************
//*
//*		OnListSort
//*
//*****************************************************************************
void COsmStatDlg::OnListSort(NMHDR *pNmHdr,LRESULT *pResult)
{
NMHEADER   *pHeader = (NMHEADER*)pNmHdr;
TVSORTEX	sSort;


	
	if(pHeader->iItem==0)
		{
		m_iSortDir			= (m_iSortMode==0)? !m_iSortDir:0;
		m_iSortMode			= 0;
		sSort.hParent		= TVI_ROOT;
		sSort.lParam		= m_iSortDir;
		sSort.lpfnCompare 	= ComparePath;
		m_cList.SortChildrenEX(&sSort,0);
		}
	else if(pHeader->iItem==1 || pHeader->iItem==10)
		{
		m_iSortDir			= (m_iSortMode==1)? !m_iSortDir:0;
		m_iSortMode			= 1;
		sSort.hParent		= TVI_ROOT;
		sSort.lParam		= pHeader->iItem|(m_iSortDir<<8);
		sSort.lpfnCompare 	= CompareName;
		m_cList.SortChildrenEX(&sSort,0);
		}
	else if(pHeader->iItem>=2)
		{
		m_iSortDir			= (m_iSortMode==2)? !m_iSortDir:0;
		m_iSortMode			= 2;
		sSort.hParent		= TVI_ROOT;
		sSort.lParam		= pHeader->iItem|(m_iSortDir<<8);
		sSort.lpfnCompare 	= CompareDiff;
		m_cList.SortChildrenEX(&sSort,0);
		}


}


//*****************************************************************************
//*
//*		ComparePath
//*
//*****************************************************************************
int CALLBACK COsmStatDlg::ComparePath(HWND hWnd,HTREEITEM hItem1,HTREEITEM hItem2,LPARAM lParam1,LPARAM lParam2,LPARAM lParam)
{
TV_ITEM		sItem1;
TV_ITEM		sItem2;
int			iCmp;

    
	sItem1.mask		 = TVIF_TEXT|TVIF_SUBITEM|TVIF_TEXTPTR;
	sItem1.hItem	 = hItem1;
	sItem1.cChildren = 0;

	sItem2.mask		 = TVIF_TEXT|TVIF_SUBITEM|TVIF_TEXTPTR;
	sItem2.hItem	 = hItem2;
	sItem2.cChildren = 0;

	TreeList_GetItem(hWnd,&sItem1);
	TreeList_GetItem(hWnd,&sItem2);

	iCmp = strvicmp(sItem1.pszText,sItem2.pszText);

	
return (lParam)? -iCmp:iCmp;
}


//*****************************************************************************
//*
//*		CompareName
//*
//*****************************************************************************
int CALLBACK COsmStatDlg::CompareName(HWND hWnd,HTREEITEM hItem1,HTREEITEM hItem2,LPARAM lParam1,LPARAM lParam2,LPARAM lParam)
{
TV_ITEM		sItem1;
TV_ITEM		sItem2;
int			iCmp;

    
	sItem1.mask		 = TVIF_TEXT|TVIF_SUBITEM|TVIF_TEXTPTR;
	sItem1.hItem	 = hItem1;
	sItem1.cChildren = lParam&0xFF;

	sItem2.mask		 = TVIF_TEXT|TVIF_SUBITEM|TVIF_TEXTPTR;
	sItem2.hItem	 = hItem2;
	sItem2.cChildren = lParam&0xFF;

	TreeList_GetItem(hWnd,&sItem1);
	TreeList_GetItem(hWnd,&sItem2);

	iCmp = strvicmp(sItem1.pszText,sItem2.pszText);

	
return (lParam>>8)? -iCmp:iCmp;
}


//*****************************************************************************
//*
//*		CompareDiff
//*
//*****************************************************************************
int CALLBACK COsmStatDlg::CompareDiff(HWND hWnd,HTREEITEM hItem1,HTREEITEM hItem2,LPARAM lParam1,LPARAM lParam2,LPARAM lParam)
{
TV_ITEM		sItem1;
TV_ITEM		sItem2;
int			iCmp;

    
	sItem1.mask		 = TVIF_TEXT|TVIF_SUBITEM|TVIF_TEXTPTR;
	sItem1.hItem	 = hItem1;
	sItem1.cChildren = lParam&0xFF;

	sItem2.mask		 = TVIF_TEXT|TVIF_SUBITEM|TVIF_TEXTPTR;
	sItem2.hItem	 = hItem2;
	sItem2.cChildren = lParam&0xFF;

	TreeList_GetItem(hWnd,&sItem1);
	TreeList_GetItem(hWnd,&sItem2);
			   	 			 	   
	iCmp  = (int)(strtof(sItem1.pszText,0,0x25)*1000.0);
	iCmp -= (int)(strtof(sItem2.pszText,0,0x25)*1000.0);
	     
	
return (lParam>>8)? -iCmp:iCmp;
}

//*****************************************************************************
//*
//*		OnPath
//*
//*****************************************************************************
void COsmStatDlg::OnPath()
{
CPathDlg	sDlg;


	UpdateData();
	sDlg.SetPath(m_sPath);
	if(sDlg.DoModal()!=IDOK)return;

	m_sPath=sDlg.GetPath();
	UpdateData(FALSE);
	OnPathChanged();

}

//*****************************************************************************
//*
//*		OnFind
//*
//*****************************************************************************
void COsmStatDlg::OnFind()
{
CProgressDlg	sDlg;
CRegKeys		sKey;
	
	
	UpdateData();
	
	sKey.Open();
	sKey.Up(_T("StatDlg"));
	sKey.Set(m_sCoordX	 ,_T("CoordX"   ));
	sKey.Set(m_sCoordY	 ,_T("CoordY"   ));
	sKey.Set(m_sDisdance ,_T("Disdance" ));
	sKey.Set(m_sCoordXA	 ,_T("CoordXA"  ));
	sKey.Set(m_sCoordYA	 ,_T("CoordYA"  ));
	sKey.Set(m_sDisdanceA,_T("DisdanceA"));
	sKey.Set(m_sCoordXE	 ,_T("CoordXE"  ));
	sKey.Set(m_sCoordYE	 ,_T("CoordYE"  ));
	sKey.Set(m_sDisdanceE,_T("DisdanceE"));
	sKey.Set(m_sFilter   ,_T("Filter"   ));
	sKey.Set(m_iSelcetA  ,_T("SelectA"  ));
	sKey.Set(m_iSelcetE  ,_T("SelectE"  ));

	ComboBoxSave(this,IDC_COMBO1,_T("#SeachPaths"),_T("#StatDlg"));


	if(m_sPath.IsEmpty())
		{
		MessageBox(_T("Bitte einen Dateipfad angeben !"),_T("Fehler"),MB_OK|MB_ICONERROR);
		return;
		}

	DelBackSlash(m_sPath);

	if(ExistFile(m_sPath)<2)
		{
		MessageBox(_T("Der angegebene Dateipfad existiert nicht !"),_T("Fehler"),MB_OK|MB_ICONERROR);
		return;
		}

	
	m_iSelCount	= 0;
	m_cList.DeleteAllItems();

	sDlg.StepIt();
	sDlg.SetRange(100);
	sDlg.SetProgressMode(200);
	sDlg.SetTitle(_T("Suche nach Tracks"));
	sDlg.SetProc(SearchProc,this,(LPCTSTR)m_sPath);
	sDlg.DoModal();

	GetDlgItem(IDOK)->EnableWindow(m_iSelCount>0);

}

//*****************************************************************************
//*
//*		OnCancel
//*
//*****************************************************************************
void COsmStatDlg::OnCancel()
{
CRegKeys		sKey;
	
	
	UpdateData();
	
	sKey.Open();
	sKey.Up(_T("StatDlg"));
	sKey.Set(m_sCoordX	 ,_T("CoordX"   ));
	sKey.Set(m_sCoordY	 ,_T("CoordY"   ));
	sKey.Set(m_sDisdance ,_T("Disdance" ));
	sKey.Set(m_sCoordXA	 ,_T("CoordXA"  ));
	sKey.Set(m_sCoordYA	 ,_T("CoordYA"  ));
	sKey.Set(m_sDisdanceA,_T("DisdanceA"));
	sKey.Set(m_sCoordXE	 ,_T("CoordXE"  ));
	sKey.Set(m_sCoordYE	 ,_T("CoordYE"  ));
	sKey.Set(m_sDisdanceE,_T("DisdanceE"));
	sKey.Set(m_sFilter   ,_T("Filter"   ));
	sKey.Set(m_iSelcetA  ,_T("SelectA"  ));
	sKey.Set(m_iSelcetE  ,_T("SelectE"  ));

	ComboBoxSave(this,IDC_COMBO1,_T("#SeachPaths"),_T("#StatDlg"));


	CDialog::OnCancel();

}

//*****************************************************************************
//*
//*		OnOK
//*
//*****************************************************************************
void COsmStatDlg::OnOK()
{
HTREEITEM		hItem;



	hItem = m_cList.GetFirstItem();

	while(hItem)
		{
		if(m_cList.GetCheck(hItem))
			{
			m_sFileList.Add(m_cList.GetItemText(hItem));
			}

		hItem = m_cList.GetNextSiblingItem(hItem);
		}


	CDialog::OnOK();

	
}

//*****************************************************************************
//*
//*		OnContextMenu
//*
//*****************************************************************************
void COsmStatDlg::OnContextMenu(CWnd *pWnd,CPoint sPoint)
{
CPoint		sPos;
CMenu		sMenu;
HTREEITEM	hItem;
UINT		uFlags;
int			iCol;




	if(!pWnd || pWnd->m_hWnd!=m_cList.m_hWnd)
		{
		return;
		}

	sPos	= sPoint;
			  m_cList.ScreenToClient(&sPos);
	hItem	= m_cList.HitTest(sPos,&uFlags);
	iCol	= uFlags>>24;
	
	m_cStatPath[0] = 0;
	m_cDataPath[0] = 0;
	m_cList.GetItemText(hItem,m_cDataPath,sizeof(m_cDataPath));

	if(m_cDataPath[0])
		{
		SetFileType(m_cStatPath,m_cDataPath,"png",sizeof(m_cStatPath));
		}

	sMenu.CreatePopupMenu();

	uFlags	= (ExistFile(m_cStatPath)!=1)? MF_DISABLED:0;
	sMenu.AppendMenu(MF_STRING|uFlags,ID_SHOWSTATS,"Statistik anzeigen");
	uFlags	= (ExistFile(m_cDataPath)!=1)? MF_DISABLED:0;
	sMenu.AppendMenu(MF_STRING|uFlags,ID_LOADGPX,"Route anzeigen");
	sMenu.AppendMenu(MF_SEPARATOR);
	sMenu.AppendMenu(MF_STRING       ,ID_SELNONE  ,"Nichts whlen");
	sMenu.AppendMenu(MF_STRING       ,ID_SELALL   ,"Alles whlen");

	sMenu.TrackPopupMenu(0,sPoint.x,sPoint.y,this);
	sMenu.DestroyMenu();

}

//*****************************************************************************
//*
//*		OnSelAll
//*
//*****************************************************************************
void COsmStatDlg::OnSelAll()
{

	m_cList.SetMultiItems(TVI_ROOT,0,TVIF_CHILDS|TVIF_STATE,NULL,0,0,0x2000,0xF000);

}

//*****************************************************************************
//*
//*		OnSelNone
//*
//*****************************************************************************
void COsmStatDlg::OnSelNone()
{

	m_cList.SetMultiItems(TVI_ROOT,0,TVIF_CHILDS|TVIF_STATE,NULL,0,0,0x1000,0xF000);

}

//*****************************************************************************
//*
//*		OnLoadGpx
//*
//*****************************************************************************
void COsmStatDlg::OnLoadGpx()
{
CStartProg	sStart;
CString		sPath;


	if(!m_cDataPath[0])return;

	if(ExistFile(m_cDataPath)!=1)
		{
		MessageBox("Die Routen-Datei wurde nicht gefunden !","Fehler",MB_OK|MB_ICONERROR);
		return;
		}

	GetExePath(sPath);
	sPath += "OsmViewer.exe";

	if(ExistFile(sPath)!=1)
		{
		sPath = "D:\\Programme\\AZ-Tools\\Tools\\OsmViewer.exe";

		if(ExistFile(sPath)!=1)
			{
			sPath = "C:\\Programme\\AZ-Tools\\Tools\\OsmViewer.exe";
			}
		}

	if(!sStart.Start(sPath,CSP_NOWAIT,"\"%s\"",m_cDataPath))
		{
		MessageBox("Das Program OsmViewer.exe konnte nicht gestartet werden !","Fehler",MB_OK|MB_ICONERROR);
		}
	
	
}

//*****************************************************************************
//*
//*		OnShow
//*
//*****************************************************************************
void COsmStatDlg::OnShow()
{
CStartProg	sStart;
CString		sPath;


	if(!m_cStatPath[0])return;

	if(ExistFile(m_cStatPath)!=1)
		{
		MessageBox("Die Bilddatei wurde nicht gefunden !","Fehler",MB_OK|MB_ICONERROR);
		return;
		}

	GetExePath(sPath);
	sPath += "Viewer.exe";

	if(ExistFile(sPath)!=1)
		{
		sPath = "D:\\Programme\\AZ-Tools\\Tools\\Viewer.exe";

		if(ExistFile(sPath)!=1)
			{
			sPath = "C:\\Programme\\AZ-Tools\\Tools\\Viewer.exe";
			}
		}

	if(!sStart.Start(sPath,CSP_NOWAIT,"\"%s\" -s",m_cStatPath))
		{
		MessageBox("Das Program Viewer.exe konnte nicht gestartet werden !","Fehler",MB_OK|MB_ICONERROR);
		}
	
	
}

//*****************************************************************************
//*
//*		InvalidEntry
//*
//*****************************************************************************
void COsmStatDlg::InvalidEntry(HTREEITEM hItem)
{

	m_cList.SetItemText(hItem," --.-- km"   , 3);
	m_cList.SetItemText(hItem," --- m"      , 4);
	m_cList.SetItemText(hItem," --- m"      , 5);
	m_cList.SetItemText(hItem," --.-- km/h" , 6);
	m_cList.SetItemText(hItem," --.-- km/h" , 7);
	m_cList.SetItemText(hItem," --.-- hr"   , 8);
	m_cList.SetItemText(hItem," --.-- hr"   , 9);
	m_cList.SetItemText(hItem," ---- -- -- ",10);

}

//*****************************************************************************
//*
//*		SearchProc
//*
//*****************************************************************************
int _cdecl COsmStatDlg::SearchProc(CProgressDlg *pDlg){COsmStatDlg	*pThis=(COsmStatDlg*)pDlg->GetVoid1();return pThis->SearchProc(pDlg,pDlg->GetChar2());}
int        COsmStatDlg::SearchProc(CProgressDlg *pDlg,LPCTSTR pPath)
{
TCHAR			cText[32];
TCHAR			cName[92];
HTREEITEM		hItem;
CFileFinder		sFind;
LPCTSTR			pFile;
LPCTSTR			pFilter;
RouteData	   *pRoute;	
RouteData	   *pData;	
double			dTime;
double			dDiff;
double			dDelta;
double			dValue;
double			dValueX;
double			dValueY;
double			dCoordX;
double			dCoordY;
double			dLength;
double			dHeighUp;
double			dCoordXA;
double			dCoordYA;
double			dCoordXE;
double			dCoordYE;
double			dDisdance;
double			dDisdanceA;
double			dDisdanceE;
double			dHeighDown;
int				iSelected;
int				iCount;
int				iStart;
int				iState;
int				iInner;
int				iBest;
int				iFlag;
int				iEnd;
int				iPos;
int				iLen;
int				iNum;


	m_iSelCount =-1;
	iSelected	= 0;	
	dDisdance	= strtof(m_sDisdance ,0,0x25);
	dDisdanceA	= strtof(m_sDisdanceA,0,0x25);
	dDisdanceE	= strtof(m_sDisdanceE,0,0x25);
	dCoordX		= TextToCoord(m_sCoordX )*0.017453292519943295769236907684886;
	dCoordY		= TextToCoord(m_sCoordY )*0.017453292519943295769236907684886;
	dCoordXA	= TextToCoord(m_sCoordXA)*0.017453292519943295769236907684886;
	dCoordYA	= TextToCoord(m_sCoordYA)*0.017453292519943295769236907684886;
	dCoordXE	= TextToCoord(m_sCoordXE)*0.017453292519943295769236907684886;
	dCoordYE	= TextToCoord(m_sCoordYE)*0.017453292519943295769236907684886;
	pFilter		= (m_sFilter.IsEmpty())? _T("*.gpx;*.kml;*.kmz;*.trk;*.tk"):(LPCTSTR)m_sFilter;
	sFind.Set(pPath,CFF_FIND_SUBDIR,pFilter);


	if(m_iSelcetA==1)										// Atartpunkt aus Suchwert
		{
		dCoordXA = dCoordX;
		dCoordYA = dCoordY;
		}

	if(m_iSelcetE==1)										// Endpunkt aus Suchwert
		{
		dCoordXE = dCoordX;
		dCoordYE = dCoordY;
		}													 

	if(dDisdance<=0.01)										// Prf die Abstnde
		{
		dDisdance = 100.0;
		}
		    
	if(dDisdanceA<=0.01)
		{
		dDisdanceA = 100.0;
		}

	if(dDisdanceE<=0.01)
		{
		dDisdanceE = 100.0;
		}


//******************** Tracks auswerten ***************************************	
	
	
	for(pData=NULL;;)										// Suche die Dateien
		{
		if(pData)
			{
			delete pData;
			pData = NULL;
			}

		if(pDlg->IsStoped())break;

			pFile = sFind.Next(1);
		if(!pFile)break;

		pDlg->SetText(_T("Datei: @"),pFile);
		iCount = ReadTrackFile(pFile,&pData,cName);
		
		if(iCount<=0)continue;

		dValueX	= pData[0].dCoordX*0.017453292519943295769236907684886;
		dValueY	= pData[0].dCoordY*0.017453292519943295769236907684886;
		dTime	= pData[0].dGlobalTime;
		dDiff 	= DistanceOfPointsEx(dValueX,dValueY,dCoordX,dCoordY);
		iBest 	= 0;

		for(iPos=1;iPos<iCount;iPos++)						// Suche den nhesten Punkt
			{
			dValueX	= pData[iPos].dCoordX*0.017453292519943295769236907684886;
			dValueY	= pData[iPos].dCoordY*0.017453292519943295769236907684886;
			dValue  = DistanceOfPointsEx(dValueX,dValueY,dCoordX,dCoordY);

			if(dValue<dDiff)								// Ist der Punkt nher 
				{
				iBest = iPos;
				dDiff = dValue;
				dTime = pData[iPos].dGlobalTime;
				}
			}

		if(dDiff>dDisdance)continue;						// Ist die Route nah genug

		iLen  = _stprintf(cText,_T("%i m"),(int)dDiff);

		if(iLen>5){memmove(cText+iLen-4,cText+iLen-5, 6*sizeof(TCHAR));cText[iLen-5]=' ';iLen++;}
		if(iLen>9){memmove(cText+iLen-8,cText+iLen-9,10*sizeof(TCHAR));cText[iLen-9]=' ';iLen++;}

		hItem = m_cList.InsertItem(pFile);
		m_cList.SetItemText(hItem,cName,1);
		m_cList.SetItemText(hItem,cText,2);
		InvalidEntry(hItem);

		if(dTime<36526.0 || dTime>72686.0)					// Ist das Datum gltig		
			{
			continue;
			}

		cText[0] = ' ';
		strtimeset(cText+1,(time_t)((dTime-25569.0)*3600.0*24.0),STR_LONG_ISO);
		m_cList.SetItemText(hItem,cText,10);


		//************ Suche den Startpunkt ***********************************


		if(m_iSelcetE==2)									// Endwert als Endpunkt benutzen
			{
			iStart	= iCount-1;									
			}
		else{
			dDiff	= dDisdanceA*2.0;
			iInner	= 0;
			iState	= 0;
			iBest	= 0;

			for(iPos=0;iPos<iCount;iPos++)					// Suche den nhesten Punkt
				{
				dValueX	= pData[iPos].dCoordX*0.017453292519943295769236907684886;
				dValueY	= pData[iPos].dCoordY*0.017453292519943295769236907684886;
				dValue  = DistanceOfPointsEx(dValueX,dValueY,dCoordXA,dCoordYA);

				if(dValue<=dDisdanceA)						// Im Umkreis
					{
					if(!iInner && iState)
						{
						dDiff  = dDisdanceA*2.0;			// Startpunkt wurde nochmals gefunden
						iBest  = iPos;
						iState = 0;
						}
						
					iInner  = 1;
					
					if(dValue<dDiff)						// Ist der Punkt nher 
						{
						iBest = iPos;
						dDiff = dValue;
						}
					}
				
				if(iInner && dValue>dDisdanceA*1.5)			// Wieder aus dem Umkreis entgangen
					{
					iInner = 0;
					iState = 1;
					}

				if(iState && m_iSelcetE!=2)					// Wurde der Endpunkt erreicht
					{
					dValue = DistanceOfPointsEx(dValueX,dValueY,dCoordXE,dCoordYE);
					if(dValue<=dDisdanceE)break;
					}
				}

			if(!iState)										// Wurde ein Startpunkt gefunden
				{
				InvalidEntry(hItem);
				continue;
				}

			iStart = iBest;
			}			


		//************ Suche den Endpunk **************************************


		if(m_iSelcetA==2)									// Startwert als Startpunkt benutzen
			{
			iEnd	= 0;									
			}
		else{
			dDiff	= dDisdanceE*2.0;
			iInner	= 0;
			iBest	= 0;
			iFlag	= 0;

			for(iPos=0;iPos<iCount;iPos++)					// Suche den nhesten Punkt
				{
				dValueX	= pData[iPos].dCoordX*0.017453292519943295769236907684886;
				dValueY	= pData[iPos].dCoordY*0.017453292519943295769236907684886;
				dValue	= DistanceOfPointsEx(dValueX,dValueY,dCoordXE,dCoordYE);

				if(dValue<=dDisdanceE)						// Im Umkreis
					{
					iInner  = 1;

					if(dValue<dDiff && !iFlag)				// Ist der Punkt nher 
						{
						iBest = iPos;
						dDiff = dValue;
						}
					else if(dValue+8.0<dDiff && iFlag)		// Diezeite annherung mus 8m nher sein
						{
						iBest = iPos;
						dDiff = dValue;
						}
					else if(dValue>dDiff+8.0)				// 8m vom nhesten Punkt entferent
						{
						iFlag = 1;
						}
					}
				
				if(iInner && dValue>dDisdanceA*1.5)			// Wieder aus dem Umkreis entgangen
					{
					break;
					}
				}

			if(!iInner)										// Wurde ein Endpunkt gefunden
				{
				InvalidEntry(hItem);
				continue;
				}

			iEnd = iBest;
			}			


		//************ Statistiken holen **************************************


		if(iStart+10>iEnd)									// Gibt es genug Punkte
			{
			continue;
			}

		dLength	= CalcDistance(pData,iCount,0xFF);
		iNum	= ScaleRoute(pData+iStart,iEnd-iStart,&pRoute,10.0);

		if(!pRoute)continue;

		dLength	= CalcDistance(pRoute,iNum,0xFF);
		
		dHeighUp				= 0.0;
		dHeighDown				= 0.0;
		pRoute[0].dHeighUp		= 0.0;
		pRoute[0].dHeighDown	= 0.0;


		for(iPos=0;iPos<iNum;iPos++)						// Die Hhen fr alle Sttzpunkte holen
			{
			   dValue = SrtmGetHeight(pRoute[iPos].dCoordX,pRoute[iPos].dCoordY);
			if(dValue<-100.0)break;

			pRoute[iPos].dCoordZ = dValue;

			if(iPos)
				{
				   dDelta = pRoute[iPos].dCoordZ  -pRoute[iPos-1].dCoordZ;
				if(dDelta>0)
						dHeighUp   += dDelta;
				else	dHeighDown += dDelta;

				pRoute[iPos].dHeighUp	= dHeighUp;
				pRoute[iPos].dHeighDown	= dHeighDown;
				}
			}


															// Ist die Zeit gltig		
		if(pRoute[     0].dGlobalTime>=36526.0 && pRoute[     0].dGlobalTime<=72686.0 &&
		   pRoute[iNum-1].dGlobalTime>=36526.0 && pRoute[iNum-1].dGlobalTime<=72686.0)					
			{
			sprintf(cText," %.2f hr",pRoute[iNum-1].dTime/3600.0);
			m_cList.SetItemText(hItem,cText,8);
			sprintf(cText," %.2f hr",pRoute[iNum-1].dPause/3600.0);
			m_cList.SetItemText(hItem,cText,9);

			dDelta	=  pRoute[iNum-1].dTime;
			dValue	= (dLength*0.001)/(dDelta/3600.0);	
			sprintf(cText," %.2f km/h",dValue);
			m_cList.SetItemText(hItem,cText,6);
			dDelta	=  pRoute[iNum-1].dTime-pRoute[iNum-1].dPause;
			dValue	= (dLength*0.001)/(dDelta/3600.0);	
			sprintf(cText," %.2f km/h",dValue);
			m_cList.SetItemText(hItem,cText,7);
			}

		sprintf(cText," %.2f km",dLength*0.001);
		m_cList.SetItemText(hItem,cText,3);
		sprintf(cText," %i m",(int)dHeighUp);
		m_cList.SetItemText(hItem,cText,4);
		sprintf(cText," %i m",(int)dHeighDown);
		m_cList.SetItemText(hItem,cText,5);
		
		m_cList.SetCheck(hItem);
		iSelected++;

		delete pRoute;
		}


	m_iSelCount = iSelected;

	if(pData)delete pData;


return iSelected;
}

