//*****************************************************************************
//*
//*
//*		OsmViewer.cpp
//*
//*
//*****************************************************************************
//	
//	Syntax:		OsmViewer.exe	<track> [-s] [-c]
//	
//					-s		Track nicht in neuem Fenster ffnen
//					-c		Track-Dateien konfigurieren
//
#include	"StdAfx.h"
#include	"OsmViewer.h"
#include	"MainFrm.h"
#include	"OsmViewerDoc.h"
#include	"OsmViewerView.h"

#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif


BEGIN_MESSAGE_MAP(COsmViewerApp, CWinApp)
	//{{AFX_MSG_MAP(COsmViewerApp)
	ON_COMMAND(ID_APP_ABOUT ,OnAppAbout)
	ON_COMMAND(ID_CONFIG	,OnConfig)
	//}}AFX_MSG_MAP
	ON_COMMAND(ID_FILE_NEW,         CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

LOAD_LAST1(COsmViewerApp)

COsmViewerApp theApp;

//*****************************************************************************
//*
//*		COsmViewerApp
//*
//*****************************************************************************
//  COsmViewerApp Konstruktion
COsmViewerApp::COsmViewerApp()
{
}

//*****************************************************************************
//*
//*		InitInstance
//*
//*****************************************************************************
//  COsmViewerApp Initialisierung
BOOL COsmViewerApp::InitInstance()
{
COsmViewerDoc  *pDoc;
POSITION		hPos;
CString			sPath;
LPCTSTR			pParam;
int				iSingle;
int				i;


	AfxEnableControlContainer();


	#ifdef		_AFXDLL 				
	Enable3dControls(); 									// Diese Funktion bei Verwendung von MFC in gemeinsam genutzten DLLs aufrufen
	#else
	Enable3dControlsStatic();								// Diese Funktion bei statischen MFC-Anbindungen aufrufen
	#endif

	AfxUtilityInit();

	SetRegistryKey(_T("AZ"));

	LoadStdProfileSettings();								// Standard INI-Dateioptionen laden (einschlielich MRU)

	iSingle = 0;
	
	
	for(i=1;i<__argc;i++)									// Zu einer bestimmten Addresse scrollen
		{
		pParam = __targv[i];

		if(pParam[0]!='-' && pParam[0]!='/')
			{
			sPath = pParam;
			continue;
			}

		if(pParam[1]=='C' || pParam[1]=='c')
			{
			OnConfig();
			return FALSE;
			}

		if(pParam[1]=='S' || pParam[1]=='s')
			{
			iSingle = 1;
			continue;
			}
		}

	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(IDR_MAINFRAME,RUNTIME_CLASS(COsmViewerDoc),RUNTIME_CLASS(CMainFrame),RUNTIME_CLASS(COsmViewerView));	// Haupt-SDI-Rahmenfenster
	AddDocTemplate(pDocTemplate);

	CCommandLineInfo cmdInfo;

	if(!ProcessShellCommand(cmdInfo))
		{
		return FALSE;
		}


	if(iSingle && !sPath.IsEmpty())							// In offenen einem Fenster laden
		{
		CMainFrame *pMain=(CMainFrame*)m_pMainWnd;
		CWnd	   *pWnd;
		HWND		hWnd;

		   hWnd = pMain->EnumMainWnd();
		if(hWnd)
			{
			pWnd = CWnd::FromHandle(hWnd);
			APPWND_LOADFILE(pWnd,sPath);
			ForceWindowToTop(pWnd);
			return FALSE;
			}
		}



	m_pMainWnd->ShowWindow(SW_SHOW);
	m_pMainWnd->UpdateWindow();


	if(!sPath.IsEmpty())									// Die Track-Datei laden wenn das Fenster offen ist
		{
		   hPos = pDocTemplate->GetFirstDocPosition();
		if(hPos)
			{
			   pDoc = (COsmViewerDoc*)pDocTemplate->GetNextDoc(hPos);
			if(pDoc)
				{
				pDoc->OnOpenDocument(sPath);
				}
			}
		}



return TRUE;
}



//*****************************************************************************
//*
//*		OnAppAbout
//*
//*****************************************************************************
//  Anwendungsbefehl zum Ausfhren des Dialogfelds
void COsmViewerApp::OnAppAbout()
{
CDialog	sDlg(IDD_ABOUTBOX);


	sDlg.DoModal();


}

//*****************************************************************************
//*
//*		OnConfig
//*
//*****************************************************************************
void COsmViewerApp::OnConfig()
{
LPCTSTR		aNames[]={_T("kml"),_T("kmz"),_T("gpx"),_T("trk"),_T("tk"),0};
CString		sExeFile;
CString		sMyType;
int			iFlags;
int			iPos;


	
	GetExeName(sExeFile);


	for(iPos=0;aNames[iPos];iPos++)
		{
		iFlags = ConfigFileQuery(aNames[iPos]);

		if((iFlags&0x04))
			{
			sMyType  = _T("Track-Datei ");
			sMyType += aNames[iPos];
			ConfigFileIcon(aNames[iPos],sExeFile,(iPos>1)? 1:2,sMyType);
			}

		ConfigFileCommand(aNames[iPos],sExeFile,_T("Anzeigen"),_T("\"%1\" -s"));
		}

}

