//*****************************************************************************
//*
//*
//*		OsmViewerDoc.cpp
//*
//*
//*****************************************************************************
#include	"StdAfx.h"
#include	"OsmViewer.h"
#include	"OsmViewerDoc.h"
#include	"OsmViewerView.h"
#include	"CoordFunctions.h"

#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif


IMPLEMENT_DYNCREATE(COsmViewerDoc, CDocument)

BEGIN_MESSAGE_MAP(COsmViewerDoc, CDocument)
	//{{AFX_MSG_MAP(COsmViewerDoc)
	ON_COMMAND(ID_FILE_SAVE_AS	,OnSaveAs)
	ON_COMMAND(ID_FILE_OPEN		,OnFileOpen)
	ON_COMMAND(ID_FILE_SAVE		,OnFileSave)
	ON_COMMAND(ID_LOADLAST		,OnLoadLast)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


LOAD_LAST(COsmViewerDoc,COsmViewerApp);


//*****************************************************************************
//*
//*		COsmViewerDoc
//*
//*****************************************************************************
//  COsmViewerDoc Konstruktion/Destruktion
COsmViewerDoc::COsmViewerDoc()
{
	m_bEditFlag = FALSE;
}

//*****************************************************************************
//*
//*		COsmViewerDoc
//*
//*****************************************************************************
COsmViewerDoc::~COsmViewerDoc()
{
}

//*****************************************************************************
//*
//*		OnNewDocument
//*
//*****************************************************************************
BOOL COsmViewerDoc::OnNewDocument()
{
COsmViewerView *pView;
CListDlg		sDlg;
CString			sTxt;
LPCTSTR			pTxt;
POSITION		hPos;
unsigned		uPos;
unsigned		uNum;


	if(!CDocument::OnNewDocument())
		{
		return FALSE;
		}


		hPos  =	GetFirstViewPosition();						// Zeiger auf Fenster holen
		pView = (COsmViewerView*)GetNextView(hPos);
	if(!pView)return FALSE;

	for(uPos=0,uNum=0;uPos<8;uPos++)
		{
		if(!pView->GetPathPoints(uPos))continue;

		uNum++;

		sTxt.Format(_T("%u / "),uPos+1);
		pTxt  = pView->GetPathFile(uPos);
		sTxt += GetFileName(pTxt);
		if(sTxt.GetLength()>4)sTxt += _T(" / ");
		sTxt += pView->GetPathName(uPos);
		if(sTxt.GetLength()<=4 && uPos==0)sTxt+=_T("Lokaler Pfad");
		
		sDlg.AddString(uPos,sTxt,TRUE);
		}

	
	if(uNum>1)												// Mehr als ein Pfad sichtbar
		{
		sDlg.SetTitle(_T("Pfade lschen"));
		sDlg.SetMode(3);

		if(sDlg.DoModal()!=IDOK)return FALSE;
		}
	
	
	for(uNum=sDlg.GetCount();uNum>0;)						// Pfade lschen
		{
		uNum--;

		if(!sDlg.GetSelect(uNum))continue;

		uPos = sDlg.GetData(uNum);

		if(!pView->GetPathPoints(uPos))continue;

		pView->DelPath(uPos);
		pView->SetPathName(uPos,_T(""));
		pView->SetPathFile(uPos,_T(""));
		}


return TRUE;
}



//*****************************************************************************
//*
//*		Serialize
//*
//*****************************************************************************
//  COsmViewerDoc Serialisierung
void COsmViewerDoc::Serialize(CArchive &ar)
{
	if(ar.IsStoring())
		{
		}
	else{
		}
}


#ifdef		_DEBUG						

//*****************************************************************************
//*
//*		AssertValid
//*
//*****************************************************************************
void COsmViewerDoc::AssertValid() const
{
	CDocument::AssertValid();
}

//*****************************************************************************
//*
//*		Dump
//*
//*****************************************************************************
void COsmViewerDoc::Dump(CDumpContext &dc) const
{
	CDocument::Dump(dc);
}
#endif 

//*****************************************************************************
//*
//*		OnSaveDocument
//*
//*****************************************************************************
BOOL COsmViewerDoc::OnSaveDocument(LPCTSTR pPathName)
{
COsmViewerView *pView;
RouteData	   *pData;
POSITION		hPos;
int				iPos;
int				iNum;
int				iRet;
	
	
	
		hPos  =	GetFirstViewPosition();						// Zeiger auf Fenster holen
		pView = (COsmViewerView*)GetNextView(hPos);
	if(!pView)
		{
		return FALSE;
		}


		iNum = pView->GetPathPoints(0);
	if(!iNum)
		{
		return FALSE;
		}

	pData = new RouteData[iNum];
	memset(pData,0,iNum*sizeof(RouteData));

	for(iPos=0;iPos<iNum;iPos++)							// Punkte holen
		{
		pView->GetPathPointEx(0,pData[iPos].dCoordX,pData[iPos].dCoordY,iPos);
		}


	if(CmpFileType(pPathName,"kml"))
		{
		iRet = SaveKml(pPathName,pData,iNum,pView->GetPathName(0));
		}
	else if(CmpFileType(pPathName,"csv"))
		{
		iRet = SaveCsv(pPathName,pData,iNum,pView->GetPathName(0));
		}
	else{
		iRet = SaveGpx(pPathName,pData,iNum,pView->GetPathName(0));
		}

	delete pData;

	
	if(iRet)												// Gab es einen Fehler
		{
		pView->MessageBox(_T("Die Datei konnte nicht gespeichert werden !"),_T("Fehler"),MB_OK|MB_ICONERROR);
		return FALSE;
		}


	pView->SetPathChanged(0,FALSE);
	SetModifiedFlag(FALSE);
	SetPathName(pPathName);



return TRUE;
}

//*****************************************************************************
//*
//*		OnOpenDocument
//*
//*****************************************************************************
BOOL COsmViewerDoc::OnOpenDocument(LPCTSTR pPathName)
{
TCHAR			cName[256];
COsmViewerView *pView;
RouteData	   *pData;
POSITION		hPos;
int				iIdx;
int				iPos;
int				iNum;
	
	
	
		hPos  =	GetFirstViewPosition();						// Zeiger auf Fenster holen
		pView = (COsmViewerView*)GetNextView(hPos);
	if(!pView)
		{
		m_bEditFlag = FALSE;
		return FALSE;
		}


	if(m_bEditFlag)											// Im ersten Pfad laden
		{
		m_bEditFlag	= FALSE;
		iIdx		= 0;

		if(pView->GetPathPoints(0))
			{
			if(pView->HasPathChanged(0))
				{
				if(pView->MessageBox(_T("Der aktuelle Pfad wurde verndert !\nSoll er berschrieben werden ?"),_T("Warnung"),MB_OKCANCEL|MB_ICONWARNING)!=IDOK)
					{
					return FALSE;
					}
				}

			pView->SetPathName(iIdx,_T(""));			
			pView->DelPath(0);
			}
		}
	else{
		for(iIdx=1;;iIdx++)									// Suche unbenutzen Pfad-Slot
			{
			if(iIdx>=8)
				{
				pView->MessageBox(_T("Es sind zu viele Pfade geladen !"),_T("Fehler"),MB_OK|MB_ICONERROR);
				return FALSE;
				}

			if(pView->GetPathPoints(iIdx)==0)break;
			}
		}


	pData = 0;

	   iNum = ReadTrackFile(pPathName,&pData,cName);
	if(iNum<=0)
		{
		pView->MessageBox(_T("Die Datei konnte nicht geladen werden !"),_T("Fehler"),MB_OK|MB_ICONERROR);
		if(pData)delete pData;
		return FALSE;
		}


	for(iPos=0;iPos<iNum;iPos++)							// Punkte laden
		{
		pView->AddPathPointEx(iIdx,pData[iPos].dCoordX,pData[iPos].dCoordY,iPos,FALSE);
		}

	pView->GetPathLength(iIdx);
	pView->SetScrollPath(iIdx,FALSE);
	pView->SetPathFile(iIdx,pPathName);
	pView->SetPathName(iIdx,cName);
	pView->RedrawWindow();

	delete pData;

	if(iIdx && pView->GetPathPoints(0))						// Wenn ein Pfad bearbeitet wird, Dateinamen nicht bernehmen
		{
		return FALSE;
		}



return TRUE;
}


//*****************************************************************************
//*
//*		OnSaveAs
//*
//*****************************************************************************
//	Speichert einen Pfad
void COsmViewerDoc::OnSaveAs()
{
COsmViewerView *pView;
CString			sPath;
POSITION		hPos;
CRegKeys		sKey;


	m_bSaveFlag = FALSE;
	sKey.Open();


		hPos  =	GetFirstViewPosition();						// Zeiger auf Fenster holen
		pView = (COsmViewerView*)GetNextView(hPos);
	if(!pView)return;
	


	CFileDialog	 sDlg(FALSE,".gpx",(LPCTSTR)GetPathName(),OFN_EXPLORER|OFN_ENABLESIZING|OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,_T("Trackdateien|*.gpx;*.kml;*.csv|GPX-Datei (*.gpx)|*.gpx|KML-Datei (*.kml)|*.kml|CSV-Datei (*.csv)|*.csv|Alle Dateien  (*.*)|*.*|"));

	
	sKey.Get(sDlg.m_ofn.nFilterIndex,"SaveFilter");

	if(sDlg.DoModal()==IDOK)
		{
		sKey.Set(sDlg.m_ofn.nFilterIndex,"SaveFilter");

		sPath = (LPCTSTR)sDlg.GetPathName();

		if(OnSaveDocument(sPath))
			{
			m_bSaveFlag = TRUE;
			SetPathName(sDlg.GetPathName());
			}
		}

}

//*****************************************************************************
//*
//*		OnFileSave
//*
//*****************************************************************************
//	Speichert einen Pfad
void COsmViewerDoc::OnFileSave()
{


	m_bSaveFlag = FALSE;


	if(m_strPathName.IsEmpty())
		{
		OnSaveAs();
		return;
		}


	if(OnSaveDocument(m_strPathName))
		{
		m_bSaveFlag = TRUE;
		}

}


//*****************************************************************************
//*
//*		OnFileOpen
//*
//*****************************************************************************
//	ffne eine Datei mit Dialog
void COsmViewerDoc::OnFileOpen()
{
CString		sPath;

	m_bEditFlag = FALSE;

	CFileDialog	sFile(TRUE,_T("*.gpx"),NULL,OFN_EXPLORER|OFN_ENABLESIZING|OFN_PATHMUSTEXIST|OFN_FILEMUSTEXIST|OFN_RENAMERO,_T("Zum Bearbeiten ffnen@Trackdateien|*.gpx;*.kml;*.kmz;*.trk;*.tk;*.csv|GPX-Datei (*.gpx)|*.gpx|KML-Datei (*.kml)|*.kml;*.kmz|TRK-Datei (*.trk)|*.trk|TK-Datei (*.tk)|*.tk|CSV-Datei (*.csv)|*.csv|Alle Dateien  (*.*)|*.*|"));


	   sFile.m_ofn.lpstrTitle=_T("Track-Datei laden");
	if(sFile.DoModal()!=IDOK)return;

	sPath		=  sFile.GetPathName();
	m_bEditFlag = (sFile.m_ofn.Flags&OFN_READONLY)? TRUE:FALSE;

	if(m_bEditFlag && !CmpFileName(sPath,m_strPathName))
		{
		m_strPathName.Empty();
		}

	AfxGetApp()->OpenDocumentFile(sPath);
	m_bEditFlag = FALSE;

}

//*****************************************************************************
//*
//*		ClearPathName
//*
//*****************************************************************************
//	Lscht den Pfadnamen
void COsmViewerDoc::ClearPathName()
{

	m_strPathName.Empty();      

}	

//*****************************************************************************
//*
//*		IsModified
//*
//*****************************************************************************
BOOL COsmViewerDoc::IsModified()
{
COsmViewerView *pView;
POSITION		hPos;


		hPos  =	GetFirstViewPosition();						// Zeiger auf Fenster holen
		pView = (COsmViewerView*)GetNextView(hPos);
	if(!pView)return FALSE;
	

return pView->HasPathChanged(0);
}

//*****************************************************************************
//*
//*		DoFileSave
//*
//*****************************************************************************
BOOL COsmViewerDoc::DoFileSave()
{
DWORD	dwAttrib;


	dwAttrib = GetFileAttributes(m_strPathName);

	if(dwAttrib&FILE_ATTRIBUTE_READONLY)
		{
		OnSaveAs();

		if(!m_bSaveFlag)
			{
			TRACE0("Warning: File save failed.\n");
			return FALSE;
			}
		}
	else{
		OnFileSave();

		if(!m_bSaveFlag)
			{
			TRACE0("Warning: File save failed.\n");
			return FALSE;
			}
		}

return TRUE;
}

