//*****************************************************************************
//*
//*
//*		OsmViewerView.cpp
//*
//*
//*****************************************************************************
#include	"StdAfx.h"
#include	"OsmViewer.h"
#include	"OsmViewerDoc.h"
#include	"OsmViewerView.h"
#include	"OsmWayPointDlg.h"
#include	"OsmServerDlg.h"
#include	"OsmFrameDlg.h"
#include	"OsmPathDlg.h"
#include	"OsmFindDlg.h"
#include	"OsmStatDlg.h"
#include	"HeightDlg.h"
#include	"CoordFunctions.h"
#include	"SrtmFunctions.h"
#include	"MainFrm.h"
#include	<math.h>
					   
#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif

#define 	 IDC_UPDATE			0x7CE4
#define 	 ID_OSM_MAP			0x7CE5
#define 	 ID_SERVER			0x7300
#define 	 ID_LAYER			0x7400
#define 	 PRINT_FRAME		10

#ifndef 	 DC_PEN
#define		 DC_PEN				19
#endif 	
#ifndef 	 AC_SRC_ALPHA
#define		 AC_SRC_ALPHA       0x01
#endif 	

IMPLEMENT_DYNCREATE(COsmViewerView, CView)

BEGIN_MESSAGE_MAP(COsmViewerView, CView)
	//{{AFX_MSG_MAP(COsmViewerView)
	ON_WM_SIZE()
	ON_WM_TIMER()
	ON_WM_CREATE()
	ON_WM_SETFOCUS()
	ON_WM_DROPFILES()
	ON_COMMAND(ID_ZOOM					,OnZoom)
	ON_COMMAND(ID_EDIT_COPY				,OnCopy)
	ON_COMMAND(ID_RELOAD				,OnReload)
	ON_COMMAND(ID_DO_MOVE				,OnDoMove)
	ON_COMMAND(ID_DO_COPY				,OnDoCopy)
	ON_COMMAND(ID_DO_DRAW				,OnDoDraw)
	ON_COMMAND(ID_DUALMODE				,OnDualMode)
	ON_COMMAND(ID_DO_MEASURE			,OnDoMeasure)
	ON_COMMAND(ID_DO_WAYPOINT			,OnDoPoint)
	ON_COMMAND(ID_OSM_MENU				,OnOsmMenu)
	ON_COMMAND(ID_PATHFIND				,OnPathFind)
	ON_COMMAND(ID_COORD_DEC				,OnCoordDec)
	ON_COMMAND(ID_COORD_DEG				,OnCoordDeg)
	ON_COMMAND(ID_COORD_NSWE			,OnCoordDir)
	ON_COMMAND(ID_COPY_COORD			,OnCopyCoord)
	ON_COMMAND(ID_SHOW_COORD			,OnShowCoord)
	ON_COMMAND(ID_WAYPOINTS				,OnWayPoints)
	ON_COMMAND(ID_WHEEL_ZOOM			,OnWheelZoom)
	ON_COMMAND(ID_WHEEL_SCROLL			,OnWheelScroll)
	ON_COMMAND(ID_PATHOPTIONS			,OnPathOptions)
	ON_COMMAND(ID_SERVER_CONFIG			,OnServerConfig)
	ON_COMMAND(ID_SAVEMAPFRAME			,OnSaveMapFrame)
	ON_COMMAND(ID_SAVEMAPFIXED			,OnSaveMapFixed)
	ON_COMMAND(ID_CLEARCHACHE			,OnClearCache)
	ON_COMMAND(ID_TRACKSSTAT			,OnTracksStat)
	ON_COMMAND(ID_HIEIGHTINFO			,OnHeightInfo)
	ON_UPDATE_COMMAND_UI(ID_DUALMODE	,OnDualModeUI)
	ON_UPDATE_COMMAND_UI(ID_OSM_MENU	,OnOsmMenuUI)
	ON_UPDATE_COMMAND_UI(ID_DO_MOVE		,OnDoMoveUI)
	ON_UPDATE_COMMAND_UI(ID_DO_COPY		,OnDoCopyUI)
	ON_UPDATE_COMMAND_UI(ID_DO_DRAW		,OnDoDrawUI)
	ON_UPDATE_COMMAND_UI(ID_DO_WAYPOINT	,OnDoPointUI)
	ON_UPDATE_COMMAND_UI(ID_FILE_OPEN	,OnOpenFileUI)
	ON_UPDATE_COMMAND_UI(ID_FILE_SAVE	,OnSaveFileUI)
	ON_UPDATE_COMMAND_UI(ID_FILE_SAVE_AS,OnSaveFileUI)
	ON_UPDATE_COMMAND_UI(ID_DO_MEASURE	,OnDoMeasureUI)
	ON_UPDATE_COMMAND_UI(ID_COORD_DEC	,OnCoordDecUI)
	ON_UPDATE_COMMAND_UI(ID_COORD_DEG	,OnCoordDegUI)
	ON_UPDATE_COMMAND_UI(ID_COORD_NSWE	,OnCoordDirUI)
	ON_UPDATE_COMMAND_UI(ID_SHOW_COORD	,OnShowCoordUI)
	ON_UPDATE_COMMAND_UI(ID_WHEEL_ZOOM	,OnWheelZoomUI)
	ON_UPDATE_COMMAND_UI(ID_WHEEL_SCROLL,OnWheelScrollUI)
	ON_UPDATE_COMMAND_UI(ID_HIEIGHTINFO	,OnHeightInfoUI)
	//}}AFX_MSG_MAP
	ON_UPDATE_COMMAND_UI_RANGE(ID_SHOWPATH1,ID_SHOWPATH8,OnShowPathUI)
	ON_COMMAND_RANGE(ID_SHOWPATH1,ID_SHOWPATH8,OnShowPath)
	ON_COMMAND_RANGE(ID_SERVER  ,ID_SERVER+99 ,OnServerChange)
	ON_COMMAND_RANGE(ID_LAYER   ,ID_LAYER +99 ,OnLayerChange)
	ON_COMMAND(ID_UPDATE_COORD				  ,OnCoordChange)
	ON_NOTIFY(OSM_NM_RECTDONE	,ID_OSM_MAP	  ,OnMapRectDone)
	ON_NOTIFY(OSM_NM_LINEDONE	,ID_OSM_MAP	  ,OnMapLineDone)
	ON_NOTIFY(OSM_NM_DRAWDONE	,ID_OSM_MAP	  ,OnPathChanged)
	ON_NOTIFY(OSM_NM_POINTDONE	,ID_OSM_MAP	  ,OnPathChanged)
	ON_NOTIFY(OSM_NM_DELDONE	,ID_OSM_MAP	  ,OnPathChanged)
	ON_NOTIFY(OSM_NM_DRAWSTART	,ID_OSM_MAP	  ,OnBeginnPath)
	ON_NOTIFY(OSM_NM_CHANGEMAP	,ID_OSM_MAP	  ,OnMapChange)
	ON_COMMAND(ID_FILE_PRINT,			CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT,	CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW,	CView::OnFilePrintPreview)
	ON_COMMAND(IDC_TEST,OnTest)
	ON_COMMAND(ID_GETINFO,OnInfo)
END_MESSAGE_MAP()


//*****************************************************************************
//*
//*		COsmViewerView
//*
//*****************************************************************************
//  COsmViewerView Konstruktion/Destruktion
COsmViewerView::COsmViewerView()
{
CString		sSrtm;
CRegKeys	sKey;	


	m_bOsmMenu		= TRUE;
	m_bFixedCache	= FALSE;
	m_bShowCoord	= FALSE;
	m_bSetWayPoint	= FALSE;
	m_iWayPoints	= 0;
	m_uWheeleMode	= 1;
	m_uCoordMode	= 0;				 
	m_iSrtmFlag		= 0;
	m_iOsmZoom		=-1;
	m_iOsmPosX		= 0;
	m_iOsmPosY		= 0;
	m_iZoom			= 0;

	sKey.Open();
	sKey.Get(sSrtm			,"SrtmPath");
	sKey.Get(m_uWheeleMode	,"WheelMode");
	sKey.Get(m_uCoordMode	,"CoordMode");
	sKey.Get(m_bShowCoord	,"ShowCoord");
	sKey.Get(m_bOsmMenu		,"OsmMenu");
	sKey.Get(m_iOsmZoom		,"OsmZoom");
	sKey.Get(m_iOsmPosX		,"OsmPosX");
	sKey.Get(m_iOsmPosY		,"OsmPosY");

	if(m_uCoordMode!=6 && m_uCoordMode!=10)
		{
		m_uCoordMode = 0;
		}

	UpdateServers();
	SrtmInit(sSrtm);

	memset(m_aPathLength,0,sizeof(m_aPathLength));

}

//*****************************************************************************
//*
//*		COsmViewerView
//*
//*****************************************************************************
COsmViewerView::~COsmViewerView()
{
CRegKeys	sKey;	

	
	SrtmExit();

	while(m_iSrtmFlag)
		{
		Sleep(20);
		}

	m_bOsmMenu		= m_cOsmWnd.HasMenu();
	m_uWheeleMode	= m_cOsmWnd.SetWheelMode(255);
	m_iOsmZoom		= m_cOsmWnd.GetZoom();

	m_cOsmWnd.GetScrollPos(m_iOsmPosX,m_iOsmPosY);

	sKey.Open();
	sKey.Set(m_uWheeleMode	,"WheelMode");
	sKey.Set(m_uCoordMode	,"CoordMode");
	sKey.Set(m_bShowCoord	,"ShowCoord");
	sKey.Set(m_bOsmMenu		,"OsmMenu");
	sKey.Set(m_iOsmZoom		,"OsmZoom");
	sKey.Set(m_iOsmPosX		,"OsmPosX");
	sKey.Set(m_iOsmPosY		,"OsmPosY");

}

//*****************************************************************************
//*
//*		PreCreateWindow
//*
//*****************************************************************************
BOOL COsmViewerView::PreCreateWindow(CREATESTRUCT &sCreate)
{

return CView::PreCreateWindow(sCreate);
}


//*****************************************************************************
//*
//*		Draw
//*
//*****************************************************************************
void _cdecl Draw(void *pParam,CDC *pDc,PAINTSTRUCT *pPaint)
{

	pDc->SelectStockObject(BLACK_PEN);
	pDc->SelectStockObject(DKGRAY_BRUSH);
	pDc->Rectangle(10,10,20,20);

}

//*****************************************************************************
//*
//*		OnCreate
//*
//*****************************************************************************
int COsmViewerView::OnCreate(LPCREATESTRUCT pCreateStruct) 
{
CRect		sRect(0,0,0,0);
unsigned	uFlags;


	
	if(CView::OnCreate(pCreateStruct)==-1)
		{
		return -1;
		}
	
	uFlags	= (m_bOsmMenu)? OSM_MENU:0;
	
	if(m_uWheeleMode==1)uFlags|=OSM_MOUSE_ZOOM;
	if(m_uWheeleMode==2)uFlags|=OSM_MOUSE_SCROLL;
	 	  	         
	if(m_iOsmZoom>=0)m_cOsmWnd.SetZoom(m_iOsmZoom);
	if(m_iOsmPosX || m_iOsmPosY)m_cOsmWnd.SetScrollPos(m_iOsmPosX,m_iOsmPosY);

	UpdateWayPoints();
	UpdatePathOptions();
	DragAcceptFiles(TRUE);

	m_cOsmWnd.Create(WS_CHILD|WS_VISIBLE|OSM_MOVE_R|OSM_MOVE_M|OSM_POINT_CHANGE|OSM_POINT_DELETE|uFlags,sRect,this,ID_OSM_MAP);
	m_cOsmWnd.SetAction(0,OSM_ACTION_MOVE);
	  	 	 
	SetClassLong(m_hWnd,GCLP_HBRBACKGROUND,(LPARAM)GetStockObject(NULL_BRUSH));
	SetTimer(IDC_UPDATE,250,NULL);
	
	m_sCoordDlg.Create(this);
	if(m_bShowCoord)m_sCoordDlg.ShowWindow(SW_SHOW);

	m_cOsmWnd.SetFocus();
	m_cOsmWnd.SetDrawCallback (DrawCallback ,this);
	m_cOsmWnd.SetMouseCallback(MouseCallback,this);
	m_cOsmWnd.SetPathMode(0,1);


return 0;
}

//*****************************************************************************
//*
//*		OnDraw
//*
//*****************************************************************************
//  COsmViewerView Zeichnen
void COsmViewerView::OnDraw(CDC *pDC)
{
COsmViewerDoc  *pDoc = GetDocument();


	ASSERT_VALID(pDoc);
}

//*****************************************************************************
//*
//*		OnPreparePrinting
//*
//*****************************************************************************
BOOL COsmViewerView::OnPreparePrinting(CPrintInfo *pInfo)
{

return DoPreparePrinting(pInfo);
}

//*****************************************************************************
//*
//*		OnBeginPrinting
//*
//*****************************************************************************
void COsmViewerView::OnBeginPrinting(CDC *pDC,CPrintInfo *pInfo)
{
	pInfo->SetMaxPage(1);
	pInfo->m_nNumPreviewPages = 1;
	m_cOsmWnd.DoCopy(0,&m_sPrintImg);

}

//*****************************************************************************
//*
//*		OnPrint
//*
//*****************************************************************************
void COsmViewerView::OnPrint(CDC *pDC,CPrintInfo* pInfo)
{
int		iScreenY;
int		iScreenX;
int		iOutputX;
int		iOutputY;
int		iStartX;
int		iStartY;
int		iSizeX;
int		iSizeY;
int		iEndX;
int		iEndY;
int		iPosX;
int		iPosY;


	if(!m_sPrintImg.IsOk())return;

	iSizeX   = m_sPrintImg.Width();
	iSizeY	 = m_sPrintImg.Height();
	iScreenX = pDC->GetDeviceCaps(HORZRES);				// Seiten Abmessungen
	iScreenY = pDC->GetDeviceCaps(VERTRES);


	iOutputX = iScreenX-PRINT_FRAME;					// Vollbild
	if(iOutputX<1)iOutputX=1;
	
	iOutputY = (iOutputX*iSizeY)/iSizeX;
	
	if(iOutputY+PRINT_FRAME>iScreenY)
		{
		   iOutputY=iScreenY-PRINT_FRAME;
		if(iOutputY<1)iOutputY=1;
		
		iOutputX = (iOutputY*iSizeX)/iSizeY;
		}


	iStartX	 = (iScreenX-iOutputX)>>1;					// Koordinaten berechnen
	iStartY	 = (iScreenY-iOutputY)>>1;
	
	if(iStartX<PRINT_FRAME/2)iStartX=PRINT_FRAME/2;
	if(iStartY<PRINT_FRAME/2)iStartY=PRINT_FRAME/2;
	
	iPosX	 = iStartX+iOutputX;
	iPosY	 = iStartY+iOutputY;
	iEndX	 = iStartX+iPosX+PRINT_FRAME*3;
	iEndY	 = iStartY+iPosY+PRINT_FRAME*3;

	SelectObject(pDC->m_hDC,GetStockObject(WHITE_BRUSH));
	SelectObject(pDC->m_hDC,GetStockObject(NULL_PEN));
	
	pDC->Rectangle(    0,    0  ,iEndX  +1,iStartY+1);
	pDC->Rectangle(    0,iPosY  ,iEndX  +1,iEndY  +1);
	pDC->Rectangle(    0,iStartY,iStartX+1,iPosY  +1);
	pDC->Rectangle(iPosX,iStartY,iEndX  +1,iPosY  +1);

	m_sPrintImg.StretchDIB(pDC->m_hDC,iStartX,iStartY,iOutputX,iOutputY);

}

//*****************************************************************************
//*
//*		OnEndPrinting
//*
//*****************************************************************************
void COsmViewerView::OnEndPrinting(CDC *pDC,CPrintInfo *pInfo)
{
	m_sPrintImg.Clear();
}

#ifdef		_DEBUG						

//*****************************************************************************
//*
//*		AssertValid
//*
//*****************************************************************************
void COsmViewerView::AssertValid() const
{
	CView::AssertValid();
}

//*****************************************************************************
//*
//*		Dump
//*
//*****************************************************************************
void COsmViewerView::Dump(CDumpContext &dc) const
{
	CView::Dump(dc);
}

//*****************************************************************************
//*
//*		GetDocument
//*
//*****************************************************************************
COsmViewerDoc *COsmViewerView::GetDocument()
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(COsmViewerDoc)));

return (COsmViewerDoc*)m_pDocument;
}
#endif 


//*****************************************************************************
//*
//*		OnTimer
//*
//*****************************************************************************
void COsmViewerView::OnTimer(UINT_PTR nIdEvent) 
{
double		dDistanceY;
double		dDistanceX;
double		dDistance;
double		dCoord1X;
double		dCoord1Y;
double		dCoord2X;
double		dCoord2Y;
double		dHeigh;
DWORD		dwThread;
HANDLE		hThread;
CPoint		sPoint;
CPoint		sPixel;
CWnd	   *pWnd;	
int			iLen;
int			iPos;
int			iOff;
int			iNum;



	if(nIdEvent==IDC_UPDATE)
		{
		if(m_cOsmWnd.GetAction()==OSM_ACTION_LINE)
			{
			m_cOsmWnd.GetXorRect(dCoord1X,dCoord1Y,dCoord2X,dCoord2Y);
			dDistance = DistanceOfPointsEx(dCoord1X*0.017453292519943295769236907684886,dCoord1Y*0.017453292519943295769236907684886,dCoord2X*0.017453292519943295769236907684886,dCoord2Y*0.017453292519943295769236907684886);
			iLen      = sprintf(m_aStatusText,"  Zoom=%i  Breite=%s  Lnge=%s  Entfernung=%.3fkm",m_cOsmWnd.GetZoom(),CoordText(dCoord2Y,1),CoordText(dCoord2X,0),dDistance*0.001);

			if(dDistance>0.5 && SrtmIsLoaded(dCoord1X,dCoord1Y)>0 && SrtmIsLoaded(dCoord2X,dCoord2Y)>0)
				{
				dHeigh  = SrtmGetHeight(dCoord2X,dCoord2Y);
				dHeigh -= SrtmGetHeight(dCoord1X,dCoord1Y);
				iLen   += sprintf(m_aStatusText+iLen,"  Delta=%4.1fm (%2.1f%%)",dHeigh,fabs(dHeigh/dDistance)*100.0);
				}

			AfxGetMainWnd()->PostMessage(ID_SETSTATUSBAR,0,(LPARAM)m_aStatusText);
			}
		else if(m_cOsmWnd.GetAction()==OSM_ACTION_RECT)
			{
			m_cOsmWnd.GetXorRect(dCoord1X,dCoord1Y,dCoord2X,dCoord2Y);
			dDistanceX = DistanceOfPointsEx(dCoord1X*0.017453292519943295769236907684886,dCoord1Y*0.017453292519943295769236907684886,dCoord2X*0.017453292519943295769236907684886,dCoord1Y*0.017453292519943295769236907684886);
			dDistanceY = DistanceOfPointsEx(dCoord1X*0.017453292519943295769236907684886,dCoord1Y*0.017453292519943295769236907684886,dCoord1X*0.017453292519943295769236907684886,dCoord2Y*0.017453292519943295769236907684886);
			iLen       = sprintf(m_aStatusText,"  Breite=%s  Lnge=%s  Breite=%.3fkm  Hhe=%.3fkm",CoordText(dCoord2Y,1),CoordText(dCoord2X,0),dDistanceX*0.001,dDistanceY*0.001);

			AfxGetMainWnd()->PostMessage(ID_SETSTATUSBAR,0,(LPARAM)m_aStatusText);
			}
		else{
			GetCursorPos(&sPoint);

			sPixel = sPoint;
			m_cOsmWnd.ScreenToClient(&sPixel);
			pWnd = CWnd::WindowFromPoint(sPoint); 

			if(m_cOsmWnd.PtInClientRect(&sPixel) && pWnd && pWnd->m_hWnd==m_cOsmWnd.m_hWnd)
				{
				m_cOsmWnd.PixelToCoord(sPixel.x,sPixel.y,dCoord1X,dCoord1Y);
				iLen = sprintf(m_aStatusText,"  Zoom=%i  Breite=%s  Lnge=%s",m_cOsmWnd.GetZoom(),CoordText(dCoord1Y,1),CoordText(dCoord1X,0));

				if(SrtmIsLoaded(dCoord1X,dCoord1Y)>0)
					{
					dHeigh = SrtmGetHeight(dCoord1X,dCoord1Y);
					iLen  += sprintf(m_aStatusText+iLen,"   %4.1fm",dHeigh);
					}
				else if(!m_iSrtmFlag)
					{
					m_iStrmCoordX	= dCoord1X;
					m_iStrmCoordY	= dCoord1Y;
					m_iSrtmFlag		= 1;
					hThread			= CreateThread(NULL,0x20000,SrtmThread,this,0,&dwThread);
					CloseHandle(hThread);
					}
				}
			else if(m_aStatusText[0])
				{
				m_aStatusText[0] = 0;
				iLen			 = 0;
				}
			else{
				goto Done;
				}				 

			for(iPos=7,iNum=0;iPos>=0;iPos--)			// Suche einzelnen Pfad
				{
				if(m_cOsmWnd.GetPathVisible(iPos)==0)continue;
				if(m_cOsmWnd.GetPathPoints (iPos)==0)continue;
				iOff=iPos;
				iNum++;
				}

			if(iNum==1)
				{
				iLen+=sprintf(m_aStatusText+iLen,"  Pfad=%.3fkm",m_aPathLength[iOff]*0.001);
				}

			AfxGetMainWnd()->PostMessage(ID_SETSTATUSBAR,0,(LPARAM)m_aStatusText);
			}

Done:	

		if(m_bShowCoord)								// Koordiantendialog sichtbar
			{
			if(m_sCoordDlg.IsWindowVisible())
				{
				m_cOsmWnd.GetScrollPos(sPoint);
				m_cOsmWnd.PosToCoord(sPoint.x,sPoint.y,dCoord1X,dCoord1Y);
				m_sCoordDlg.Set(dCoord1X,dCoord1Y,m_cOsmWnd.GetZoom(),m_uCoordMode);
				}
			else{
				m_bShowCoord = FALSE;
				}
			}

		
		return;
		}
	
	CView::OnTimer(nIdEvent);
}

//*****************************************************************************
//*
//*		OnSize
//*
//*****************************************************************************
void COsmViewerView::OnSize(UINT nType,int iSizeX,int iSizeY) 
{
			  
	if(iSizeX && iSizeY)
		{
		SizeWindow(&m_cOsmWnd,iSizeX,iSizeY);
		}
	
	CView::OnSize(nType,iSizeX,iSizeY);
	
}

//*****************************************************************************
//*
//*		OnSetFocus
//*
//*****************************************************************************
void COsmViewerView::OnSetFocus(CWnd *pOldWnd)
{

	m_cOsmWnd.SetFocus();

}

//*****************************************************************************
//*
//*		OnOsmMenuUI
//*
//*****************************************************************************
void COsmViewerView::OnOsmMenuUI(CCmdUI *pCmdUI)
{

	pCmdUI->SetCheck(m_cOsmWnd.HasMenu());

}

//*****************************************************************************
//*
//*		OnOsmMenu
//*
//*****************************************************************************
void COsmViewerView::OnOsmMenu()
{

	m_cOsmWnd.ShowMenu(!m_cOsmWnd.HasMenu());

}

//*****************************************************************************
//*
//*		OnCopy
//*
//*****************************************************************************
void COsmViewerView::OnCopy() 
{
	
	m_cOsmWnd.DoCopy(0);

}

//*****************************************************************************
//*
//*		OnDualMode
//*
//*****************************************************************************
void COsmViewerView::OnDualMode() 
{
	
	m_cOsmWnd.SetDual(-1);

}

//*****************************************************************************
//*
//*		OnDualModeUI
//*
//*****************************************************************************
void COsmViewerView::OnDualModeUI(CCmdUI *pCmdUI)
{

	pCmdUI->SetCheck(m_cOsmWnd.GetDual());

}

//*****************************************************************************
//*
//*		OnWheel...
//*
//*****************************************************************************
void COsmViewerView::OnWheelScrollUI(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(m_cOsmWnd.SetWheelMode(255)==2);
}

void COsmViewerView::OnWheelZoomUI(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(m_cOsmWnd.SetWheelMode(255)==1);
}

void COsmViewerView::OnWheelScroll()
{
	m_cOsmWnd.SetWheelMode(2);
}

void COsmViewerView::OnWheelZoom()
{
	m_cOsmWnd.SetWheelMode(1);
}

//*****************************************************************************
//*
//*		OnDo...UI
//*
//*****************************************************************************
void COsmViewerView::OnDoMeasureUI(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(!m_bSetWayPoint && m_cOsmWnd.GetAction(0)==OSM_ACTION_LINE);
}
void COsmViewerView::OnDoMoveUI(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(!m_bSetWayPoint && m_cOsmWnd.GetAction(0)==OSM_ACTION_MOVE);
}
void COsmViewerView::OnDoCopyUI(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(!m_bSetWayPoint && m_cOsmWnd.GetAction(0)==OSM_ACTION_RECT);
}
void COsmViewerView::OnDoDrawUI(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(!m_bSetWayPoint && m_cOsmWnd.GetAction(0)==OSM_ACTION_DRAW);
}
void COsmViewerView::OnDoPointUI(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(m_bSetWayPoint);
}

//*****************************************************************************
//*
//*		OnCoord...
//*
//*****************************************************************************
void COsmViewerView::OnCoordDecUI(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(m_uCoordMode==0);
}
void COsmViewerView::OnCoordDegUI(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(m_uCoordMode==6);
}
void COsmViewerView::OnCoordDirUI(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(m_uCoordMode==10);
}
void COsmViewerView::OnCoordDec()
{
	m_uCoordMode=0;
}
void COsmViewerView::OnCoordDeg()
{
	m_uCoordMode=6;
}

void COsmViewerView::OnCoordDir()
{
	m_uCoordMode=10;
}


//*****************************************************************************
//*
//*		OnOpenFileUI
//*
//*****************************************************************************
void COsmViewerView::OnOpenFileUI(CCmdUI *pCmdUI)
{
unsigned	uPos;


	for(uPos=1;uPos<8;uPos++)
		{
		if(m_cOsmWnd.GetPathPoints(uPos)==0)break;
		}
	
	pCmdUI->Enable(uPos<8);

}

//*****************************************************************************
//*
//*		OnSaveFileUI
//*
//*****************************************************************************
void COsmViewerView::OnSaveFileUI(CCmdUI *pCmdUI)
{

	pCmdUI->Enable(m_cOsmWnd.HasPathChanged(0));

}

//*****************************************************************************
//*
//*		OnShowCoordUI
//*
//*****************************************************************************
void COsmViewerView::OnShowCoordUI(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(m_sCoordDlg.IsWindowVisible());
}

//*****************************************************************************
//*
//*		OnShowCoord
//*
//*****************************************************************************
void COsmViewerView::OnShowCoord()
{

	m_bShowCoord = !m_sCoordDlg.IsWindowVisible();
	m_sCoordDlg.ShowWindow((m_bShowCoord)? SW_SHOW:SW_HIDE);
	m_cOsmWnd.SetFocus();
	

}
//*****************************************************************************
//*
//*		OnHeightInfoUI
//*
//*****************************************************************************
void COsmViewerView::OnHeightInfoUI(CCmdUI *pCmdUI)
{
int		iPos;

	for(iPos=0;iPos<OSM_PATHS;iPos++)
		{
		if(m_cOsmWnd.GetPathPoints(iPos)>0)break;
		}


	pCmdUI->Enable(iPos<OSM_PATHS);
}

//*****************************************************************************
//*
//*		OnHeightInfo
//*
//*****************************************************************************
//	Dialog mit Hhendaten anzeigen
void COsmViewerView::OnHeightInfo()
{
LPCTSTR		pTxt;
CString		sTxt;
CHeightDlg	sDlg;	
CListDlg	sList;
int			iFirst;
int			iNum;
int			iPos;
int			iErr;


	iFirst = -1;
	iNum   =  0;

	for(iPos=0;iPos<OSM_PATHS;iPos++)						// Pfade suchen
		{
		if(m_cOsmWnd.GetPathPoints(iPos)<=0)continue;
		if(iFirst<0)iFirst=iPos;

		sTxt.Format(_T("%u / "),iPos+1);
		pTxt  = GetPathFile(iPos);
		sTxt += GetFileName(pTxt);
		if(sTxt.GetLength()>4)sTxt += _T(" / ");
		sTxt += GetPathName(iPos);
		if(sTxt.GetLength()<=4 && iPos==0)sTxt+=_T("Lokaler Pfad");
		
		sList.AddString(iPos,sTxt,TRUE);

		iNum++;
		}

	if(iNum<=0)return;

	if(iNum>1)
		{													// Mehr als ein Pfad vorhanden
		sList.SetTitle(_T("Pfadauswahl"));
		sList.SetMode(2);

		if(sList.DoModal()!=IDOK)
			{
			return;
			}

		iFirst = sList.GetSelect();
		iFirst = sList.GetData(iFirst);
		}


	iErr			= 0;
	iNum			= m_cOsmWnd.GetPathPoints(iFirst);
	sDlg.m_pRoute	= new RouteData[iNum+1];
	sDlg.m_iCount	= iNum;

	memset(sDlg.m_pRoute,0,sizeof(RouteData)*iNum);


	for(iPos=0;iPos<iNum;iPos++)							// Die Koordinaten holen
		{
		GetPathPointEx(iFirst,sDlg.m_pRoute[iPos].dCoordX,sDlg.m_pRoute[iPos].dCoordY,iPos);
		sDlg.m_pRoute[iPos].dCoordZ = SrtmGetHeight(sDlg.m_pRoute[iPos].dCoordX,sDlg.m_pRoute[iPos].dCoordY);
		if(sDlg.m_pRoute[iPos].dCoordZ<=-10000.0)iErr++;
		}

	if(iErr>=iNum)
		{
		MessageBox("Es gab einen Fehler beim holen der Hhendaten","Fehler",MB_OK|MB_ICONERROR);
		}
	else{
		sDlg.DoModal();
		}

	
	
	delete sDlg.m_pRoute;


}

//*****************************************************************************
//*
//*		OnDoPoint
//*
//*****************************************************************************
void COsmViewerView::OnDoPoint()
{
	m_bSetWayPoint = TRUE;
}


//*****************************************************************************
//*
//*		OnDoMeasure
//*
//*****************************************************************************
void COsmViewerView::OnDoMeasure()
{
	m_bSetWayPoint = FALSE;
	m_cOsmWnd.SetAction(0,OSM_ACTION_LINE);
}

//*****************************************************************************
//*
//*		OnDoMove
//*
//*****************************************************************************
void COsmViewerView::OnDoMove()
{
	m_bSetWayPoint = FALSE;
	m_cOsmWnd.SetAction(0,OSM_ACTION_MOVE);
}

//*****************************************************************************
//*
//*		OnDoCopy
//*
//*****************************************************************************
void COsmViewerView::OnDoCopy()
{
	m_bSetWayPoint = FALSE;
	m_cOsmWnd.SetAction(0,OSM_ACTION_RECT);
}

//*****************************************************************************
//*
//*		OnDoDraw
//*
//*****************************************************************************
void COsmViewerView::OnDoDraw()
{
	m_bSetWayPoint = FALSE;
	m_cOsmWnd.SetAction(0,OSM_ACTION_DRAW);
}

//*****************************************************************************
//*
//*		OnMapRectDone
//*
//*****************************************************************************
void COsmViewerView::OnMapRectDone(NMHDR *pNmHdr,LRESULT *pResult)
{
OSM_NOTIFY *pNotify=(OSM_NOTIFY*)pNmHdr;


	m_cOsmWnd.SetAction(0,OSM_ACTION_MOVE);

	if(!pNotify->iMode)m_cOsmWnd.DoCopy(1);
			
}

//*****************************************************************************
//*
//*		OnBeginnPath
//*
//*****************************************************************************
void COsmViewerView::OnBeginnPath(NMHDR *pNmHdr,LRESULT *pResult)
{
COsmViewerDoc	*pDoc;


		pDoc = GetDocument();
	if(!pDoc)return;

	pDoc->ClearPathName();
			
}

//*****************************************************************************
//*
//*		OnPathChanged
//*
//*****************************************************************************
void COsmViewerView::OnPathChanged(NMHDR *pNmHdr,LRESULT *pResult)
{
OSM_NOTIFY *pNotify=(OSM_NOTIFY*)pNmHdr;
int			iPos1X;
int			iPos1Y;
int			iPos2X;
int			iPos2Y;
int			iPath;


	   iPath = pNotify->iIndex;
	if(iPath<0 || iPath>=8)return;

	if(pNotify->iMode==2 && m_cOsmWnd.GetPathPoints(iPath)==3)
		{
		m_cOsmWnd.GetPathPoint(iPath,iPos1X,iPos1Y,0);
		m_cOsmWnd.GetPathPoint(iPath,iPos2X,iPos2Y,1);

		if(iPos1X==iPos2X && iPos1Y==iPos2Y)			// Doppelten ersten Punkt lschen
			{
			m_cOsmWnd.DelPathPoint(iPath,0);
			}
		}

	m_aPathLength[iPath] = m_cOsmWnd.GetPathLength(iPath);

			
}

//*****************************************************************************
//*
//*		OnMapLineDone
//*
//*****************************************************************************
void COsmViewerView::OnMapLineDone(NMHDR *pNmHdr,LRESULT *pResult)
{
OSM_NOTIFY *pNotify=(OSM_NOTIFY*)pNmHdr;


}

//*****************************************************************************
//*
//*		OnMapChange
//*
//*****************************************************************************
void COsmViewerView::OnMapChange(NMHDR *pNmHdr,LRESULT *pResult)
{
OSM_NOTIFY *pNotify=(OSM_NOTIFY*)pNmHdr;
CPoint		sPoint;
CMenu		sMemu;
int			iPos;


	sMemu.CreatePopupMenu();

	for(iPos=0;iPos<m_sServerNames.Count();iPos++)
		{
		sMemu.AppendMenu((m_sServerNames.DataGet(iPos))? MF_CHECKED|MF_STRING:MF_STRING,ID_SERVER+iPos,m_sServerNames[iPos]);
		}

	if(m_sLayerNames.Count())
		{
		sMemu.AppendMenu(MF_SEPARATOR);

		for(iPos=0;iPos<m_sLayerNames.Count();iPos++)
			{
			sMemu.AppendMenu((m_sLayerNames.DataGet(iPos))? MF_CHECKED|MF_STRING:MF_STRING,ID_LAYER+iPos,m_sLayerNames[iPos]);
			}
		}				

	GetCursorPos  (&sPoint);
//	ScreenToClient(&sPoint);
				   						
	sMemu.TrackPopupMenu(TPM_LEFTALIGN,sPoint.x,sPoint.y,this);
	sMemu.DestroyMenu();
			
}

//*****************************************************************************
//*
//*		OnReload
//*
//*****************************************************************************
//	Die Ansicht neu laden
void COsmViewerView::OnReload()
{

	m_cOsmWnd.Reload();

}

//*****************************************************************************
//*
//*		SrtmThread
//*
//*****************************************************************************
//	Thread zum Nachladen von SRTM-Dateien
DWORD WINAPI COsmViewerView::SrtmThread(LPVOID pParam)
{
COsmViewerView 	*pThis=(COsmViewerView*)pParam;
	
	SrtmGetHeight(pThis->m_iStrmCoordX,pThis->m_iStrmCoordY);
	pThis->m_iSrtmFlag = 0;

return 0;
}

//*****************************************************************************
//*
//*		ClearCache
//*
//*****************************************************************************
int _cdecl COsmViewerView::ClearCache(CProgressDlg *pDlg)
{
COsmCtrl	*pOsmCtrl=(COsmCtrl*)pDlg->GetVoid1();

return pOsmCtrl->ClearCache();
}

//*****************************************************************************
//*
//*		OnClearCache
//*
//*****************************************************************************
//	Alle Cache-Dateien lschen
void COsmViewerView::OnClearCache()
{
CProgressDlg	sDlg;

	
	sDlg.SetProc(ClearCache,&m_cOsmWnd);
	sDlg.SetTitle(_T("Cache lschen"));
	sDlg.SetProgressMode(500);
	sDlg.HideCancel();
	sDlg.DoModal();
	

}


//*****************************************************************************
//*
//*		OnCopyCoord
//*
//*****************************************************************************
//	Die Koordinarten eines Ortes kopieren
void COsmViewerView::OnCopyCoord()
{
char		cText[128];
double		dCoordX;
double		dCoordY;
CPoint		sPoint;


	GetCursorPos(&sPoint);

	m_cOsmWnd.ScreenToClient(&sPoint);
	m_cOsmWnd.PixelToCoord(sPoint.x,sPoint.y,dCoordX,dCoordY);
	sprintf(cText,"%.6f,\t%.6f,\t",dCoordY,dCoordX);
	SetClipboardText(cText);


}

//*****************************************************************************
//*
//*		CoordText
//*
//*****************************************************************************
const char *COsmViewerView::CoordText(double dCoord,int iSel)
{
char	*pBuffer;


	pBuffer	= m_aCoordBuffer+32*(m_lCoordIndex&7);

	InterlockedIncrement(&m_lCoordIndex);


return CoordToText(dCoord,m_uCoordMode+iSel,pBuffer);
}

//*****************************************************************************
//*
//*		OnShowPathUI
//*
//*****************************************************************************
void COsmViewerView::OnShowPathUI(CCmdUI *pCmdUI)
{
unsigned	uItem;


	uItem = pCmdUI->m_nID-ID_SHOWPATH1;

	pCmdUI->Enable  (m_cOsmWnd.GetPathPoints (uItem)>0);
	pCmdUI->SetCheck(m_cOsmWnd.GetPathVisible(uItem) && m_cOsmWnd.GetPathPoints(uItem)>0);

}

//*****************************************************************************
//*
//*		OnShowPath
//*
//*****************************************************************************
void COsmViewerView::OnShowPath(UINT nId)
{

	nId -= ID_SHOWPATH1;

	if(m_cOsmWnd.GetPathPoints(nId)>0)
		{
		m_cOsmWnd.SetPathVisible(nId,!m_cOsmWnd.GetPathVisible(nId));
		}

}

//*****************************************************************************
//*
//*		OnServerChange
//*
//*****************************************************************************
void COsmViewerView::OnServerChange(UINT nId)
{
CRegKeys	sKey;	
int			iPos;


	   iPos = nId-ID_SERVER;
	if(iPos>=m_sServerNames.Count())
		{
		return;
		}

	sKey.Open();
	sKey.Up(_T("Server"));
	sKey.Set(iPos,_T("Select"));

	UpdateServers();

}

//*****************************************************************************
//*
//*		OnLayerChange
//*
//*****************************************************************************
void COsmViewerView::OnLayerChange(UINT nId)
{
CRegKeys	sKey;	
CString		sName;
int			iPos;


	   iPos = nId-ID_LAYER;
	if(iPos>=m_sLayerNames.Count())
		{
		return;
		}

	sName.Format(_T("Select%02i"),iPos);
	sKey.Open();
	sKey.Up(_T("Layer"));
	sKey.Set(!m_sLayerNames.DataGet(iPos),sName);

	UpdateServers();

}


//*****************************************************************************
//*
//*		OnCoordChange
//*
//*****************************************************************************
void COsmViewerView::OnCoordChange()
{

	m_cOsmWnd.SetZoom(m_sCoordDlg.m_iZoom);
	m_cOsmWnd.SetScrollCoord(m_sCoordDlg.m_dCoordX,m_sCoordDlg.m_dCoordY);

}

//*****************************************************************************
//*
//*		UpdateServers
//*
//*****************************************************************************
void COsmViewerView::UpdateServers(LPCTSTR pSelect)
{
CString		sName;
CString		sText;
CString		sPath;
CString		sInfo;
CRegKeys	sKey;
LPCTSTR		pPath;
BOOL		bFixed;
unsigned	uInter;
double		dVal1X;
double		dVal2X;
double		dVal1Y;
double		dVal2Y;
int			iVal1X;
int			iVal2X;
int			iVal1Y;
int			iVal2Y;
int			iPort;	
int			iSel;
int			iRow;
int			iPos;
int			iOff;
int			iNum;



	sKey.Open();
	sKey.Up(_T("Server"));
	
	if(!sKey.Get(sText,_T("Name00")))						// Standart-Server eintragen
		{
		sKey.Down();
		sKey.DelKey(_T("Server"));
		sKey.Up(    _T("Server"));
		sKey.Set(0, _T("Select"));


		sKey.Set(_T("c.tile.openstreetmap.org")	,_T("Name00"));

		sKey.Set(_T("Mapic"								)	,_T("Name00"	));
		sKey.Set(_T("Cycle"								)	,_T("Name01"	));
		sKey.Set(_T("Transport"							)	,_T("Name02"	));
		sKey.Set(_T("Type-B"							)	,_T("Name03"	));
		sKey.Set(_T("Outdoors"							)	,_T("Name04"	));
		sKey.Set(_T("HikeBike"							)	,_T("Name05"	));
		sKey.Set(_T("WaterColor"						)	,_T("Name06"	));
		sKey.Set(_T("Tilegen"							)	,_T("Name07"	));
		sKey.Set(_T("Comic"								)	,_T("Name08"	));
		sKey.Set(_T("TopoMap"							)	,_T("Name09"	));
		sKey.Set(_T("Toner"								)	,_T("Name10"	));
		sKey.Set(_T("Esri"								)	,_T("Name11"	));
		sKey.Set(_T("Esri Gray"							)	,_T("Name12"	));
		sKey.Set(_T("Physical"							)	,_T("Name13"	));
		sKey.Set(_T("Satellite"							)	,_T("Name14"	));
		sKey.Set(_T("Relief"							)	,_T("Name15"	));
		sKey.Set(_T("Esri Topo"							)	,_T("Name16"	));
		sKey.Set(_T("Yandex"							)	,_T("Name17"	));
		sKey.Set(_T("BbBike"							)	,_T("Name18"	));
		sKey.Set(_T("Komoot"							)	,_T("Name19"	));
		sKey.Set(_T("GeoFabrik"							)	,_T("Name20"	));
		sKey.Set(_T("Hybrid"							)	,_T("Name21"	));
		sKey.Set(_T("Winter"							)	,_T("Name22"	));
		
		sKey.Set(_T("c.tile.openstreetmap.org"			)	,_T("Server00"	));
		sKey.Set(_T("c.tile.thunderforest.com"			)	,_T("Server01"	));
		sKey.Set(_T("c.tile.thunderforest.com"			)	,_T("Server02"	));
		sKey.Set(_T("b.tile.openstreetmap.org"			)	,_T("Server03"	));
		sKey.Set(_T("a.tile.thunderforest.com"			)	,_T("Server04"	));
		sKey.Set(_T("a.tiles.wmflabs.org"				)	,_T("Server05"	));
		sKey.Set(_T("tile.stamen.com"					)	,_T("Server06"	));
		sKey.Set(_T("tile.memomaps.de"					)	,_T("Server07"	));
		sKey.Set(_T("a.tiles.mapbox.com"				)	,_T("Server08"	));
		sKey.Set(_T("a.tiles.wmflabs.org"				)	,_T("Server09"	));
		sKey.Set(_T("c.tile.stamen.com"					)	,_T("Server10"	));
		sKey.Set(_T("server.arcgisonline.com"			)	,_T("Server11"	));
		sKey.Set(_T("server.arcgisonline.com"			)	,_T("Server12"	));
		sKey.Set(_T("server.arcgisonline.com"			)	,_T("Server13"	));
		sKey.Set(_T("server.arcgisonline.com"			)	,_T("Server14"	));
		sKey.Set(_T("server.arcgisonline.com"			)	,_T("Server15"	));
		sKey.Set(_T("server.arcgisonline.com"			)	,_T("Server16"	));
		sKey.Set(_T("vec02.maps.yandex.net"				)	,_T("Server17"	));
		sKey.Set(_T("a.tile.thunderforest.com"			)	,_T("Server18"	));
		sKey.Set(_T("c.tile.hosted.thunderforest.com"	)	,_T("Server19"	));
		sKey.Set(_T("c.tile.geofabrik.de"				)	,_T("Server20"	));
		sKey.Set(_T("b.tiles.mapbox.com"				)	,_T("Server21"	));
		sKey.Set(_T("m4.mapserver.mapy.cz"				)	,_T("Server22"	));
				
		sKey.Set(_T(""																	)	,_T("Path00"	));
		sKey.Set(_T("cycle/*.png?apikey=6170aad10dfd42a38d4d8c709a536f38"				)	,_T("Path01"	));
		sKey.Set(_T("transport/*.png?apikey=6170aad10dfd42a38d4d8c709a536f38"			)	,_T("Path02"	));
		sKey.Set(_T(""																	)	,_T("Path03"	));
		sKey.Set(_T("outdoors/*.png?apikey=7c352c8ff1244dd8b732e349e0b0fe8d"			)	,_T("Path04"	));
		sKey.Set(_T("hikebike"															)	,_T("Path05"	));
		sKey.Set(_T("watercolor/*.jpg"													)	,_T("Path06"	));
		sKey.Set(_T("tilegen"															)	,_T("Path07"	));
		sKey.Set(_T("v3/examples.bc17bb2a"												)	,_T("Path08"	));
		sKey.Set(_T("hillshading"														)	,_T("Path09"	));
		sKey.Set(_T("toner"																)	,_T("Path10"	));
		sKey.Set(_T("ArcGIS/rest/services/World_Street_Map/MapServer/tile"				)	,_T("Path11"	));
		sKey.Set(_T("ArcGIS/rest/services/Canvas/World_Light_Gray_Base/MapServer/tile"	)	,_T("Path12"	));
		sKey.Set(_T("ArcGIS/rest/services/World_Physical_Map/MapServer/tile"			)	,_T("Path13"	));
		sKey.Set(_T("ArcGIS/rest/services/World_Imagery/MapServer/tile"					)	,_T("Path14"	));
		sKey.Set(_T("ArcGIS/rest/services/World_Shaded_Relief/MapServer/tile"			)	,_T("Path15"	));
		sKey.Set(_T("ArcGIS/rest/services/World_Topo_Map/MapServer/tile"				)	,_T("Path16"	));
		sKey.Set(_T("tiles?l=map&v=2.2.3"												)	,_T("Path17"	));
		sKey.Set(_T("landscape/*.png?apikey=6170aad10dfd42a38d4d8c709a536f38"			)	,_T("Path18"	));
		sKey.Set(_T("komoot-2"															)	,_T("Path19"	));
		sKey.Set(_T("15173cf79060ee4a66573954f6017ab0"									)	,_T("Path20"	));
		sKey.Set(_T("v3/tmcw.map-j5fsp01s"												)	,_T("Path21"	));
		sKey.Set(_T("winter-m"															)	,_T("Path22"	));
				
		sKey.Set( "0",_T("ZoomMin09"));
		sKey.Set("15",_T("ZoomMax09"));
		sKey.Set( "0",_T("ZoomMin12"));
		sKey.Set("16",_T("ZoomMax12"));
		sKey.Set( "0",_T("ZoomMin13"));
		sKey.Set( "8",_T("ZoomMax13"));	
		sKey.Set( "0",_T("ZoomMin14"));
		sKey.Set("20",_T("ZoomMax14"));	
		sKey.Set( "0",_T("ZoomMin15"));
		sKey.Set("13",_T("ZoomMax15"));	
		sKey.Set( "0",_T("ZoomMin16"));
		sKey.Set("19",_T("ZoomMax16"));	
		sKey.Set( "0",_T("ZoomMin20"));
		sKey.Set("19",_T("ZoomMax20"));	
		
		sKey.Set( 1,_T("Interface11"));	
		sKey.Set( 1,_T("Interface12"));	
		sKey.Set( 1,_T("Interface13"));	
		sKey.Set( 1,_T("Interface14"));	
		sKey.Set( 1,_T("Interface15"));	
		sKey.Set( 1,_T("Interface16"));	
		sKey.Set( 2,_T("Interface17"));	
		sKey.Set( 3,_T("Interface22"));	
		
		sKey.Down();
		sKey.DelKey("Layer");
		sKey.Up("Layer");

		sKey.Set(_T("Topologie"							)	,_T("Name00"	));
		sKey.Set(_T("Topologie (strker)"				)	,_T("Name01"	));
		sKey.Set(_T("Wanderwege"						)	,_T("Name02"	));
		sKey.Set(_T("Radwege"							)	,_T("Name03"	));
		sKey.Set(_T("Wanderwege 2"						)	,_T("Name04"	));
		sKey.Set(_T("MTB Wege"							)	,_T("Name05"	));
		sKey.Set(_T("Esri Places"						)	,_T("Name06"	));
		sKey.Set(_T("Mapic transparent"					)	,_T("Name07"	));
		sKey.Set(_T("Transport transparent"				)	,_T("Name08"	));
		sKey.Set(_T("Straen"							)	,_T("Name09"	));
		sKey.Set(_T("Straen 2"							)	,_T("Name10"	));
		sKey.Set(_T("Hhenlinien"						)	,_T("Name11"	));

		sKey.Set(_T("a.tiles.wmflabs.org"				)	,_T("Server00"	));
		sKey.Set(_T("a.tiles.wmflabs.org"				)	,_T("Server01"	));
		sKey.Set(_T("tile.waymarkedtrails.org"			)	,_T("Server02"	));
		sKey.Set(_T("tile.lonvia.de"					)	,_T("Server03"	));
		sKey.Set(_T("tile.lonvia.de"					)	,_T("Server04"	));
		sKey.Set(_T("tile.waymarkedtrails.org"			)	,_T("Server05"	));
		sKey.Set(_T("server.arcgisonline.com"			)	,_T("Server06"	));
		sKey.Set(_T("c.tile.openstreetmap.org"			)	,_T("Server07"	));
		sKey.Set(_T("c.tile.thunderforest.com"			)	,_T("Server08"	));
		sKey.Set(_T("a.tiles.mapbox.com"				)	,_T("Server09"	));
		sKey.Set(_T("server.arcgisonline.com"			)	,_T("Server10"	));
		sKey.Set(_T("c.tiles.mapbox.com"				)	,_T("Server11"	));
		
		sKey.Set(_T("hillshading"						)	,_T("Path00"	));
		sKey.Set(_T("hillshading"						)	,_T("Path01"	));
		sKey.Set(_T("hiking"							)	,_T("Path02"	));
		sKey.Set(_T("lonvia"							)	,_T("Path03"	));					   
		sKey.Set(_T("lonvia"							)	,_T("Path04"	));					   
		sKey.Set(_T("waymarkedtrails"					)	,_T("Path05"	));
		sKey.Set(_T("ArcGIS/rest/services/Reference/World_Boundaries_and_Places/MapServer/tile/*.jpg")	,_T("Path06"	));
		sKey.Set(_T(""																				 )	,_T("Path07"	));
		sKey.Set(_T("transport/*.png?apikey=6170aad10dfd42a38d4d8c709a536f38"					     )	,_T("Path08"	));
		sKey.Set(_T("v4/digitalglobe.nakolk5j/*.jpg?access_token=pk.eyJ1IjoibWFya3VzNTEiLCJhIjoiY2pvN3BqdHp4MDM5ZzNxcGNlY2E1OWQ1cSJ9.Z-6n_qUB3eByTLIYu9oX-w")	,_T("Path09"	));
		sKey.Set(_T("ArcGIS/rest/services/Reference/World_Transportation/MapServer/tile"																	  )	,_T("Path10"	));
		sKey.Set(_T("v4/heyitsgarrett.kf2a2nb1/*.png?access_token=pk.eyJ1IjoiaGV5aXRzZ2FycmV0dCIsImEiOiIwdWt5ZlpjIn0.73b7Y47rgFnSD7QCNeS-zA"				  ) ,_T("Path11"	));
		
		sKey.Set(_T("0"									)	,_T("AlphaOff00"));
		sKey.Set(_T("0"									)	,_T("AlphaOff01"));
		sKey.Set(_T("0"									)	,_T("AlphaOff02"));
		sKey.Set(_T("0"									)	,_T("AlphaOff03"));
		sKey.Set(_T("0"									)	,_T("AlphaOff04"));
		sKey.Set(_T("0"									)	,_T("AlphaOff05"));
		sKey.Set(_T("0"									)	,_T("AlphaOff06"));
		sKey.Set(_T("1"									)	,_T("AlphaOff07"));
		sKey.Set(_T("1"									)	,_T("AlphaOff08"));
		sKey.Set(_T("0"									)	,_T("AlphaOff09"));
		sKey.Set(_T("0"									)	,_T("AlphaOff10"));

		sKey.Set(_T("120"								)	,_T("AlphaMul00"));
		sKey.Set(_T("0"									)	,_T("AlphaMul01"));
		sKey.Set(_T("0"									)	,_T("AlphaMul02"));
		sKey.Set(_T("0"									)	,_T("AlphaMul03"));
		sKey.Set(_T("0"									)	,_T("AlphaMul04"));
		sKey.Set(_T("0"									)	,_T("AlphaMul05"));
		sKey.Set(_T("0"									)	,_T("AlphaMul06"));
		sKey.Set(_T("0"									)	,_T("AlphaMul07"));
		sKey.Set(_T("0"									)	,_T("AlphaMul08"));
		sKey.Set(_T("150"								)	,_T("AlphaMul09"));
		sKey.Set(_T("0"									)	,_T("AlphaMul10"));

		sKey.Set(_T("GRAY 0x0F000000"					)	,_T("Info00"	));
		sKey.Set(_T("GRAY 0x0F000000"					)	,_T("Info01"	));
		sKey.Set(_T(""									)	,_T("Info02"	));
		sKey.Set(_T(""									)	,_T("Info03"	));
		sKey.Set(_T(""									)	,_T("Info04"	));
		sKey.Set(_T(""									)	,_T("Info05"	));
		sKey.Set(_T(""									)	,_T("Info06"	));
		sKey.Set(_T("0xF1EEE8 0xECDDC9 0x3BB551 0xCEECA8 0xB5E2B5 0xE0E0E0 0xACD09D")	,_T("Info07"));
		sKey.Set(_T("0xD2F2D7 0xF7F7F7 0xADDEFF"		)	,_T("Info08"	));
		sKey.Set(_T("GRAY 0x00FF0000"					)	,_T("Info09"	));
		sKey.Set(_T("GRAY 0x0F8000FF"					)	,_T("Info11"	));
		

		sKey.Set( 1,_T("Interface06"));	
		sKey.Set( 1,_T("Interface10"));	

		sKey.Down();
		sKey.Up(_T("Server"));
		}


//*****************************************************************************



	if(pSelect && *pSelect)									// Einen Server whlen
		{
		for(iPos=0;iPos<100;iPos++)
			{
			sName.Format(_T("Name%02i"),iPos);
			sText.Empty();

			if(!sKey.Get(sText,sName))break;

			if(sText==pSelect)
				{
				sKey.Set(iPos,_T("Select"));
				break;
				}
			}
		}
	
	iRow = 0;
	sKey.Get(iRow,_T("Select"));
	m_sServerNames.Del();
	m_sServerNames.DataLength(sizeof(int));
	
	for(iPos=0;iPos<100;iPos++)								// Server-Namen holen 
		{
		sName.Format(_T("Name%02i"),iPos);
		sText.Empty();

		if(!sKey.Get(sText,sName))break;

		m_sServerNames.Add(sText);
		}
		
	sKey.Down();
	sKey.Up(_T("Layer"));
	m_sLayerNames.Del();
	m_sLayerNames.DataLength(sizeof(int));
	
	for(iPos=0;iPos<100;iPos++)								// Layer-Namen holen
		{
		sName.Format(_T("Name%02i"),iPos);
		sText.Empty();

		if(!sKey.Get(sText,sName))break;

		iSel = 0;
		sName.Format(_T("Select%02i"),iPos);
		sPath.Empty();
		sKey .Get(iSel,sName);

		m_sLayerNames.Add(sText,CSC_END,&iSel);
		}


	if(iRow<0 || iRow>=m_sServerNames.Count())
		{
		iRow = 0;
		}

	m_sServerNames.DataSet(iRow,1);							// Haupt-Server einstellen

	sKey .Down();
	sKey .Up(_T("Server"));

	sName.Format(_T("Server%02i"),iRow);	
	sText.Empty();	
	sKey .Get(sText,sName);	

	sName.Format(_T("Path%02i"),iRow);	
	sPath.Empty();	
	sKey .Get(sPath,sName);	

	sName.Format(_T("Fixed%02i"),iRow);	
	bFixed = 0;	
	sKey .Get(bFixed,sName);	

	sName.Format(_T("Interface%02i"),iRow);	
	uInter = 0;	
	sKey .Get(uInter,sName);	

	iOff = strchar(sText,':');								// Server-Port holen
	
	if(iOff<sText.GetLength())
		{
		iPort = atoi(((LPCTSTR)sText)+iOff+1);
		sText = sText.Left(iOff);
		}
	else{
		iPort = 80;
		}

	m_cOsmWnd.SetServer(0,sText,sPath,iPort,bFixed,uInter);

	pPath = sPath;
	m_bFixedCache = bFixed;


	sName.Format(_T("ZoomMin%02i"),iRow);					// Zoom-Bereich einstellen
	sText.Empty();	
	sKey .Get(sText,sName);	

	sName.Format(_T("ZoomMax%02i"),iRow);	
	sPath.Empty();	
	sKey .Get(sPath,sName);	

	m_cOsmWnd.SetRangeZoom(atoi(sText),atoi(sPath));
	
	sName.Format(_T("AreaXA%02i"),iRow);					// Scroll-Bereich einstellen
	sText.Empty();	
	sKey .Get(sText,sName);	
	dVal1X=TextToCoord(sText);

	sName.Format(_T("AreaYA%02i"),iRow);	
	sPath.Empty();	
	sKey .Get(sPath,sName);	
	dVal1Y=TextToCoord(sPath);

	sName.Format(_T("AreaXB%02i"),iRow);	
	sText.Empty();	
	sKey .Get(sText,sName);	
	dVal2X=TextToCoord(sText);

	sName.Format(_T("AreaYB%02i"),iRow);	
	sPath.Empty();	
	sKey .Get(sPath,sName);	
	dVal2Y=TextToCoord(sPath);

	m_cOsmWnd.CoordToPos(dVal1X,dVal1Y,iVal1X,iVal1Y);
	m_cOsmWnd.CoordToPos(dVal2X,dVal2Y,iVal2X,iVal2Y);

	sText.TrimLeft();
	sPath.TrimLeft();

	if(dVal1X==0.0 && dVal2X==0.0 && sText.GetLength()==0)
			m_cOsmWnd.SetRangeX(0     ,0     );
	else	m_cOsmWnd.SetRangeX(iVal1X,iVal2X);

	if(dVal1Y==0.0 && dVal2Y==0.0 && sPath.GetLength()==0)
			m_cOsmWnd.SetRangeY(0 ,0x7FFFFFFF);
	else	m_cOsmWnd.SetRangeY(iVal1Y,iVal2Y);



	sKey.Down();
	sKey.Up(_T("Layer"));

	for(iPos=0,iNum=1;iPos<m_sLayerNames.Count();iPos++)	// Server fr Layer hinzufgen	
		{
		if(!m_sLayerNames.DataGet(iPos))continue;

		sName.Format(_T("Server%02i"),iPos);	
		sText.Empty();	
		sKey .Get(sText,sName);	

		sName.Format(_T("Path%02i"),iPos);	
		sPath.Empty();	
		sKey .Get(sPath,sName);	

		sName.Format(_T("Info%02i"),iPos);	
		sInfo.Empty();	
		sKey .Get(sInfo,sName);	

		sName.Format(_T("Fixed%02i"),iPos);	
		bFixed = 0;	
		sKey .Get(bFixed,sName);	

		sName.Format(_T("Interface%02i"),iPos);	
		uInter = 0;	
		sKey .Get(uInter,sName);	

		iOff = strchar(sText,':');
		
		if(iOff<sText.GetLength())
			{
			iPort = atoi(((LPCTSTR)sText)+iOff+1);
			sText = sText.Left(iOff);
			}
		else{
			iPort = 80;
			}

		m_cOsmWnd.SetServer(iNum,sText,sPath,iPort,bFixed,uInter,sInfo);

		pPath = sPath;
		
		if(!bFixed)
			{
			m_bFixedCache = FALSE;
			}
				
		sName.Format(_T("AlphaOff%02i"),iPos);				// Alpha-Werte fr Layer einstellen
		sText.Empty();	
		sKey .Get(sText,sName);	

		sName.Format(_T("AlphaMul%02i"),iPos);
		sPath.Empty();	
		sKey .Get(sPath,sName);	

		m_cOsmWnd.SetServerAlpha(iNum,atoi(sText),atoi(sPath));

		iNum++;
		if(iNum>=8)break;
		}


	m_cOsmWnd.SetServer(iNum,NULL);
	m_cOsmWnd.Reinit();										// nderungen ber nehmen

}

//*****************************************************************************
//*
//*		OnServerConfig
//*
//*****************************************************************************
//	Die Server-Liste einstellen
void COsmViewerView::OnServerConfig()
{
COsmServerDlg	sDlg;


	sDlg.m_uCoordMode = m_uCoordMode;

	if(sDlg.DoModal()==IDOK)
		{
		UpdateServers(sDlg.m_sSelected);
		}

}

//*****************************************************************************
//*
//*		FrameTime
//*
//*****************************************************************************
void _cdecl COsmViewerView::FrameTime(CProgressDlg *pDlg)
{
COsmViewerView *pThis=(COsmViewerView*)pDlg->GetVoid1();	
int				iPos;

	
	if(pThis->m_iDlgLast!=pThis->m_iDlgState)
		{
		pThis->m_iDlgLast=pThis->m_iDlgState;

		if(pThis->m_iDlgMul)
			{
			iPos  = pThis->m_iDlgState>>(pThis->m_iDlgStep+1);
			iPos += ((1<<pThis->m_iDlgStep)-1)<<(13-pThis->m_iDlgStep);
			}
		else{
			iPos  = pThis->m_iDlgState;
			}

		pDlg->SetPos(iPos);
		pDlg->SetText(pThis->m_cOsmWnd.GetDownloadPath());
		}

	if(pDlg->IsStoped())pThis->m_iDlgCancel=1;

}

//*****************************************************************************
//*
//*		FrameProc
//*
//*****************************************************************************
int _cdecl COsmViewerView::FrameProc(CProgressDlg *pDlg)
{
COsmViewerView *pThis =(COsmViewerView*)pDlg->GetVoid1();	
COsmFrameDlg   *pFrame=(COsmFrameDlg  *)pDlg->GetVoid2();		
BitmapImage	   *pImage=(BitmapImage   *)pDlg->GetVoid3();		
LPCTSTR			pName =(LPCTSTR        )pDlg->GetVoid4();			
char			cComment[256];
int				iSizeX;
int				iSizeY;
int				iPosX;
int				iPosY;
int				iZoom;
int				iTurn;
int				iRet;
int				iEnd;
int				iVal;

	
	iZoom	= pFrame->m_iZoom;
	
	if(pName)											// Soll ein 
		{
		pImage->SetSize(32,pFrame->m_iSizeX,pFrame->m_iSizeY);
		iEnd = pFrame->m_iZoom;
		}
	else{												// Nur in Chache laden
		pImage->SetSize(32,1,1);			
		iEnd = 0;
		}
	
	pThis->m_iDlgMul = iZoom-iEnd;
		
	
	for(iTurn=0;iZoom>=iEnd;iTurn++)					// Alle Zoom Levels abarbeiten
		{
		iSizeX	= pFrame->m_iSizeX>>iTurn;	if(!iSizeX)iSizeX=1;
		iSizeY	= pFrame->m_iSizeY>>iTurn;	if(!iSizeY)iSizeY=1;
		iPosX	= pFrame->m_iFrameX1;
		iPosY	= pFrame->m_iFrameY1;


		if(iTurn && (1<<(OSM_AREA_BITS+iZoom))>=2048)	// Mindest Breite fr Bild
			{
			if(iSizeX<2048)
				{
				iVal	= (2048-iSizeX)/2;
				iPosX  -= iVal<<(OSM_ZOOM_BASE-OSM_AREA_BITS-iZoom);
				iSizeX  =  2048;
				}

			if(iSizeY<2048)
				{
				iVal	= (2048-iSizeY)/2;
				iPosY  -= iVal<<(OSM_ZOOM_BASE-OSM_AREA_BITS-iZoom);
				iSizeY  =  2048;
				}
			}

		   iRet	= pThis->m_cOsmWnd.GetMapFrame(iPosX,iPosY,iZoom,*pImage,&pThis->m_iDlgState,&pThis->m_iDlgCancel,iSizeX,iSizeY);
		if(iRet)return iRet;
		
		if(iZoom!=iEnd)
			{
			pThis->m_iDlgState=0;
			pThis->m_iDlgStep++;
			}

		iZoom--;
		}
	
	
	if(iEnd==pFrame->m_iZoom && pName)					// Auch speichern
		{
		EncodeMercatorRef(cComment,pFrame->m_dFrameX1,pFrame->m_dFrameY1,pFrame->m_iZoom);
		iRet=ImageSaver(pName,pImage,cComment);
		}
	else{
		iRet = 0;
		}


return iRet;
}

//*****************************************************************************
//*
//*		OnSaveMapFrame
//*
//*****************************************************************************
void COsmViewerView::OnSaveMapFrame()
{
CProgressDlg	sImgDlg;
CString			sName;
COsmFrameDlg	sDlg;
BitmapImage		sImg;
int				iRet;


	m_cOsmWnd.GetViewRect(sDlg.m_iFrameX1,sDlg.m_iFrameY1,sDlg.m_iFrameX2,sDlg.m_iFrameY2);
	sDlg.m_pOsmMain	  = &m_cOsmWnd;
	sDlg.m_uCoordMode = m_uCoordMode;
	sDlg.m_iZoom	  =	m_cOsmWnd.GetZoom();

	if(sDlg.DoModal()!=IDOK)
		{
		return;
		}

	if(sDlg.m_iSizeX>18000 || sDlg.m_iSizeY>18000)
		{
		MessageBox("Der Kartenauschnitt ist grer als 18000 Pixel !","Fehler",MB_OK|MB_ICONERROR);
		return;
		}

	if(sDlg.m_iSizeX<64 || sDlg.m_iSizeY<64)
		{
		MessageBox("Der Kartenauschnitt ist kleiner als 64 Pixel !","Fehler",MB_OK|MB_ICONERROR);
		return;
		}



	CFileDialog	sFile(FALSE,_T("*.png"),sName,OFN_EXPLORER|OFN_ENABLESIZING|OFN_PATHMUSTEXIST|OFN_HIDEREADONLY,_T("Bilddatei (*.png)|*.png|Alle Dateien|*.*|"));


	   sFile.m_ofn.lpstrTitle=_T("Kartenauschnitt speichern");
	if(sFile.DoModal()!=IDOK)return;

	sName =	sFile.GetPathName();

	m_iDlgCancel	= 0;
	m_iDlgState		= 0;
	m_iDlgStep		= 0;
	m_iDlgLast		=-1;
	m_iDlgMul		= 1;

	sImgDlg.SetRange(8192);
	sImgDlg.SetTitle("Kartenauschnitt speichern");
	sImgDlg.SetProc(FrameProc,this,&sDlg,&sImg,(LPCTSTR)sName);
	sImgDlg.SetTime(FrameTime);
	sImgDlg.DoModal();

	iRet = sImgDlg.GetExitCode();

	if(iRet<0)
		{
		MessageBox("Es gab einen Fehler beim Speichern !","Fehler",MB_OK|MB_ICONERROR);
		return;
		}

}

//*****************************************************************************
//*
//*		OnSaveMapFixed
//*
//*****************************************************************************
void COsmViewerView::OnSaveMapFixed()
{
CProgressDlg	sImgDlg;
COsmFrameDlg	sDlg;
BitmapImage		sImg;
int				iRet;


	if(!m_bFixedCache)
		{
		if(MessageBox(_T("Nicht alle Server und Layer liegen im fixierten Cache !"),_T("Warnung"),MB_OKCANCEL|MB_ICONERROR)==IDCANCEL)
			{
			return;
			}
		}

	m_cOsmWnd.GetViewRect(sDlg.m_iFrameX1,sDlg.m_iFrameY1,sDlg.m_iFrameX2,sDlg.m_iFrameY2);
	sDlg.m_pOsmMain	  = &m_cOsmWnd;
	sDlg.m_uCoordMode = m_uCoordMode;
	sDlg.m_iZoom	  =	m_cOsmWnd.GetZoom();

	if(sDlg.DoModal()!=IDOK)
		{
		return;
		}

	m_iDlgCancel	= 0;
	m_iDlgState		= 0;
	m_iDlgStep		= 0;
	m_iDlgLast		=-1;
	m_iDlgMul		= 1;

	sImgDlg.SetRange(8192);
	sImgDlg.SetTitle("Kartenauschnitt cachen");
	sImgDlg.SetProc(FrameProc,this,&sDlg,&sImg,NULL);
	sImgDlg.SetTime(FrameTime);
	sImgDlg.DoModal();

	iRet = sImgDlg.GetExitCode();

	if(iRet<0)
		{
		MessageBox("Es gab einen Fehler beim Speichern !","Fehler",MB_OK|MB_ICONERROR);
		return;
		}

}

//*****************************************************************************
//*
//*		DrawCallback
//*
//*****************************************************************************
void _cdecl COsmViewerView::DrawCallback(void *pParam,CDC *pDc,PAINTSTRUCT *pPaint)
{
COsmViewerView *pThis=(COsmViewerView*)pParam;

}

//*****************************************************************************
//*
//*		MouseCallback
//*
//*****************************************************************************
int _cdecl COsmViewerView::MouseCallback(void *pParam,UINT uType,UINT nFlags,CPoint sPoint)
{
COsmViewerView *pThis=(COsmViewerView*)pParam;	

	
	if(uType==WM_LBUTTONDOWN && pThis->m_bSetWayPoint )			// Einen neuen Wegpunkt setzen
		{
		TCHAR		cText[64];
		CString		sParam;
		double		dPosX;
		double		dPosY;
		CTextDlg	sDlg;
		CRegKeys	sKey;

		pThis->m_bSetWayPoint = FALSE;

		sDlg.SetTitle("Wegpunkt setzen");
		sDlg.SetTextTitle("Namen fr Wegpunkt eingeben :");

		if(sDlg.DoModal()!=IDOK)return 1;

		if(pThis->m_iWayPoints<100)
			{
			pThis->m_cOsmWnd.PixelToCoord(sPoint.x,sPoint.y,dPosX,dPosY);

			sKey.Open();
			sKey.Up("WayPoints");

			sParam.Format(_T("Name%02i"),pThis->m_iWayPoints);
			sKey.Set(sDlg.GetText(),sParam);
			sParam.Format(_T("Mode%02i"),pThis->m_iWayPoints);
			sKey  .Set(3,sParam);
			CoordToText(dPosX,0,cText);		
			sParam.Format(_T("CoordX%02i"),pThis->m_iWayPoints);
			sKey  .Set(cText,sParam);
			CoordToText(dPosY,1,cText);		
			sParam.Format(_T("CoordY%02i"),pThis->m_iWayPoints);
			sKey  .Set(cText,sParam);
			
			pThis->m_cOsmWnd.AddWayPoint(sDlg.GetText(),dPosX,dPosY);
			}

		return 1;
		}


return 0;
}

//*****************************************************************************
//*
//*		UpdatePathOptions
//*
//*****************************************************************************
void COsmViewerView::UpdatePathOptions()
{
unsigned		uWidth;
COLORREF		uColor;
CString			sParam;
CRegKeys		sKey;
int				iPos;



	sKey.Open();
	sKey.Up("PathOptions");


	for(iPos=0;iPos<8;iPos++)									// Punkte einlesen
		{
		m_cOsmWnd.GetPathPen(iPos,uColor,uWidth);
	
		sParam.Format(_T("Color%02i"),iPos);
		sKey  .Get(uColor,sParam);
		sParam.Format(_T("Width%02i"),iPos);
		sKey  .Get(uWidth,sParam);

		m_cOsmWnd.SetPathPen(iPos,uColor,uWidth);
		}

}


//*****************************************************************************
//*
//*		UpdateWayPoints
//*
//*****************************************************************************
void COsmViewerView::UpdateWayPoints()
{
TCHAR			cName[64];
CString			sParam;
CString			sText;
CRegKeys		sKey;
double			dPosX;
double			dPosY;
int				iMode;
int				iPos;



	sKey.Open();
	sKey.Up("WayPoints");

	m_cOsmWnd.DelWayPoints();


	for(iPos=0;iPos<100;iPos++)									// Punkte einlesen
		{
		sParam.Format(_T("Name%02i"),iPos);

		if(!sKey.Get(cName,64,sParam))break;

		iMode = 0;
		sParam.Format(_T("Mode%02i"),iPos);
		sKey  .Get(iMode,sParam);

		if(!(iMode&1))continue;
		
		sParam.Format(_T("CoordX%02i"),iPos);
		sText .Empty();
		sKey  .Get(sText,sParam);
		dPosX =TextToCoord(sText);		

		sParam.Format(_T("CoordY%02i"),iPos);
		sText .Empty();
		sKey  .Get(sText,sParam);
		dPosY =TextToCoord(sText);		

		m_cOsmWnd.AddWayPoint(cName,dPosX,dPosY,iMode);
		}

	m_iWayPoints = iPos;

}

//*****************************************************************************
//*
//*		OnWayPoints
//*
//*****************************************************************************
//	Die Wegpunkte bearbeiten
void COsmViewerView::OnWayPoints() 
{
COsmWayPointDlg	sDlg;
int				iRet;
	
	
	sDlg.m_uCoordMode = m_uCoordMode;

	iRet = sDlg.DoModal();

	if(iRet==IDOK || (iRet==IDRETRY && sDlg.m_bChanged))
		{
		UpdateWayPoints();
		m_cOsmWnd.RedrawWindow();
		}

	if(iRet==IDRETRY)
		{
		m_cOsmWnd.SetScrollCoord(sDlg.m_dGotoX,sDlg.m_dGotoY);
		}

}

//*****************************************************************************
//*
//*		OnPathOptions
//*
//*****************************************************************************
void COsmViewerView::OnPathOptions() 
{
COsmPathDlg		dDlg;
unsigned		uPos;
unsigned		uRet;

	
	
	if(m_aPathNames[0].IsEmpty())
		{
		m_aPathNames[0]=_T("<Loker Pfad>");
		}

	dDlg.m_pOsmMain = &m_cOsmWnd;

	for(uPos=0;uPos<8;uPos++)
		{
		m_cOsmWnd.GetPathPen(uPos,dDlg.m_aColors[uPos],dDlg.m_aWidth[uPos]);
		
		if(m_cOsmWnd.GetPathPoints(uPos))
			{
			dDlg.m_aNames[uPos]  = _T("  ");
			dDlg.m_aNames[uPos] += GetFileName(m_aPathFiles[uPos]);
			if(!m_aPathFiles[uPos].IsEmpty())dDlg.m_aNames[uPos]+=_T(" / ");
			dDlg.m_aNames[uPos] += m_aPathNames[uPos];
			}
		}


	uRet = dDlg.DoModal();

	if(uRet!=IDOK)
		{
		return;
		}

	UpdatePathOptions();
	((CMainFrame*)AfxGetMainWnd())->UpdatePathBar();

}

//*****************************************************************************
//*
//*		OnPathFind
//*
//*****************************************************************************
void COsmViewerView::OnPathFind()
{
COsmViewerDoc  *pDoc;	
COsmFindDlg		sDlg;
int				iPos;


	if(sDlg.DoModal()!=IDOK)
		{
		return;
		}


		pDoc = GetDocument();
	if(!pDoc)return;

	for(iPos=0;iPos<sDlg.m_sFileList.Count();iPos++)
		{
		if(pDoc->OnOpenDocument(sDlg.m_sFileList[iPos]))continue;
		MessageBox(_T("Es konneten nicht alle Tracks geladen werden !"),_T("Fehler"),MB_OK|MB_ICONERROR);
		break;
		}



}

//*****************************************************************************
//*
//*		OnZoom
//*
//*****************************************************************************
void COsmViewerView::OnZoom()
{
CWnd	   *pMainWnd;
int			iScreenX;
int			iScreenY;
UINT		uStyle;
RECT		sBase;
RECT		sRect;


	pMainWnd = AfxGetMainWnd();



	if(m_iZoom)											// Zoom rckgngig machen
		{
		uStyle = ::GetStyle(pMainWnd);
		SetStyle(pMainWnd,uStyle|WS_THICKFRAME|WS_MAXIMIZEBOX|WS_MINIMIZEBOX|WS_CAPTION);
		pMainWnd->MoveWindow(m_sOldRect.left,m_sOldRect.top,m_sOldRect.right-m_sOldRect.left,m_sOldRect.bottom-m_sOldRect.top);
		if(m_iZoom==2)pMainWnd->ShowWindow(SW_SHOWMAXIMIZED);
		m_iZoom = 0;
		RedrawWindow();
		return;
		}



	if(pMainWnd->IsZoomed())
		{
		pMainWnd->ShowWindow(SW_SHOWNORMAL);
		m_iZoom = 2;
		}
	else{
		m_iZoom = 1;
		}


	pMainWnd->GetWindowRect(&m_sOldRect);
	GetWindowRect(&sRect);

	uStyle   = ::GetStyle(pMainWnd);
	SetStyle(pMainWnd,uStyle&~(WS_THICKFRAME|WS_MAXIMIZEBOX|WS_MINIMIZEBOX|WS_CAPTION));
	iScreenX = GetSystemMetrics(SM_CXSCREEN);
	iScreenY = GetSystemMetrics(SM_CYSCREEN);

	
	pMainWnd->GetClientRect (&sBase);
	pMainWnd->ClientToScreen(&sBase);
	

	pMainWnd->MoveWindow(m_sOldRect.left-sBase.left,
						 m_sOldRect.top -sBase.top,
						 iScreenX+(m_sOldRect.right -sBase.right )-(m_sOldRect.left-sBase.left),
						 iScreenY+(m_sOldRect.bottom-sBase.bottom)-(m_sOldRect.top -sBase.top ));

	RedrawWindow();
}


//*****************************************************************************
//*
//*		OnDropFiles
//*
//*****************************************************************************
void COsmViewerView::OnDropFiles(HDROP hDrop)
{
COsmViewerDoc  *pDoc = GetDocument();
TCHAR			cFile[MAX_PATH];
int				iCount;
int				iNum;



	iCount = DragQueryFile(hDrop,-1,0,0);


	for(iNum=0;iNum<iCount;iNum++)						// Dateien durchlaufen
		{
		DragQueryFile(hDrop,iNum,cFile,sizeof(cFile)/sizeof(TCHAR));
		pDoc->OnOpenDocument(cFile);
		}


	DragFinish(hDrop);

}

//*****************************************************************************
//*
//*		OnTracksStat
//*
//*****************************************************************************
void COsmViewerView::OnTracksStat()
{
COsmViewerDoc  *pDoc;	
COsmStatDlg		sDlg;
int				iPos;


	if(sDlg.DoModal()!=IDOK)
		{
		return;
		}


		pDoc = GetDocument();
	if(!pDoc)return;

	for(iPos=0;iPos<sDlg.m_sFileList.Count();iPos++)
		{
		if(pDoc->OnOpenDocument(sDlg.m_sFileList[iPos]))continue;
		MessageBox(_T("Es konneten nicht alle Tracks geladen werden !"),_T("Fehler"),MB_OK|MB_ICONERROR);
		break;
		}



}

//*****************************************************************************
//*
//*		OnTest
//*
//*****************************************************************************
void COsmViewerView::OnTest() 
{


}

//*****************************************************************************
//*
//*		OnInfo
//*
//*****************************************************************************
void COsmViewerView::OnInfo() 
{


}


