//*****************************************************************************
//*
//*
//*		OsmViewerView.h
//*
//*
//*****************************************************************************
#ifndef		AFX_OSMVIEWERVIEW_H__77743167_0938_40FE_A1F4_64E3F5A18C4B__INCLUDED_
#define		AFX_OSMVIEWERVIEW_H__77743167_0938_40FE_A1F4_64E3F5A18C4B__INCLUDED_	

#if _MSC_VER > 1000
#pragma		once						
#endif

#include	"OsmCtrl.h"
#include	"OsmCoordDlg.h"



//*****************************************************************************
//*
//*		Klasse COsmViewerView
//*
//*****************************************************************************
class COsmViewerView : public CView
{
protected:

	COsmViewerView();
	DECLARE_DYNCREATE(COsmViewerView)

public:

	COsmViewerDoc* GetDocument();

	int 	GetPathPoints (unsigned uPath);
	BOOL	HasPathChanged(unsigned uPath);
	BOOL 	SetPathChanged(unsigned uPath,BOOL bChanged);
	BOOL	AddPathPointEx(unsigned uPath,double  dPosX,double  dPosY,int iIndex=0x7FFFFFFF,BOOL bRedraw=TRUE);
	BOOL	GetPathPointEx(unsigned uPath,double &dPosX,double &sPosY,int iIndex);
	BOOL    GetPathPen    (unsigned uPath,COLORREF &uColor,unsigned &uWidth);
	BOOL	DelPath       (unsigned uPath,BOOL bRedraw=TRUE);
	BOOL	SetScrollPath (unsigned uPath,BOOL bRedraw=TRUE);
	void	SetPathName   (unsigned uPath,LPCTSTR pName);
	LPCTSTR	GetPathName   (unsigned uPath);
	void	SetPathFile   (unsigned uPath,LPCTSTR pName);
	LPCTSTR	GetPathFile   (unsigned uPath);
	double  GetPathLength (unsigned uPath);

	//{{AFX_VIRTUAL(COsmViewerView)
public:
	virtual void OnDraw(CDC* pDC);								// berladen zum Zeichnen dieser Ansicht
	virtual BOOL PreCreateWindow(CREATESTRUCT &sCreate);
protected:
	virtual BOOL OnPreparePrinting(CPrintInfo *pInfo);
	virtual void OnBeginPrinting(CDC* pDC,CPrintInfo *pInfo);
	virtual void OnEndPrinting(CDC* pDC,CPrintInfo *pInfo);
	virtual void OnPrint(CDC *pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

public:
	virtual ~COsmViewerView();
	#ifdef		_DEBUG					
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext &sDc) const;
	#endif

protected:

	BitmapImage		m_sPrintImg;
	CRect			m_sOldRect;
	COsmCoordDlg	m_sCoordDlg;
	COsmCtrl		m_cOsmWnd;
	CString			m_aPathNames  [8];
	CString			m_aPathFiles  [8];
	double			m_aPathLength [8];
	TCHAR			m_aStatusText [256];
	CHAR			m_aCoordBuffer[256];
	LONG			m_lCoordIndex;
	UINT			m_uWheeleMode;
	UINT			m_uCoordMode;
	BOOL			m_bFixedCache;
	BOOL			m_bShowCoord;
	BOOL			m_bOsmMenu;
	int				m_iOsmPosX;
	int				m_iOsmPosY;
	int				m_iOsmZoom;
	CStringChain	m_sLayerNames;
	CStringChain	m_sServerNames;
	int				m_iDlgCancel;
	int				m_iDlgState;
	int				m_iDlgStep;
	int				m_iDlgMul;
	int				m_iDlgLast;
	int				m_iWayPoints;
	BOOL			m_bSetWayPoint;
	int				m_iZoom;
	int	volatile	m_iSrtmFlag;
	double			m_iStrmCoordX;
	double			m_iStrmCoordY;


protected:
	//{{AFX_MSG(COsmViewerView)
	afx_msg int  OnCreate(LPCREATESTRUCT pCreateStruct);
	afx_msg void OnTimer(UINT_PTR nIDEvent);
	afx_msg void OnSize(UINT nType,int iSizeX,int iSizeY);
	afx_msg void OnSetFocus(CWnd *pOldWnd);
	afx_msg void OnDropFiles(HDROP hDrop);
	afx_msg void OnHeightInfoUI(CCmdUI *pCmdUI);
	afx_msg void OnWheelScrollUI(CCmdUI *pCmdUI);
	afx_msg void OnWheelZoomUI(CCmdUI *pCmdUI);
	afx_msg void OnDoMeasureUI(CCmdUI *pCmdUI);
	afx_msg void OnShowCoordUI(CCmdUI *pCmdUI);
	afx_msg void OnOpenFileUI(CCmdUI *pCmdUI);
	afx_msg void OnSaveFileUI(CCmdUI *pCmdUI);
	afx_msg void OnCoordDecUI(CCmdUI *pCmdUI);
	afx_msg void OnCoordDegUI(CCmdUI *pCmdUI);
	afx_msg void OnCoordDirUI(CCmdUI *pCmdUI);
	afx_msg void OnShowPathUI(CCmdUI *pCmdUI);
	afx_msg void OnDualModeUI(CCmdUI *pCmdUI);
	afx_msg void OnOsmMenuUI(CCmdUI *pCmdUI);
	afx_msg void OnDoPointUI(CCmdUI *pCmdUI);
	afx_msg void OnDoMoveUI(CCmdUI *pCmdUI);
	afx_msg void OnDoCopyUI(CCmdUI *pCmdUI);
	afx_msg void OnDoDrawUI(CCmdUI *pCmdUI);
	afx_msg void OnSaveMapFrame();
	afx_msg void OnSaveMapFixed();
	afx_msg void OnPathOptions();
	afx_msg void OnWheelScroll();
	afx_msg void OnTracksStat();
	afx_msg void OnHeightInfo();
	afx_msg void OnClearCache();
	afx_msg void OnWheelZoom();
	afx_msg void OnShowCoord();
	afx_msg void OnDoMeasure();
	afx_msg void OnWayPoints();
	afx_msg void OnPathFind();
	afx_msg void OnCoordDec();
	afx_msg void OnCoordDeg();
	afx_msg void OnCoordDir();
	afx_msg void OnDualMode();
	afx_msg void OnOsmMenu();
	afx_msg void OnDoPoint();
	afx_msg void OnDoMove();
	afx_msg void OnDoCopy();
	afx_msg void OnDoDraw();
	afx_msg void OnCopy();
	afx_msg void OnZoom();
	//}}AFX_MSG

	afx_msg void OnCoordChange();
	afx_msg void OnServerConfig();
	afx_msg void OnShowPath    (UINT nId);
	afx_msg void OnServerChange(UINT nId);
	afx_msg void OnLayerChange (UINT nId);
	afx_msg void OnBeginnPath (NMHDR *pNmHdr,LRESULT *pResult);
	afx_msg void OnPathChanged(NMHDR *pNmHdr,LRESULT *pResult);
	afx_msg void OnMapRectDone(NMHDR *pNmHdr,LRESULT *pResult);
	afx_msg void OnMapLineDone(NMHDR *pNmHdr,LRESULT *pResult);
	afx_msg void OnMapChange  (NMHDR *pNmHdr,LRESULT *pResult);
	afx_msg void OnCopyCoord();
	afx_msg void OnReload();

	void		 UpdateServers(LPCTSTR pSelect=0);
	void		 UpdateWayPoints();
	void		 UpdatePathOptions();
	
	const char  *CoordText(double dCoord,int iSel);
	static	void _cdecl 	FrameTime(CProgressDlg *pDlg);
	static	int  _cdecl 	FrameProc(CProgressDlg *pDlg);
	static	int  _cdecl 	ClearCache(CProgressDlg *pDlg);
	static	void _cdecl		DrawCallback(void *pParam,CDC *pDc,PAINTSTRUCT *pPaint);
	static	int  _cdecl		MouseCallback(void *pParam,UINT uType,UINT nFlags,CPoint sPoint);
	static	DWORD WINAPI 	SrtmThread(LPVOID pParam);	

	
	afx_msg void OnTest();
	afx_msg void OnInfo();

	DECLARE_MESSAGE_MAP()


};


//*****************************************************************************
//*
//*		GetDocument
//*
//*****************************************************************************
#ifndef		_DEBUG	
inline COsmViewerDoc *COsmViewerView::GetDocument()
{

return (COsmViewerDoc*)m_pDocument; 
}
#endif

//*****************************************************************************
//*
//*		Inline Funktionen
//*
//*****************************************************************************
inline BOOL	   COsmViewerView::SetScrollPath (unsigned uPath,BOOL bRedraw){return m_cOsmWnd.SetScrollPath(uPath,bRedraw);}
inline BOOL	   COsmViewerView::DelPath       (unsigned uPath,BOOL bRedraw){return m_cOsmWnd.DelPath(uPath,bRedraw);}
inline BOOL	   COsmViewerView::AddPathPointEx(unsigned uPath,double  dPosX,double  dPosY,int iIndex,BOOL bRedraw){return m_cOsmWnd.AddPathPointEx(uPath,dPosX,dPosY,iIndex,bRedraw);}
inline BOOL	   COsmViewerView::GetPathPointEx(unsigned uPath,double &dPosX,double &dPosY,int iIndex             ){return m_cOsmWnd.GetPathPointEx(uPath,dPosX,dPosY,iIndex)>=0     ;}
inline BOOL    COsmViewerView::GetPathPen    (unsigned uPath,COLORREF &uColor,unsigned &uWidth){return m_cOsmWnd.GetPathPen(uPath,uColor,uWidth);}
inline BOOL    COsmViewerView::HasPathChanged(unsigned uPath){return m_cOsmWnd.HasPathChanged(uPath);}
inline BOOL    COsmViewerView::SetPathChanged(unsigned uPath,BOOL bChanged){return m_cOsmWnd.SetPathChanged(uPath,bChanged);}
inline int 	   COsmViewerView::GetPathPoints (unsigned uPath){return m_cOsmWnd.GetPathPoints(uPath);}
inline double  COsmViewerView::GetPathLength (unsigned uPath){if(uPath>=8)return 0.0;    return m_aPathLength[uPath]=m_cOsmWnd.GetPathLength(uPath);}
inline void    COsmViewerView::SetPathName   (unsigned uPath,LPCTSTR pName){if(uPath>=8)return; m_aPathNames [uPath]=pName;}
inline LPCTSTR COsmViewerView::GetPathName   (unsigned uPath){if(uPath>=8)return _T(""); return m_aPathNames [uPath];}
inline void    COsmViewerView::SetPathFile   (unsigned uPath,LPCTSTR pName){if(uPath>=8)return; m_aPathFiles [uPath]=pName;}
inline LPCTSTR COsmViewerView::GetPathFile   (unsigned uPath){if(uPath>=8)return _T(""); return m_aPathFiles [uPath];}
//{{AFX_INSERT_LOCATION}}

#endif
