//*****************************************************************************
//*
//*
//*		WayPointDlg.cpp
//*
//*
//*****************************************************************************
#include	"StdAfx.h"
#include	"OsmViewer.h"
#include	"WayPointDlg.h"
#include	"CoordFunctions.h"


#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif

#define 	 ID_LIST		0x3411
#define 	 ID_SHOW_ALL	0x3412
#define 	 ID_SHOW_NONE	0x3413
#define 	 ID_TEXT_ALL	0x3414
#define 	 ID_TEXT_NONE	0x3415


BEGIN_MESSAGE_MAP(CWayPointDlg, CDialog)
	//{{AFX_MSG_MAP(CWayPointDlg)
	ON_WM_CONTEXTMENU()
	ON_BN_CLICKED(IDC_IMPORT, OnImport)
	ON_BN_CLICKED(IDC_EXPORT, OnExport)
	ON_BN_CLICKED(IDC_DELETE, OnDelete)
	//}}AFX_MSG_MAP
	ON_COMMAND(ID_SHOW_ALL	, OnShowAll)
	ON_COMMAND(ID_SHOW_NONE	, OnShowNone)
	ON_COMMAND(ID_TEXT_ALL	, OnTextAll)
	ON_COMMAND(ID_TEXT_NONE	, OnTextNone)
	ON_NOTIFY(TVN_SELCHANGED    ,ID_LIST,OnSelChanged)
	ON_NOTIFY(TVN_ENDLABELEDIT  ,ID_LIST,OnEndLabelEdit)
	ON_NOTIFY(TVN_CBSTATECHANGED,ID_LIST,OnChangeNotify)
END_MESSAGE_MAP()

//*****************************************************************************
//*
//*		CDialog
//*
//*****************************************************************************
//  Dialogfeld CWayPointDlg
CWayPointDlg::CWayPointDlg(CWnd *pParent/*=NULL*/): CDialog(CWayPointDlg::IDD,pParent)
{
	//{{AFX_DATA_INIT(CWayPointDlg)
	//}}AFX_DATA_INIT

	m_uCoordMode	= 0;
}


//*****************************************************************************
//*
//*		DoDataExchange
//*
//*****************************************************************************
void CWayPointDlg::DoDataExchange(CDataExchange *pDX)
{

	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWayPointDlg)
	//}}AFX_DATA_MAP

}


//*****************************************************************************
//*
//*		OnInitDialog
//*
//*****************************************************************************
//  Behandlungsroutinen fr Nachrichten CWayPointDlg
BOOL CWayPointDlg::OnInitDialog()
{
CString		sParam;
CString		sText;
CString		sPosX;
CString		sPosY;
HTREEITEM	hItem;
CRegKeys	sKey;
int			iPos;
int			iBit;



	m_bChanged	= FALSE;

	CDialog::OnInitDialog();


	m_cList.CreateEx(WS_EX_CLIENTEDGE,WS_CHILD|WS_VISIBLE|WS_TABSTOP|TVS_FULLROWSELECT|TVS_EDITLABELS|TVS_CHECKBOXES,IDC_FRAME,this,ID_LIST);
	
	m_cList.SetExtendedStyle(TVS_EX_HOMEENDSELECT|TVS_EX_EDITCLICK|TVS_EX_ITEMLINES|TVS_EX_ALTERNATECOLOR|TVS_EX_SUBSELECT|TVS_EX_AUTOHSCROLL,TVS_EX_HOMEENDSELECT|TVS_EX_ITEMLINES|TVS_EX_ALTERNATECOLOR|TVS_EX_EDITCLICK|TVS_EX_SUBSELECT|TVS_EX_AUTOHSCROLL);

	m_cList.InsertColumn(0,_T("Name"  ),TVCFMT_LEFT ,-99);
	m_cList.InsertColumn(1,_T("Breite"),TVCFMT_RIGHT,-50);
	m_cList.InsertColumn(2,_T("Lnge" ),TVCFMT_RIGHT,-50);
	m_cList.InsertColumn(3,_T("Text"  ),TVCFMT_LEFT , 40);
	
	m_cList.SetColumnAutoEdit(0,TVAE_EDIT|TVAE_DBLCLICK|TVAE_FULLWIDTH);
	m_cList.SetColumnAutoEdit(1,TVAE_EDIT|TVAE_DBLCLICK|TVAE_FULLWIDTH);
	m_cList.SetColumnAutoEdit(2,TVAE_EDIT|TVAE_DBLCLICK|TVAE_FULLWIDTH);
	m_cList.SetColumnAutoEdit(3,TVAE_CHECK|TVAE_ICONCLICK|TVAE_DBLCLICK);


	sKey.Open();
	sKey.Up("WayPoints");


	for(iPos=0;iPos<100;iPos++)									// Punkte einlesen
		{
		sText .Empty();
		sParam.Format(_T("Name%02i"),iPos);
		if(!sKey.Get(sText,sParam))break;

		iBit  = 0;
		sParam.Format(_T("Mode%02i"),iPos);
		sKey  .Get(iBit,sParam);
		
		sParam.Format(_T("CoordX%02i"),iPos);
		sPosX .Empty();
		sKey  .Get(sPosX,sParam);

		sParam.Format(_T("CoordY%02i"),iPos);
		sPosY .Empty();
		sKey  .Get(sPosY,sParam);

		CoordConvert(sPosX,0);
		CoordConvert(sPosY,0);

		hItem = m_cList.InsertItem(sText);	
		
		m_cList.SetItemText(hItem,sPosY,1);
		m_cList.SetItemText(hItem,sPosX,2);
		
		if(iBit&1)m_cList.SetCheck(hItem);
		m_cList.SetItemCheckBox(hItem,(iBit&2)? 2:1,3);
		}

	hItem = m_cList.InsertItem(_T(""));	
	m_cList.SetItemCheckBox(hItem,1,3);
	


return TRUE;
}

//*****************************************************************************
//*
//*		CoordConvert
//*
//*****************************************************************************
void CWayPointDlg::CoordConvert(LPTSTR pText,int iSel,int iMode)
{
double	dCoord;

	
	if(iMode<0)
			iMode =m_uCoordMode+iSel;
	else	iMode+=iSel;	

	dCoord = TextToCoord(pText);

	if(dCoord==0.0)
		{
		pText[0]=0;
		}
	else{
		CoordToText(dCoord,iMode,pText);
		}


}


//*****************************************************************************
//*
//*		CoordConvert
//*
//*****************************************************************************
void CWayPointDlg::CoordConvert(CString &sText,int iSel,int iMode)
{
LPTSTR	pText;


	pText = sText.GetBuffer(256);
	CoordConvert(pText,iSel,iMode);
	sText.ReleaseBuffer();

}

//*****************************************************************************
//*
//*		OnSelChanged
//*
//*****************************************************************************
void CWayPointDlg::OnSelChanged(NMHDR *pNmHdr,LRESULT *pResult)
{
NMTREEVIEW     *pItem=(NMTREEVIEW*)pNmHdr;
HTREEITEM		hItem;

	
	hItem = pItem->itemNew.hItem;
	hItem = m_cList.GetNextSiblingItem(hItem);	

	GetDlgItem(IDC_DELETE)->EnableWindow(hItem!=NULL);


}

//*****************************************************************************
//*
//*		OnChangeNotify
//*
//*****************************************************************************
void CWayPointDlg::OnChangeNotify(NMHDR *pNmHdr,LRESULT *pResult)
{
	m_bChanged = TRUE;
}

//*****************************************************************************
//*
//*		OnEndLabelEdit
//*
//*****************************************************************************
void CWayPointDlg::OnEndLabelEdit(NMHDR *pNmHdr,LRESULT *pResult)
{
NMTVDISPINFO   *pItem=(NMTVDISPINFO*)pNmHdr;
LPCTSTR			pText;
HTREEITEM		hNext;
HTREEITEM		hItem;
int				iSub;
int				iPos;
int				iLen;



	*pResult = 0;


    if(!(pItem->item.mask&TVIF_TEXTCHANGED))
        {
        return;
        }


	m_bChanged	= TRUE;
	hItem		= pItem->item.hItem;
	iSub		= pItem->item.cChildren;


	if(iSub>=1 && iSub<=2)									// Koordinaten anpassen
		{
		if(iSub==1)
			{
			LPTSTR	pTemp;

			pTemp = pItem->item.pszText;

			TextToCoord(pTemp,&iLen);
															// Y und X eingegeben
			if(iLen>0 && pTemp[iLen]==',' && TextToCoord(pTemp+iLen+1)!=0.0)
				{
				iLen += 1;
				iLen += strwlen(pTemp+iLen,0xE0);
				
				CoordConvert(pItem->item.pszText+iLen,iSub&1);
				m_cList.SetItemText(hItem,pItem->item.pszText+iLen,2);
				pItem->item.pszText[iLen] = 0;
				}
			else if(iLen>0 && TextToCoord(pTemp+iLen)!=0.0)
				{
				iLen += strwlen(pTemp+iLen,0xE0);
				
				CoordConvert(pItem->item.pszText+iLen,iSub&1);
				m_cList.SetItemText(hItem,pItem->item.pszText+iLen,2);
				pItem->item.pszText[iLen] = 0;
				}
			}
		
		CoordConvert(pItem->item.pszText,(iSub^1)&1);
		}


	if(pItem->item.pszText[0]==0)							// Den Eintrag lschen
		{
			hNext=m_cList.GetNextItem(hItem);
		if(!hNext)return;		  

		for(iPos=0;iPos<3;iPos++)
			{
			if( iPos==iSub)continue;
			    pText = m_cList.GetItemText(hItem,iPos);
			if(*pText)break; 
			}
		
		if(iPos>=3)
			{
			m_cList.DeleteItem(hItem);
			m_cList.SelectItem(hNext);
			}
		}
	else{													// Neue leer Zeile am Ende
		if(!m_cList.GetNextItem(hItem))
			{
			hItem = m_cList.InsertItem("");
			m_cList.SetItemCheckBox(hItem,1,3);
			}
		}
  

} 

//*****************************************************************************
//*
//*		OnContextMenu
//*
//*****************************************************************************
void CWayPointDlg::OnContextMenu(CWnd *pWnd, CPoint sPoint)
{
CMenu		sMenu;


	if(!pWnd)return;


	if(pWnd->m_hWnd!=m_cList.m_hWnd)					// Im Listenfenster
		{
		return;
		}

	sMenu.CreatePopupMenu();

	sMenu.AppendMenu(MF_STRING,ID_SHOW_ALL	,_T("Alle Punkte anzeigen" ));
	sMenu.AppendMenu(MF_STRING,ID_SHOW_NONE	,_T("Alle Punkte verbergen"));
	sMenu.AppendMenu(MF_STRING,ID_TEXT_ALL	,_T("Alle Texte anzeigen"  ));
	sMenu.AppendMenu(MF_STRING,ID_TEXT_NONE	,_T("Alle Texte verbergen" ));
	sMenu.TrackPopupMenu(0,sPoint.x,sPoint.y,this);
	sMenu.DestroyMenu();


}

//*****************************************************************************
//*
//*		OnShowAll
//*
//*****************************************************************************
void CWayPointDlg::OnShowAll()
{
HTREEITEM	hItem;
HTREEITEM	hNext;


	
	hItem	= m_cList.GetFirstItem();
	

	for(;;)				
		{
			hNext = m_cList.GetNextSiblingItem(hItem);
		if(!hNext)break; 

		if(m_cList.GetItemCheckBox(hItem,0)!=2)
			{
			m_bChanged = TRUE;
			m_cList.SetItemCheckBox(hItem,2,0);
			}

		hItem = hNext;
		}

}

//*****************************************************************************
//*
//*		OnShowNone
//*
//*****************************************************************************
void CWayPointDlg::OnShowNone()
{
HTREEITEM	hItem;
HTREEITEM	hNext;


	
	hItem	= m_cList.GetFirstItem();
	

	for(;;)				
		{
			hNext = m_cList.GetNextSiblingItem(hItem);
		if(!hNext)break; 

		if(m_cList.GetItemCheckBox(hItem,0)!=1)
			{
			m_bChanged = TRUE;
			m_cList.SetItemCheckBox(hItem,1,0);
			}

		hItem = hNext;
		}

}

//*****************************************************************************
//*
//*		OnTextAll
//*
//*****************************************************************************
void CWayPointDlg::OnTextAll()
{
HTREEITEM	hItem;
HTREEITEM	hNext;


	
	hItem	= m_cList.GetFirstItem();
	

	for(;;)				
		{
			hNext = m_cList.GetNextSiblingItem(hItem);
		if(!hNext)break; 

		if(m_cList.GetItemCheckBox(hItem,3)!=2)
			{
			m_bChanged = TRUE;
			m_cList.SetItemCheckBox(hItem,2,3);
			}

		hItem = hNext;
		}

}

//*****************************************************************************
//*
//*		OnTextNone
//*
//*****************************************************************************
void CWayPointDlg::OnTextNone()
{
HTREEITEM	hItem;
HTREEITEM	hNext;


	
	hItem	= m_cList.GetFirstItem();
	

	for(;;)				
		{
			hNext = m_cList.GetNextSiblingItem(hItem);
		if(!hNext)break; 

		if(m_cList.GetItemCheckBox(hItem,3)!=1)
			{
			m_bChanged = TRUE;
			m_cList.SetItemCheckBox(hItem,1,3);
			}

		hItem = hNext;
		}

}

//*****************************************************************************
//*
//*		OnCancel
//*
//*****************************************************************************
void CWayPointDlg::OnCancel()
{

	CDialog::OnCancel();
}

//*****************************************************************************
//*
//*		OnOK
//*
//*****************************************************************************
void CWayPointDlg::OnOK()
{
CString		sParam;
CString		sText;
CString		sPosX;
CString		sPosY;
HTREEITEM	hItem;
HTREEITEM	hNext;
CRegKeys	sKey;
int			iPos;
int			iBit;



	if(!m_bChanged)												// Gab es nderungen
		{
		OnCancel();
		return;
		}


	sKey.Open();
	sKey.Up("WayPoints");

	hItem	= m_cList.GetFirstItem();
	

	for(iPos=0;iPos<100;iPos++)									// Punkte einlesen
		{
			hNext = m_cList.GetNextSiblingItem(hItem);
		if(!hNext)break; 

		sText	= m_cList.GetItemText(hItem,0);
		sPosY	= m_cList.GetItemText(hItem,1);
		sPosX	= m_cList.GetItemText(hItem,2);

		iBit	= 0;
		if(m_cList.GetItemCheckBox(hItem,0)==2)iBit|=1;;
		if(m_cList.GetItemCheckBox(hItem,3)==2)iBit|=2;

		CoordConvert(sPosX,0,0);
		CoordConvert(sPosY,1,0);

		sParam.Format(_T("Name%02i"  ),iPos);
		sKey  .Set(sText,sParam);
		sParam.Format(_T("CoordX%02i"),iPos);
		sKey  .Set(sPosX,sParam);
		sParam.Format(_T("CoordY%02i"),iPos);
		sKey  .Set(sPosY,sParam);
		sParam.Format(_T("Mode%02i"  ),iPos);
		sKey  .Set(iBit,sParam);

		if(iBit&1)m_cList.SetCheck(hItem);
		
		hItem = hNext;
		}


	for(;iPos<m_iCount;iPos++)									// Entfernte Eintge lschen
		{
		sParam.Format(_T("Name%02i"  ),iPos);
		sKey  .Del(sParam);
		sParam.Format(_T("CoordX%02i"),iPos);
		sKey  .Del(sParam);
		sParam.Format(_T("CoordY%02i"),iPos);
		sKey  .Del(sParam);
		sParam.Format(_T("Mode%02i"  ),iPos);
		sKey  .Del(sParam);
		}


	CDialog::OnOK();

}

//*****************************************************************************
//*
//*		OnImport
//*
//*****************************************************************************
void CWayPointDlg::OnImport()
{
char		cText[2048];
char 		cTemp[256];
TCHAR		cName[256];
FILE	   *pFile;
HTREEITEM	hItem;
HTREEITEM	hNext;
CString		sName;
CString		sText;
int			iChar;
int			iLine;
int			iRet;
int			iPos;
int			iLen;
int			iCol;


	CFileDialog	sFile(TRUE,_T("*.csv"),sName,OFN_EXPLORER|OFN_ENABLESIZING|OFN_PATHMUSTEXIST|OFN_HIDEREADONLY,_T("CSV-Dateien (*.csv)|*.csv|Textdateien (*.txt)|*.txt|Alle Dateien|*.*|"));


	   sFile.m_ofn.lpstrTitle=_T("Wegpunkte importieren");
	if(sFile.DoModal()!=IDOK)return;

	sName =	sFile.GetPathName();

		pFile = fopen(sName,"rb");
	if(!pFile)
		{
		sText.Format(_T("Die Datei '%s' konnte nicht geffnet werden ?"),(LPCTSTR)sName);
		MessageBox(sText,"Fehler",MB_YESNO|MB_ICONERROR|MB_DEFBUTTON2);
		return;
		}

	iChar	= (GetFileType(sName,_T("txt")))? '\t':';';
	iRet	= MessageBox(_T("Alte Liste lschen ?"),_T("Frage"),MB_YESNOCANCEL);

	if(iRet==IDCANCEL)
		{
		fclose(pFile);
		return;
		}

	if(iRet==IDYES)
		{
		m_cList.DeleteAllItems();
		m_cList.InsertItem(_T(""));
		}

	cText[sizeof(cText)-1] = 0 ;
	
	hNext	= m_cList.GetLastChild(TVI_ROOT);
	iLine	= 0;

	while(fgets(cText,sizeof(cText)-1,pFile))
		{
		iLen = strcwlen(cText,0x40);
		cText[iLen] = 0;
		iLine++;

		if(iLine>200)break;

		iPos  = strfromcsv(cText,cTemp,sizeof(cTemp));
		strawcpy(cName,cTemp,256);
		hItem = m_cList.InsertItem(cName,hNext,TVI_BEFORE);
			    m_cList.SetItemCheckBox(hItem,1,3);

		for(iCol=1;iCol<3;iCol++)
			{
			iPos += strfromcsv(cText+iPos,cTemp,sizeof(cTemp));
			strawcpy(cName,cTemp,256);
			m_cList.SetItemText(hItem,cName,iCol);
			}
		}

	fclose(pFile);

}

//*****************************************************************************
//*
//*		OnExport
//*
//*****************************************************************************
void CWayPointDlg::OnExport()
{
char		cText[256];
char		cTemp[256];
FILE	   *pFile;
HTREEITEM	hItem;
HTREEITEM	hNext;
LPCTSTR		pText;
CString		sName;
CString		sText;
int			iChar;
int			iRet;
int			iPos;


	CFileDialog	sFile(FALSE,_T("*.csv"),sName,OFN_EXPLORER|OFN_ENABLESIZING|OFN_PATHMUSTEXIST|OFN_HIDEREADONLY,_T("CSV-Dateien (*.csv)|*.csv|Textdateien (*.txt)|*.txt|Alle Dateien|*.*|"));


	   sFile.m_ofn.lpstrTitle=_T("Wegpunkte exportieren");
	if(sFile.DoModal()!=IDOK)return;

	sName =	sFile.GetPathName();

	if(ExistFile(sName)==1)
		{
		sText.Format(_T("Die Datei '%s' existiert bereits, soll sie berschrieben werden ?"),(LPCTSTR)sName);
		iRet = MessageBox(sText,_T("Frage"),MB_YESNO|MB_ICONQUESTION|MB_DEFBUTTON2);
		if(iRet!=IDYES)return;
		}
	
		pFile = _tfopen(sName,_T("wb"));
	if(!pFile)
		{
		sText.Format(_T("Die Datei '%s' konnte nicht erstellt werden ?"),(LPCTSTR)sName);
		MessageBox(sText,_T("Fehler"),MB_YESNO|MB_ICONERROR|MB_DEFBUTTON2);
		return;
		}

	iChar	= (GetFileType(sName,_T("txt")))? '\t':';';

	hItem	= m_cList.GetFirstItem();

	while(hItem)
		{
			hNext = m_cList.GetNextSiblingItem(hItem);	
		if(!hNext)break;

		for(iPos=0;iPos<3;iPos++)
			{
			pText = m_cList.GetItemText(hItem,iPos);
			strawcpy(cText,pText,sizeof(cText));
			strtocsv(cText,cTemp,sizeof(cTemp));
			fprintf(pFile,"%s%c",cText,iChar);
			}
		
		fprintf(pFile,"\n");
		hItem = hNext;
		}

	
	fclose(pFile);

	

}

//*****************************************************************************
//*
//*		OnDelete
//*
//*****************************************************************************
void CWayPointDlg::OnDelete()
{
HTREEITEM		hItem;

	
		hItem = m_cList.GetFocusItem();	
	if(!hItem || !m_cList.GetNextSiblingItem(hItem))return;

	m_cList.DeleteItem(hItem);

}

